-- 公共語言包

LANGUAGE_TIPS_LOCALERROR = "本地檔錯誤"
LANGUAGE_TIPS_PROGRESS = "下載進度"
LANGUAGE_TIPS_DOWNLOADERRO = "下載過程失敗"
LANGUAGE_TIPS_GETTINGERROR = "解析設定檔失敗"
LANGUAGE_TIPS_UNPACKING = "正在解壓安裝，請勿退出遊戲"
LANGUAGE_TIPS_UPDATEOK = "更新完成!"
LANGUAGE_TIPS_UPDATEERROR = "更新失敗!"
LANGUAGE_TIPS_WEBERROR = "網路請求失敗"
LANGUAGE_OTHER_TXTPACKAGESIZE = "補丁包大小："

LANGUAGE_TIPS_BATTLE_SKIP = APP_REVIEW and "主角12級或至尊2開啟跳過戰鬥功能" or "主角12級或VIP2開啟跳過戰鬥功能"
LANGUAGE_TIPS_BATTLE_SPEED_2 = "主角" .. BATTLE_SPEED_2_FLAG_LEVEL .. "級開啟加速戰鬥功能"
LANGUAGE_TIPS_BATTLE_SPEED_3 = "主角" .. BATTLE_SPEED_3_FLAG_LEVEL .. "級開啟3倍加速戰鬥功能"

LANGUAGE_KEY_PASSTOWER_CONDITION = 
{        
    [1] = "我方總血量不低於",
    [2] = "主角不能死亡",
    [3] = "回合數不超過",
    [4] = "陣亡人數不超過",
    [5] = "敵方全滅",

}

function LANGUAGE_GETERRORTIP( errMsg )
    local _errMsg = "伺服器異常，請重試"
    if type(errMsg) == "string" then
        _errMsg = errMsg
    end
    return _errMsg
end
function LANGUAGE_GET_CONDITION_BY_ID(_id, _needHead)
    local condition = (LANGUAGE_KEY_PASSTOWER_CONDITION[tonumber(_id)] or LANGUAGE_KEY_PASSTOWER_CONDITION[1])
    if _needHead then
        condition = "戰鬥勝利且"..condition
    end
    return condition
end

function LANGUAGE_KEY_BATTLE_ROUND_TXT(roundNow, roundAll)
    return "第"..tostring(roundNow).."/"..tostring(roundAll).."回合"
end

function LANGUAGE_KEY_BATTLE_WAVE_TXT(waveNow, waveAll)
    return "第"..tostring(waveNow).."/"..tostring(waveAll).."波"
end

function LANGUAGE_getReousrceNameById(_id)
    local _id = tonumber(_id) or 1
    local resourceName = {
        [1] = "元寶",
        [2] = "銀幣",
        [3] = "聲望",
        [4] = "藍寶石",
        [5] = "黃寶石",
        [6] = "紫寶石",
        [7] = "體力",
        [8] = "稅金",
        [9] = "木材",
        [10] = "礦石",
        [11] = "武魂",
        [12] = "名將冊體力",
        [13] = "將領技能點",
        [14] = "戰功",
        [15] = "榮譽",
        [16] = "兌換",
        [17] = "糧食",
        [18] = "",
        [19] = "主線星數",
        [20] = "特訓積分",
        [21] = "突破石",
        [22] = "挑戰令",
        [23] = "武神榜積分",
        [24] = "燈靈",
    }
    local _text = resourceName[_id] or resourceName[1]
    return _text
end

function LANGUAGE_getGemAttrByType(_id)
    local __type = tonumber(_id) or 0
    local _config = {
        [4]  = "生命",
        [8]  = "物防",
        [12] = "策防",
        [30] = "攻擊",
    }
    return _config[__type] or ""
end

function LANGUAGE_getReousrceDescById(_id) --資源的描述，暫時沒有先用名字代替
    local _id = tonumber(_id) or 0
    local resourceDesc = { 
        [1] = "金燦燦的元寶，代表著財富的象徵",
        [2] = "世界流通的基礎貨幣。",
        [3] = "用於聲望商店兌換道具的重要物資。",
        [4] = "發亮的寶石，用於購買突飛卡以及將領。",
        [5] = "發亮的寶石，用於購買突飛卡以及將領。",
        [6] = "發亮的寶石，用於購買突飛卡以及將領。",
        [7] = "體力代表著行動力的多少。",
        [8] = "在國家商店中進行兌換的重要物資。",
        [9] = "主城建造消耗的重要物資。",
        [10] = "主城建造消耗的重要物資。",
        [11] = "群雄兌換將領卡的重要物資。",
        [12] = "用於挑戰群雄的門票。",
        [13] = "用於升級將領技能等級的物資。",
        [14] = "用於軍功商店購買道具的物資。",
        [15] = "無。",
        [16] = "無。",
        [17] = "無。",
        [18] = "武神試煉中換取特殊效果的資源。",
        [19] = "用於啟動或升級命格的重要物資。",
        [20] = "用於解鎖極限挑戰副本的重要物資。",
        [21] = "用於將領突破的重要物資。",
        [22] = "用於挑戰兵器庫副本的重要物資",
        [23] = "用於酒館五虎上將卡包招募將領的重要物資",
        [24] = "用於燈魂商店兌換燈魂的重要物資",
    }
    local _text = resourceDesc[_id] or resourceDesc[1]
    return _text
end

--悍將屬性定義名稱 id與順序一一對應， _isBase表示作用層級是不是自身
function LANGUAGE_getAttributeTextById(_id, _isBase)
    local _id = tonumber(_id) or 1
    local _isBase = _isBase
    local attributeText = { 
        [1] = "武力",--1.  武力(整數)
        [2] = "智力",--2.  智力(整數)
        [3] = "體力",--3.  體力(整數)
        [4] = "生命",-- 4.  生命值上限(整數)
        [5] = "生命",-- 5.  生命值上限加成(百分比)
        [6] = "物攻",-- 6.  物理攻擊力(整數)
        [7] = "物攻",-- 7.  物理攻擊力加成(百分比)
        [8] = "物防",-- 8.  物理防禦力(整數)
        [9] = "物防",-- 9.  物理防禦力加成(百分比)
        [10] = "策攻",-- 10. 策略攻擊力(整數)
        [11] = "策攻",-- 11.  策略攻擊力加成(百分比)
        [12] = "策防",-- 12.  策略防禦力(整數)
        [13] = "策防",-- 13.  策略防禦力加成(百分比)
        [14] = "命中",-- 14.  命中率(百分比)
        [15] = "閃避",-- 15.  閃避率(百分比)
        [16] = "精准",-- 16.  精准率(百分比)
        [17] = "識破",-- 17.  識破率(百分比)
        [18] = "暴擊",-- 18.  暴擊率(百分比)
        [19] = "暴傷",-- 19.  暴擊效果值(百分比)
        [20] = "抗暴",-- 20.  抗暴率(百分比)
        [21] = "眩暈",-- 21.  眩暈率(百分比)
        [22] = "抗暈",-- 22.  抗暈率(百分比)
        [23] = "增傷",-- 23.  傷害加成(百分比)
        [24] = "減傷",-- 24.  傷害減免(百分比)
        [25] = "技能傷害加成",-- 25.  技能效果加成(百分比)
        [26] = "技能傷害減免",-- 26.  技能效果減免(百分比)
        [27] = "初始士氣",-- 27.  初始士氣值(整數)
        [28] = "抗清氣率",-- 28.  減士氣抵抗(百分比)
        [29] = "反傷",-- 29.  反傷抵抗比率(百分比)
        [30] = "攻擊力",-- 30.  攻擊力(物理攻擊或者策略攻擊, 由類型決定)
        [31] = "防禦力",-- 31. 防禦力（全部防禦包括物防和策防）
        [32] = "攻擊力",--  32. 全部攻擊力（百分比）
        [33] = "防禦力",--  32. 全部防禦力（百分比）
        [34] = "速度",--  34. 速度
        [101] = "國家人數",-- 101.  提升國家人數
        [102] = "掠奪次數上限",-- 102.  提升掠奪次數上限
        [103] = "佔領次數上限",-- 103.  提升佔領次數上限
        [104] = "倉庫容量",-- 104.  倉庫容量
        [105] = "國家商品數量",-- 105.  國家商品數量
        [106] = "國戰獲取速度",-- 106.  國戰獲取速度
        [107] = "主城建築cd",-- 107.  主城建築cd減少（百分比）
        [108] = "額外幫助減少時間",-- 106.  額外幫助減少時間
    }
    local _text = attributeText[_id] or attributeText[1]
    if _isBase then
        _text = "基礎".._text
    end
    return _text
end

function LANGUAGE_getTargetTextById(_target)
    local _target = tonumber(_target) or 0
    local targetText = {
        [0] = "全隊",
        [1] = "主角",
        [2] = "",
        [3] = "上陣將領",
    }
    return targetText[_target]
end
--獲取熟練度玩法說明
function LANGUAGE_GET_RULE_SHULIANDU( desc, _str1,_str2,_str3)
    local _desc = clone( desc )
    local needFormatStr = _desc[4] or ""
    _desc[4] = string.format(needFormatStr,_str1,_str2,_str3)
    return _desc
end


-- 演武榜
LANGUAGE_ARENA = {
    arena_over = "演武榜賽事結束，週一5:00重新開啟！",
    arena_final = "正在將參賽玩家分配至天地榜，周日上午十點開啟決賽！",
    arena_type_0 = "",
    arena_type_1 = "青龍組",
    arena_type_2 = "朱雀組",
    arena_type_3 = "玄武組",
    arena_type_11 = "天榜",
    arena_type_12 = "地榜",
    rank_mine = "我的排名",
    un_rank = "未上榜",
    score_mine = "我的積分",
    btn_hallFame = "名人榜",
    btn_rank = "排行榜",
    times_left = "剩餘次數",
    times_to_limit = "挑戰次數已達到上限",
    btn_change = "換一批",
    btn_defence = "防守陣容",
    btn_record = "戰報",
    btn_shop = "軍功商店",
    times_not_enough = "剩餘挑戰次數不足",
    challenged_player = "已挑戰過該玩家",
    score = "積分",
    -- 名人榜
    to_current = "至當前屆",
    share = "分享",
    -- 排行榜
    rank = "排名",
    name = "名字",
    reward_preview = "獎勵預覽",
    rule = "規則說明",
    -- 戰報
    share_success = "分享成功",
    -- 查看信息
    get_score_when_win = "戰勝可獲得積分",
    send_email = "發郵件",
    ignore = "遮罩",
    make_friend = "加好友",
    lookup = "查看信息",
    fight = "切磋",
    chat_private = "私聊",
    no_hallFame = "本次演武榜為開服首屆，冠軍未產生",
    defence = "防守",
    attack = "進攻",
    bang_text1 = "青龍組",
    bang_text2 = "朱雀組",
    bang_text3 = "玄武組",
    bang_text11 = "天榜",
    bang_text12 = "地榜",
    un_into = "您未進入",
}

function LANGUAGE_WEEK( day )
    local _day = {
        "一","二","三","四","五","六","日"
    }
    return _day[tonumber(day)] or ""
end
-- 演武榜結束提示
function LANGUAGE_ARENA_OVER( day, time )
    return "演武榜賽事結束，周" .. LANGUAGE_WEEK(day) .. time .. "重新開啟！"
end
-- 演武榜
function LANGUAGE_ARENA_FINAL( day, time )
    return "正在將參賽玩家分配至天地榜，周" .. LANGUAGE_WEEK(day) .. time .. "開啟決賽！"
end

function LANGUAGE_ITEMNODE_USERBOX( num )
    return "使用寶箱後可從以下" .. tostring(num) .. "種獎勵選擇一個獲取"
end

function LANGUAGE_UNLOCK_CHAPTER_TIP( typeName, chapterId, chapterName )
    -- return "通關" .. tostring(typeName) .. "第".. tostring(chapterId) .. "章" .. tostring(chapterName) .. "解鎖"
    return "通關" .. tostring(typeName) .. tostring(chapterName) .. "解鎖"
end

function LANGUAGE_UNLOCK_FUNCTION_TIP( chapterId, tollgateId, level )
    if level then
        return tostring(level) .. "級開啟"
    else
        return "通關" .. chapterId .. "章" .. tollgateId .. "關開啟"
    end
end

function LANGUAGE_BAG_CHOOSE_TIP( num )
    return "從以下[color=ffff0000]" .. tostring(num) .. "種[/color]選擇一個"
end


function LANGUAGE_GET_RULE_SHULIANDU( desc, _str1,_str2,_str3)
    local _desc = clone( desc )
    local needFormatStr = _desc[4] or ""
    _desc[4] = string.format(needFormatStr,_str1,_str2,_str3)
    return _desc
end
--漢字數位(小於100的)
function LANGUAGE_GET_CHINESE_NUM( _time )
    local _time = tonumber(_time) or 0
    local nums = {"一","二","三","四","五","六","七","八","九","十"} --135 "一百三十五"
    local _nums = ""
    local function getWord(_pos)
        return nums[_pos] or ""
    end
    if _time % 10 == 0 then
        local _pos = math.floor(_time/10)
        if _pos == 1 then
            _nums = "十"
        else
            _nums = (getWord(_pos) or "").. "十"
        end
    else
        local _gewei = _time % 10
        local _shiwei = math.floor(_time/10)
        if _shiwei == 0 then
            _nums = getWord(_gewei)
        elseif _shiwei == 1 then
            _nums = "十"..getWord(_gewei)
        else
            _nums = getWord(_shiwei).."十"..getWord(_gewei)
        end
    end
    return _nums
end
--打造购买
function LANGUAGE_DAZAO_BUY(_price)
    return "是否花費".._price.."元寶購買1次打造?"
end

-- 購買挑戰次數提示
function LANGUAGE_ARENA_BUY( _price )
    return "是否花費".._price.."元寶購買1次挑戰次數"
end
-- 總屆數
function LANGUAGE_ARENA_PERIOD( _cur, _total )
    return "總屆數: ".._cur.."/".._total.."屆"
end

function LANGUAGE_RECHARGE_OWNRIGHT( _vip )
    local _str = APP_REVIEW and "擁有至尊" or "擁有VIP"
    return _str.._vip.."所有特權"
end

function LANGUAGE_RECHARGE_BUYGOLD( _price, _gold )
    local _text = "是否花費" .. zc.getGtMoneyFlag() .. _price .. " 購買"
    if _gold then
        _text = _text .. _gold .. "元寶"
    end
    return _text
end

function LANGUAGE_SEIZE_BUYGOLD( price )
    return "是否花費"..price.."元寶購買一次搶佔次數？"
end

function LANGUAGE_BATTLE_RESULT_SHARE( name, key, sType )
    local _text = ""
    if sType == 1 then
        _text ="在與".. name .."的比武中勝利{key=".. key .."}"
    elseif sType == 2 then
        _text = "在與".. name .."的比武中失敗{key=".. key .."}"
    elseif sType ==  3 then
        _text = "擊敗了關卡".. name .."{key=".. key .."}"   
    elseif sType ==  4 then
         _text = "在挑戰關卡".. name .."時失利{key=".. key .."}"
    elseif sType == 5 then
        _text = "在武神榜擊敗了" .. name .. "{key=".. key .."}" 
    elseif sType == 6 then
        _text = "在武神榜中挑戰" .. name .. "失利{key=".. key .."}" 
    end
    return _text
end

function LANGUAGE_SWEEP_COST_TIPS( cost, times )
    return "是否花費" .. tostring(cost) .. "元寶，掃蕩" .. tostring(times) .. "次？"
end

-- 分享戰報資料
function LANGUAGE_ARENA_SHAREDATA( _type, _data )
    local shareData = {}
    if _type == 1 then
        -- 進攻方勝利，玩家失敗
        shareData = {
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "在與",
            },
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "的比武中失敗",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 2 then
        -- 進攻方失敗，玩家勝利
        shareData = {
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "在"..LANGUAGE_ARENA["arena_type_".._data.type].."中戰勝了",
            },
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 3 then
        -- 玩家勝利，防守方失敗，前六天
        shareData = {
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "在"..LANGUAGE_ARENA["arena_type_".._data.type].."中戰勝了",
            },
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 4 then
        -- 玩家勝利，防守方失敗，最後一天
        shareData = {
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "擊敗了",
            },
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "升至"..LANGUAGE_ARENA["arena_type_".._data.type]..( "第".._data.attackerAfterRank or 0 ).."名",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 5 then
        -- 玩家失敗，防守方勝利
        shareData = {
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "在與",
            },
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "的比武中失敗",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 6 then
        -- 進攻方勝利，玩家失敗
        shareData = {
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "在糧草先行中，被",
            },
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "搶奪了糧草",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 7 then
        -- 進攻方失敗，玩家勝利
        shareData = {
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "在糧草先行中，抵禦了",
            },
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "的搶奪",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 8 then
        -- 玩家勝利，防守方失敗
        shareData = {
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "在糧草先行中，成功搶奪了",
            },
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "的糧草",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    elseif _type == 9 then
        -- 玩家失敗，防守方勝利
        shareData = {
            {
                type = 1,
                id = _data.attackerInfo.userId,
                name = _data.attackerInfo.userName,
            },
            {
                type = 2,
                text = "在糧草先行中，未能成功搶奪",
            },
            {
                type = 1,
                id = _data.defenderInfo.userId,
                name = _data.defenderInfo.userName,
            },
            {
                type = 2,
                text = "的糧草",
            },
            {
                type = 3,
                key = _data.warKey,
            },
        }
    end
    return shareData
end

-- 商店
LANGUAGE_SHOP = {
    shop = "商店",
    shop_arena = "軍功商店",
    shop_expCard = "突飛卡",
    buy_space = "購 買",
    discount = "折扣",
    own = "擁有",
    total_refresh_times = "今日總刷新次數",
    no_refresh_times = "今日刷新次數用完",
    no_free_refresh_times = "免費刷新次數用完",
    free_refresh = "免費刷新",
    refresh_space = "刷 新",
    refresh = "刷新",
    buy = "購買",
    bought = "已購買",
    shop_gem = "勾玉",
    shop_time = "限時商城",
    goods_shop = "道具商城",
    shengwang = "聲望",
}

-- 儲值，特權
LANGUAGE_RECHARGE = {
    current_level = "當前等級",
    vip_level_max = APP_REVIEW and "已達最高至尊等級" or "已達最高VIP等級",
    recharge_more = "再儲值",
    can_up_to = "可升級到",
    recharge_space = "儲 值",
    right_space = "特 權",
    recharge_success_tx = "恭喜您，購買成功！您本次花費%s元，獲得%s元寶，您當前的帳戶餘額為%s元。(元寶到賬時間可能會有短暫延遲，請您耐心等待。)",
    recharge_unenough = "餘額不足，還需要儲值%s元，是否立即儲值？",
    recharge_success = "恭喜您，成功儲值%s元，元寶到賬時間可能會有短暫延遲，請您耐心等待",     
    recharge_success2 = "恭喜您，獲得%s元寶，您當前的帳戶餘額為%s元。元寶到賬時間可能會有短暫延遲，請您耐心等待。",  
    recharge_fail = "扣款失敗，請稍後再試",
    order_fail = "請求訂單失敗",
    recharge_fail2 = "儲值失敗，請重試",
    tip_5 = "解鎖第二把神兵，開啟主角變身功能",
    tip_6 = "可在特權禮包中購買A級將領寶箱",
}

LANGUAGE_RECIEVEENERGY_TIPS = {
    tip_group1 = {
        "美食還沒做好,",
        "過會再來吧",
        "",
    },
    tip_1 = {"正在準備豐盛的午餐", "正在準備豐盛的晚餐", "正在準備豐盛的宵夜"},
    tip_group2 = {  "美食已經做好,",
        "趕緊過來吃吧",
        "",
    },
    tip_2 = {"每份午餐可以獲得       60", "每份晚餐可以獲得       60", "每份宵夜可以獲得       60"},
    tip_group3 = {
        "本次免費領取時",
        "段已過,%s點-%s點",
        "可再次領取哦",
    },
    tip_3 = "花費       %s可補領       60",
    tip_4 = "錯過免費供應時間，請消耗元寶購買"
}



LANGUAGE_GAME_START_INFO = {
    name = "序章",
    desc = "西元184年，奸臣當道，戰亂不斷。而此時天降玄鐵，傳聞，以玄鐵鑄就神兵，可橫掃千軍，終結這漢末亂世，故事就由此拉開了帷幕……",
}

LANGUAGE_GAME_EIGHT_WORDS = {
    title = "健康遊戲忠告",
    desc = "抵制不良遊戲，拒絕盜版遊戲。注意自我保護，謹防受騙上當。\n適度遊戲益腦，沉迷遊戲傷身。合理安排時間，享受健康生活。",
}

LANGUAGE_UPDATE_INFO = {
    tip1 = "需要有",
    tip2 = "的更新內容，請在網路",
    tip3 = "條件好的情況下進行更新哦~",
    tip4 = "全新資源更新中",
    tip5 = "前往下載",
    tip6 = "立即更新",
}

-- 將領介面
LANGUAGE_ROLE = {
    -- 培養
    not_enough = "不足",
    keep = "保留",
    culture = "培養",
    attribute_level_max = "屬性已達到當前等級最大值",
    -- 羈絆
    no_fetter = "該將領沒有羈絆",
    in_battle_team = "已上陣",
    free_space = "解 除",
    fetter_space = "羈 絆",
    fetter = "羈絆",
    no_hero = "尚未擁有",
    fetter_to_other = "已羈絆到其他將領",
    fetter_effect = "羈絆效果",
    attribute_total_addition = "屬性總加成",
    choose_fetter_object = "選擇羈絆物件",
    -- 升星
    consume = "需要材料",
    activate_space = "裝 備",
    one_key_activate = "一鍵裝備",
    no_equip = "當前沒有可以鑲嵌的裝備",
    starup = "升星",
    activate_all_to_starup = "全部裝備才可升星",
    consume_not_enough = "升星石不足",
    unlock = "解鎖",
    lock = "鎖定",
    have_locked = "已鎖定",
    not_locked = "未鎖定",
}

-- 名將副本
LANGUAGE_TOLLGATEHERO = {
    challenge_times_today = "今日可挑戰",
    chance_drop = "概率掉落",
    win_drop = "勝利獲得",
    general_exp = "將領經驗",
    mainrole_exp = "主角經驗",
    copy_consume = "副本消耗",
    consume = "消耗",
    challenge_once_one_day = "每日只可挑戰一次",
    no_challenge_times = "挑戰次數不足",
    not_open = "未開啟",
    fetch_reward = "領取獎勵",
    fetched = "已領取",
    can_not_fetch = "不可領取",
    can_fetch = "可領取",
    first_drop = "首殺掉落",
    common_drop = "概率掉落",
}

function LANGUAGE_condition_uimatrix( stype )
    local _stype = tonumber(stype)
    local _text = ""
    if _stype == 1 then
        _text = "擊殺全部敵方"
    elseif _stype == 2 then
        _text = "回合內上陣角色還有存活"
    elseif _stype == 3 then
        _text = "回合內擊殺全部敵方"
    elseif _stype == 4 then
        _text = "擊殺全部敵方"
    end
    return _text
end


function LANGUAGE_KEY_GETQUNXIONGNAME_BY_ID(_id)
    local qunxiongName = {
        [1] = "同符合契",
        [2] = "勢如破竹",
        [3] = "三國無雙",
        [4] = "名將冊4",
        [5] = "名將冊5",
        [6] = "名將冊6",
    }
    return qunxiongName[tonumber(_id)] or ""
end

function LANGUAGE_getCountryLogByType( type )
    local _type = tonumber(type) or 1
    local _countryLog = {
        [1] = "%s將國家科技%s升級為%s級！",
        [2] = "%s加入了國家，大家歡迎！",
        [3] = "%s退出了國家.",
        [4] = "%s通過藏寶圖獲得了%s！",
        [5] = "%s在藏寶圖中被國家%s的%s驅逐，慘遭損失！",
        [6] = "國家%s對%s戰場發起掠奪，%s分鐘後開始戰鬥，大家準備迎敵！",
        [7] = "國家%s對%s戰場發起攻佔，%s分鐘後開始戰鬥，大家準備迎敵！",
        [8] = "國家%s在%s戰場的戰爭中被我方擊敗",
        [9] = "%s戰場遭到國家%s掠奪，損失%s的%s。",
        [10] = "%s戰場遭到國家%s掠奪，物資受國家倉庫保護，沒有損失。",
        [11] = "國家%s攻佔了我方%s戰場！重整旗鼓，奪回失地！",
    } 
    local _log = _countryLog[tonumber(_type)] or _countryLog[1]
    return _log
end

function LANGUAGE_getHouseNameById( _id )
    local str = ""
    _id = tonumber(_id)
    if _id == 1 then 
        str = "主城"
    elseif _id == 2 then
        str = "城牆"
    elseif _id == 3 then
        str = "碼頭"
    elseif _id == 4 then
        str = "重生塔"
    elseif _id == 5 then
        str = "農田"
    elseif _id == 6 then
        str = "木場"
    elseif _id == 7 then
        str = "礦場"
    elseif _id == 8 then
        str = "校場"
    elseif _id == 9 then
        str = "酒館"
    elseif _id == 10 then
        str = "燈市"
    elseif _id == 11 then
        str = "鐵匠鋪"
    elseif _id == 12 then
        -- str = "倉庫"
        str = "商店"
    elseif _id == 13 then
        str = "演武榜"
    elseif _id == 14 then
        str = "研究院"
    elseif _id == 15 then
        str = "挑戰"
    elseif _id == 16 then
        str = "市政"
    end
    return str
end

function LANGUAGE_getTipColorNameByType( type )
    local _str = "普通"
    local _type = tonumber(type)
    if _type == 1 then   --白
        _str = "普通"
    elseif _type == 2 then --綠
        _str = "精良"
    elseif _type == 3 then --藍
        _str = "稀有"
    elseif _type == 4 then --紫
        _str = "史詩"
    elseif _type == 5 then --金
        _str = "特殊"
    elseif _type == 6 then --紅
        _str = "傳說"
    end
    return _str
end

-- 根據裝備進階等級獲取名稱
function LANGUAGE_get_advance_color_text( advance )
    local _advance = tonumber( advance ) or 0
    local _config = {
        "綠色", "藍色", "藍色+1", "紫色", "紫色+1", "紫色+2", "金色", "金色+1", "金色+2","紅色","紅色+1","紅色+2","黑色","黑色+1",
    }
    return _config[_advance] or ""
end

function LANGUAGE_get_color_text( qualifications )
    local _qualifications = tonumber( qualifications ) or 0
    local _config = {
        "白色", "綠色", "藍色", "藍色+1", "紫色", "紫色+1", "紫色+2", "金色", "金色+1", "金色+2","紅色","紅色+1","紅色+2","黑色","黑色+1",
    }
    return _config[_advance] or ""
end

function LANGUAGE_get_server_status_name( status )
    local _state = tonumber( status ) or 0
    local stateText = ""
    local stateColor = display.COLOR_RED
    if _state == 0 then
        -- 運行中
        stateText = "火爆"
        stateColor = display.COLOR_RED
    elseif _state == 1 then
        -- 維護中
        stateText = "維護中"
        stateColor = display.COLOR_GRAY
    elseif _state == 2 then
        -- 待開服
        stateText = "即將開啟"
        stateColor = cc.c3b(248, 238, 0)
    elseif _state == 3 then
        -- 已關服
        stateText = "停服"
        stateColor = display.COLOR_GRAY
    elseif _state == 10 then
        -- 新服
        stateText = "新服"
        stateColor = display.COLOR_GREEN
    end
    return stateText, stateColor
end

function LANGUAGE_get_weapon_type_name()
    return {"長柄", "鈍器", "法杖", " 劍", "扇子", "法球"}
end

function LANGUAGE_get_bag_tabs()
    return {"全 部", "兵 器", "兵器碎片","消耗品", "材 料", "勾 玉"}
end

function LANGUAGE_get_weapon_random_effect_name( color )
    local _color = tonumber(color)
    local _text = "白色品質隨機屬性"
    if _color == 2 then
        _text = "綠色品質隨機屬性"
    elseif _color == 3 then
        _text = "藍色品質隨機屬性"
    elseif _color == 4 then
        _text = "紫色品質隨機屬性"
    elseif _color == 5 then
        _text = "金色品質隨機屬性"
    elseif _color == 6 then
        _text = "紅色品質隨機屬性"
    elseif _color == 7 then
        _text = "隨機品質隨機屬性"
    end
    return _text
end

function LANGUAGE_get_buff_show_text( id )
    local ret = nil
    if id == 1 then
        ret = "眩暈"
    elseif id == 2 then
        ret = "中毒"
    elseif id == 21 then
        ret = "流血"
    elseif id == 35 then
        ret = "魅惑"
    elseif id == 3 then--[[傷害增加]]
        ret = "傷害加深"
    elseif id == 4 then
        ret = "傷害減免"
    elseif id == 5 then--[[提升精准率]]
        ret = "精准"
    elseif id == 6 then--[[-降低精准率]]
        ret = "精准"
    elseif id == 7 then--[[提升命中]]
        ret = "命中"
    elseif id == 8 then--[[降低命中]]
        ret = "命中"
    elseif id == 9 then--提升暴擊抗性
        ret = "抗暴"
    elseif id == 10 then--降低物理攻擊力
        ret = "物理攻擊"
    elseif id == 11 then--降低策略攻擊力
        ret = "策略攻擊"
    elseif id == 12 then--提升物理攻擊力
        ret = "物理攻擊"
    elseif id == 13 then--提升策略攻擊力
        ret = "策略攻擊"
    elseif id == 14 then--降低物理攻擊力加成
        ret = "物理攻擊"
    elseif id == 15 then--降低策略攻擊力加成
        ret = "策略攻擊"
    elseif id == 16 then--提升物理攻擊力加成
        ret = "物理攻擊"
    elseif id == 17 then--提升策略攻擊力加成
        ret = "策略攻擊"
    elseif id == 18 then--提升暴擊
        ret = "暴擊"
    elseif id == 19 then--降低暴擊
        ret = "暴擊"
    elseif id == 20 then
        ret = "暴擊流血"
    elseif id == 21 then
        ret = "流血"
    elseif id == 22 then
        ret = "提升暴擊"
    elseif id == 23 then
        ret = "護盾"
    elseif id == 24 then--[[降低物理防禦力]]
        ret = "物理防禦"
    elseif id == 25 then--降低策略防禦力
        ret = "策略防禦"
    elseif id == 26 then--提升物理防禦力
        ret = "物理防禦"
    elseif id == 27 then--提升策略防禦力
        ret = "策略防禦"
    elseif id == 28 then--降低物理防禦力加成
        ret = "物理防禦"
    elseif id == 29 then--降低策略防禦力加成
        ret = "策略防禦"
    elseif id == 30 then--提升物理防禦力加成
        ret = "物理防禦"
    elseif id == 31 then--提升策略防禦力加成
        ret = "策略防禦"
    elseif id == 34 then
        ret = "降低輸出"
    elseif id == 38 then
        ret = "傷害輸出"
    elseif id == 39 then
        ret = "命中"
    elseif id == 40 then
        ret = "精准"
    elseif id == 41 then
        ret = "物理防禦"
    elseif id == 42 then
        ret = "策略防禦"
    elseif id == 45 then
        ret = "閃避"
    elseif id == 46 then
        ret = "識破"
    elseif id == 47 then
        ret = "沈默"
     elseif id == 48 then --攻击上升
        ret = "攻擊"
    elseif id == 49 then --攻击下降
        ret = "攻擊"
    elseif id == 50 then -- 降低暴击抗性
        ret = "抗暴"
    elseif id == 51 then -- 增加速度属性
        ret = "速度"
    elseif id == 52 then -- 降低速度属性
        ret = "速度"
    elseif id == 53 then -- 提升暴击伤害属性
        ret = "暴擊傷害"
    elseif id == 54 then -- 降低暴击伤害属性
        ret = "暴擊傷害"
    elseif id == 55 then -- 必定识破X次谋士攻击
        ret = "識破"
    elseif id == 100 then--[[士氣上升]]
        ret = "士氣"
    elseif id == 101 then--[[士氣下降]]
        ret = "士氣"
    elseif id == 102 then--[[識破]]
        ret = "識破"
    elseif id == 103 then--[[閃避]]
        ret = "閃避"
    elseif id == 104 then--[[連擊]]
        ret = "連擊"
    end
    return ret
end

function LANGUAGE_line_choose_tips()
    return {
        "可獲得兵器洗練的重要材料",
        "可獲得裝備進階的重要材料",
        "可獲得將領升星的重要材料",
    }
end

function LANGUAGE_heti_skill_tip( name, desc )
    return "【與[color=ff5ba6d4]" .. tostring(name) .."[/color]同時上陣可觸發】" .. desc
end

function LANGUAGE_heti_skill_unrich_tip( name, desc )
    return "與" .. tostring(name) .."同時上陣可觸發" .. desc
end

function LANGUAGE_get_levy_tip()
    return "[size=18][color=ffdeb05d]每日[/size][/color][size=18][color=ffff0000]上午7:00[/size][/color][size=18][color=ffdeb05d]恢復12次免費徵收次數[/size][/color]"
end

function LANGUAGE_get_country_tech_types()
    return {[1] = "低級科技",[2] = "中級科技",[3] = "高級科技"}, {[1] = "",[2] = "：全部低級科技達到滿級解鎖",[3]="：全部中級科技達到滿級解鎖"}
end

function LANGUAGE_get_country_join_condition()
    return  {
        [1] = "允許任何人",
        [2] = "需要批准",
        [3] = "不允許任何人",
    }
end

function LANGUAGE_get_qunxiong_tabs()
    return {[1]="總覽",[2]="圖鑒",[3]="兌換"}
end

function LANGUAGE_get_country_main_tabs()
    return {[1]="國家總覽",[2]="國家人員",[3]="國家排名",[4]="國家幫助",[5]="國家日誌",[6]="國家設置"}
end

function LANGUAGE_get_dart_open_time( _time1, _time2 )
    return "[color=ffe6e0a3]中午[/color][color=ffff3644]".. _time1 .."[/color][color=ffe6e0a3]，晚上[/color][color=ffff3644]".. _time2 .."[/color][color=ffe6e0a3]開放[/color]"
end

function LANGUAGE_get_multicopy_open_time( _time1, _time2 )
    return "[color=ffe6e0a3]中午[/color][color=ffff3644]".._time1.."[/color][color=ffe6e0a3]，晚上[/color][color=ffff3644]".._time2.."[/color][color=ffe6e0a3]開放[/color]"
end

function LANGUAGE_dart_get_times_tip( leftTimes, maxTimes )
    return "[color=ffdeb05d]剩餘次數[/color][color=ff00ff66]"..leftTimes.."/"..maxTimes.."[/color]  [color=ffdeb05d]領取後限[/color][color=ffff3644]30[/color][color=ffdeb05d]分鐘內完成[/color]" 
end

function LANGUAGE_grabmine_get_chat_tips()
    return {
        "準備好，速度開！",
        "速買次數",
        "我強我先手",
        "難度較大，人滿開車",
    }
end

function LANGUAGE_culture_tips()
    return {
        [1] = "普通培養",
        [2] = "超級培養",
        [3] = "極限培養",
        [4] = "至尊培養",
    }
end

function LANGUAGE_talent_showinfo()
    return {
        [0] = "[color=ff746548]對[/color][color=ffff0000]全體英雄[/color][color=ff746548]進行加成[/color]",
        [1] = "[color=ff746548]對[/color][color=ffff0000]主角[/color][color=ff746548]進行加成[/color]",
        [2] = "[color=ffff0000]主角[/color][color=ff746548]將獲得全新天賦[/color]",
    }
end

function LANGUAGE_task_tabs()
    return {"主線", "日常", "成就"}
end

function LANGUAGE_wushen_resoult_baoji_type()
    return {[1]="暴擊",[2]="大暴擊",[3]="幸運暴擊"}
end

function LANGUAGE_get_rank_list_basedatas()
    return {
        {
            [1]={name="戰力榜",moreRank=true,rankTabNum=2},
            [2]={name="武神榜",moreRank=false,rankTabNum=0},
            [3]={name="演武榜",moreRank=true,rankTabNum=5}, --特殊處理
            [4]={name="國家榜",moreRank=true,rankTabNum=1},
            [5]={name="群雄逐鹿",moreRank=true,rankTabNum=3},    
            [6]={name="糧草榜",moreRank=false,rankTabNum=0},
            [7]={name="搶奪榜",moreRank=false,rankTabNum=0},      
            
        },
        {
            [1]={
                [1]={name="隊伍",infoTag=2},
                [2]={name="主角",infoTag=1},
            },        
            [2]={
                [1]={name="武神榜",infoTag=19},
            },
            [3]={
                [1]={name="青龍組",infoTag=3},
                [2]={name="朱雀組",infoTag=4},
                [3]={name="玄武組",infoTag=5},
                [4]={name="天榜",infoTag=6},
                [5]={name="地榜",infoTag=7},
            },
            [4]={
                [1]={name="全員戰力",infoTag=8},
            },
            [5]={
                [1]={name="黃巾軍",infoTag=16},
                [2]={name="西涼軍",infoTag=17},
                [3]={name="蜀軍",infoTag=18},
            },
            [6]={
                [1]={name="糧草榜",infoTag=20},
            },
            [7]={
                [1]={name="搶奪榜",infoTag=21},
            },
        },
        {
            [1] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="主角戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [2] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="小隊戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [3] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [4] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [5] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [6] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [7] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [8] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="國家",pos=cc.p(223, 438)},
                [3] = {name="君主",pos=cc.p(365+56, 438)},
                [4] = {name="全員戰力",pos=cc.p(485+120, 438)},
                [5] = {name="",pos=cc.p(617, 438)},
            },
            [9] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [10] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [11] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [12] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [13] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [14] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [15] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [16] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="個人最高傷害",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [17] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="個人最高傷害",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [18] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="個人最高傷害",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [19] = {
                [1] = {name="排名",pos=cc.p(76,438)},
                [2] = {name="名字",pos=cc.p(223, 438)},
                [3] = {name="職業",pos=cc.p(365, 438)},
                [4] = {name="將領總戰力",pos=cc.p(485, 438)},
                [5] = {name="獲得稱號",pos=cc.p(617, 438)},
            },
            [20] = {
                [1] = {name="排名",pos=cc.p(76,436)},
                [2] = {name="名字",pos=cc.p(223, 436)},
                [3] = {name="糧草數量",pos=cc.p(380, 436)},
                [4] = {name="排名獎勵",pos=cc.p(500, 436)},
                [5] = {name="",pos=cc.p(617, 436)},
            },
            [21] = {
                [1] = {name="排名",pos=cc.p(76,436)},
                [2] = {name="名字",pos=cc.p(223, 436)},
                [3] = {name="搶奪數量",pos=cc.p(380, 436)},
                [4] = {name="排名獎勵",pos=cc.p(500, 436)},
                [5] = {name="",pos=cc.p(617, 436)},
            },
        }
    }
    -- 1    排名 名字 職業 主角戰力 獲得稱號
    -- 2    排名 名字 職業 小隊戰力 獲得稱號
    -- 3    排名 名字 職業 將領總戰力 獲得稱號
    -- 4    排名 名字 職業 將領總戰力 獲得稱號
    -- 5    排名 名字 職業 將領總戰力 獲得稱號
    -- 6    排名 名字 職業 將領總戰力 獲得稱號
    -- 7    排名 名字 職業 將領總戰力 獲得稱號
    -- 8    排名 名字 職業 將領總戰力 獲得稱號
    -- 9    排名 名字 職業 關卡數 獲得稱號
    -- 10   排名 名字 職業 將領總戰力 獲得稱號
    -- 11   排名 名字 職業 將領總戰力 獲得稱號
    -- 12   排名 名字 職業 將領總戰力 獲得稱號
    -- 13   排名 名字 職業 將領總戰力 獲得稱號
    -- 14   排名 名字 職業 將領總戰力 獲得稱號
    -- 15   排名 名字 職業 將領總戰力 獲得稱號
    -- 16   排名 名字 職業 個人最高傷害 獲得稱號
    -- 17   排名 名字 職業 個人最高傷害 獲得稱號
    -- 18   排名 名字 職業 個人最高傷害 獲得稱號
    -- 19   排名 名字 職業 將領總戰力 獲得稱號
end

function LANGUAGE_get_randomNames()
    return {
        {
            "司馬","歐陽","端木","上官","獨孤","夏侯","尉遲","赫連","皇甫","公孫","慕容","長孫","宇文",
            "司徒","軒轅","百里","呼延","令狐","諸葛","南宮","東方","西門","李","王","張","劉","陳","楊","趙","黃","周","胡",
            "林","梁","宋","鄭","唐","馮","董","程","曹","袁","許","沈","曾","彭","呂","蔣","蔡","魏","葉","杜","夏","汪",
            "田","方","石","熊","白","秦","江","孟","龍","萬","段","雷","武","喬","洪","魯","葛","柳","岳","梅","辛","耿",
            "關","苗","童","項","裴","鮑","霍","甘","景","包","柯","阮","華","滕","穆","燕","敖","冷","卓","花","藍","楚",
            "荊","思","冰","夜","癡","依","小","香","綠","向","映","含","曼","春","醉","之","新","雨","天","如","若","涵",
            "亦","采","安","芷","綺","雅","飛","又","寒","憶","曉","樂","笑","妙","元","碧","翠","初","懷","幻","慕","秋",
            "語","覓","幼","靈","傲","冷","沛","念","尋","水","紫","易","惜","詩","青","雁","盼","爾","以","雪","夏","凝",
            "丹","迎","問","宛","夢","憐","聽","巧","凡","靜"
        },
        {
            "之","夢","慕","爾","初","沛","傲","曼","樂","惜","香","新","語",
            "海","夜","涵","水","醉","語","從","傲","語","又","碧","元","憐","紫","妙","曼",
            "南","紫","雨","易","如","若","尋","曉","向","慕","以","映","雪","海","凝","沛",
            "寒","冰","宛","綠","曉","碧","夏","曼","若","半","雅","冰","靈","平","書","翠",
            "代","夢","幼","聽","夢","醉","訪","亦","淩","訪","懷","笑","靖","夜","冰","夢",
            "書","樂","念","靖","從","覓","靜","凡","以","念","芷","千","新","代","新","雁",
            "冷","紫","千","傲","盼","懷","冰","山","翠","問","白","問","如","半","丹","冰",
            "亦","之","冰","爾","谷","樂","涵","海","傲","青","易","惜","宛","之","夏","亦",
            "妙","紫","幻","元","冰","訪","芷","凡","凡","安","天","含","書","雅","書","從",
            "夏","念","代","幻","穀","秋","白","海","代","含","書","聽","靈","雪","樂","含",
            "涵","平","雅","傲","靈","含","從","從","初","聽","語","夏","淩","憶","幻","憐",
            "紫","依","妙","訪","憐","映","友","冰","惜","淩","芷","雁","迎","元","代","紫",

            "千青","淩寒","紫安","寒安","懷蕊","秋荷","涵雁","以山","凡梅","盼曼","翠彤","谷冬","冷安","千萍","冰煙","雅陽",
            "友綠","南松","詩雲","飛風","寄靈","書芹","幼蓉","以藍","笑寒","憶寒","秋煙","芷巧","水香","映之","醉波","幻蓮",
            "夜山","芷卉","向彤","小玉","幼南","凡夢","爾曼","念波","迎松","青寒","笑天","涵蕾","碧菡","映秋","盼煙","憶山",
            "以寒","寒香","小凡","代亦","夢露","映波","友蕊","寄凡","憐蕾","雁楓","水綠","曼荷","笑珊","寒珊","谷南","慕兒",
            "夏嵐","友兒","小萱","紫青","妙菱","冬寒","曼柔","語蝶","青筠","夜安","覓海","問安","曉槐","雅山","訪雲","翠容",
            "寒凡","曉綠","以菱","冬雲","含玉","訪楓","含卉","夜白","冷安","靈竹","醉薇","元珊","幻波","盼夏","元瑤","迎曼",
            "水雲","訪琴","穀波","笑白","妙海","紫霜","淩旋","孤絲","憐寒","凡松","青絲","翠安","如天","淩雪","綺菱","代雲",
            "香薇","冬靈","淩珍","沛文","紫槐","幻柏","采文","雪旋","盼海","映夢","安雁","映容","凝陽","訪風","天亦","覓風",
            "小霜","雪萍","半雪","山柳","穀雪","靖易","白薇","夢菡","飛綠","如波","又晴","友易","香菱","冬亦","問雁","海冬",
            "秋靈","凝芙","念煙","白山","從靈","爾芙","迎蓉","念寒","翠綠","翠芙","靖兒","妙柏","千凝","小珍","妙旋","思淼",
            "敗","悔","南","寶","仞","刀","斐","德","雲","天","仁","嶽","宵","忌","爵","權","敏","陽","狂","冠","康","平",
            "剛","強","凡","邦","福","歌","國","和","康","瀾","民","寧","然","順","翔","晏","宜","怡","易","志","雄","佑",
            "斌","河","元","墨","松","林","之","翔","竹","宇","軒","榮","哲","風","霜","山","炎","罡","盛","睿","達","洪",
            "武","耀","磊","寒","冰","瀟","痕","嵐","空"
        },
        {
            "桃","琪","青","嵐","夏","菡","珊","文","菱","文","寒","柔","蓉",
            "安","蓉","柏","桃","藍","琴","彤","晴","蘭","菱","彤","霜","夢","寒","彤","易",
            "蓮","翠","寒","煙","萱","南","真","亦","珊","靈","蕊","易","柳","雲","天","珊",
            "雲","旋","兒","真","霜","凡","菡","香","煙","夢","綠","藍","槐","安","翠","風",
            "雲","曼","翠","寒","柏","易","旋","玉","萱","卉","亦","藍","柏","蕾","夏","松",
            "雪","楓","薇","雁","寒","波","曼","旋","亦","露","蕾","蘭","波","真","蕾","玉",
            "卉","山","琴","芙","山","蝶","蘭","柏","萱","旋","易","筠","霜","芹","丹","彤",
            "寒","瑤","露","珍","雪","萱","菡","蓮","蕾","槐","夢","雪","海","柔","夏","瑤",
            "菡","藍","柏","風","楓","蕊","蕊","蕾","柔","蕾","荷","玉","蘭","琴","書","安",
            "槐","芹","曼","珊","絲","翠","晴","露","荷","玉","蕾","白","雁","青","樂","煙",
            "雙","蝶","蕊","之","薇","蕾","夢","蓉","丹","蓉","芙","彤","瑤","翠","幻","菡",
            "南","珊","竹","煙","蕾","寒","綠","萍","霜","香","蕾","卉","夢","柏","萱","真"
        }
    }
end


local langConfig = {
    -- 操作提示
    build                 = "建造",
    copy                  = "副本",
    lineup                = "佈陣",
    bag                   = "背包",
    task                  = "任務",
    logout                = "註銷",
    remove                = "拆除",
    speed_up              = "提速",
    speed_up_left         = "提速還剩",
    enter                 = "進入",
    enter_2               = "進 入",
    friend                = "好友",
    apply_for             = "申請",
    apply_for2            = "申 請",
    have_apply_for        = "已申請",
    black_list            = "黑名單",
    details               = "詳情",
    dismantle             = "拆除",
    gold_speed_up         = "元寶加速",
    prop_speed_up         = "道具加速",
    god_weapon            = "神兵",
    weapon_cast           = "鍛造",
    fightEnter            = "征戰",
    smithy                = "兵器",
    smithy_clear          = "洗練",
    smithy_clear_2        = "洗 練",
    smithy_book           = "兵器譜",
    limitChallenge        = "極限挑戰",
    challenge             = "挑戰",
    challenge_2           = "挑 戰",
    fetterRegionalMap     = "地域羈絆",
    use                   = "使用",
    begin_drill           = "開始訓練",
    reincarnate           = "轉生",
    confirm               = "確定",
    cancel                = "取消",
    sweep                 = "掃蕩",
    sell                  = "出售",
    gather                = "收取",
    sell_2                = "出 售",
    one_key_sell          = "一鍵出售",
    one_key_gather        = "一鍵收取",
    xilian                = "洗煉",
    transfer              = "轉移",
    suit                  = "套裝",
    stop                  = "終止",
    back                  = "返回",
    back_2                = "返 回",
    buy                   = "購買",
    go_recruit            = "招募",
    go_train              = "訓練",
    go_transaction        = "交易",
    go_wharf              = "碼頭",
    send                  = "發送",
    delete                = "刪除",
    reply                 = "回復",
    unblock               = "解除遮罩",
    fight_1               = "切磋",
    house_help            = "幫助",
    multi_copy            = "多人副本",
    weapon_copy           = "兵器副本",
    hero_copy             = "名將傳",
    cailiao_copy          = "武神試練",
    qunxiong_copy         = "群雄",
    qinmidu               = "好友度",
    bingfa                = "兵法",
    bingfa_2              = "兵 法",
    fetch                = "領取",
    equip                = "裝備",
    no_equip             = "無裝備",
    on_line              = "線上",
    off_line              = "離線",
    prompt               = "提示",
    unload               = "卸下",
    see_info             = "查看信息",
    confirm2              = "確 定",
    confirm2_             = "確 認",
    cancel2               = "取 消",
    close2               = "關 閉",
    buy2                  = "購 買",
    recruit_2             = "招 募",
    challenge_2           = "出 戰",
    check_2               = "查 看",
    create_2              = "創 建",
    fetch_2               = "領 取",
    upgrade_2             = "升 級",
    xilian_2              = "洗 煉",
    finish_2              = "完 成",
    transfer_2            = "轉 移",
    already_transfer      = "已轉移",
    revoke_2              = "撤 銷",
    exchange              = "兌 換",
    change_name           = "改名",
    --資源名稱
    gold                 = "元寶",
    money                = "銀幣",
    prestige             = "聲望",
    sapphire             = "藍寶石",
    topaz                = "黃寶石",
    amethyst             = "紫寶石",
    energy               = "體力",
    tax                  = "稅金",
    wood                 = "木材",
    ore                  = "鐵礦",
    heroSoul             = "武魂",
    captainEnergy        = "名將冊體力",
    skillPoint           = "技能點",
    grain                = "糧食",

    -- -- 一級屬性
    wuli                 = "武力",
    wisdom               = "智力",
    tili                 = "體力",

    -- -- 二級屬性
    attack               = "攻擊力",
    physics_attack       = "物攻",
    physics_defense      = "物防",
    strategy_attack      = "策攻",
    strategy_defense     = "策防",
    hp_1                 = "生命",
    hp                   = "生命值",
    defense_force        = "防禦力",

    -- -- 三級屬性
    hit_rate             = "命中率",
    dodge_rate           = "閃避率",
    see_through_rate     = "識破率",
    accurate_rate        = "精准率",
    crit_rate            = "暴擊率",
    crit_hurt            = "暴擊傷害",
    vertigo_rate         = "暈眩率",
    anti_vertigo_rate    = "抗暈率",
    anti_crit_rate       = "抗暴率",
    physics_attack_add    = "物攻加成",
    physics_defense_add   = "物防加成",
    strategy_attack_add   = "策攻加成",
    strategy_defense_add  = "策防加成",
    hp_add                = "生命加成",
    hurt_deep             = "傷害加成",
    hurt_reduction        = "傷害減免",
    skill_hurt_deep       = "技能增傷",
    skill_hurt_reduction  = "技能減傷",
    init_shiqi            = "初始士氣",
    anti_air_rate         = "抗清氣率",
    rebound_hurt_rate     = "反傷率",
    speed                 = "速度",

    -- 時間
    date_seconds         = "秒",
    minute               = "分",
    date_minute          = "分鐘",
    date_hours           = "小時",
    date_day             = "天",
    date_day_1             = "日",
    date_month           = "月",
    date_year            = "年",

    -- 其他說明性文字
    discount_text        = "折",
    front                = "前",
    middle               = "中",
    back_1               = "後",
    individual           = "個",
    piece                = "件",
    level_1              = "級",
    advancedNum          = "階",
    reward               = "獎勵",
    level                = "等級",
    player_name          = "姓名",
    attribute            = "屬性",
    base_attribute       = "基礎屬性",
    append_attribute     = "附加屬性",
    limit_attribute      = "極限屬性",
    building_next_level_effect    = "下一級效果",
    building_description = "建築說明",
    building_condition   = "建造條件",
    building_function    = "建築功能",
    more_information     = "更多資訊",
    protect_money_number = "銀幣保護",
    protect_wood_number  = "木材保護",
    protect_ore_number   = "礦石保護",
    daily_activity       = "每日活躍度",
    active_degree        = "活躍度",
    task_name            = "任務名稱",
    task_description     = "任務描述",
    completion_degree    = "完成度",
    upgrade              = "升級",
    upgrade_condition    = "升級條件",
    upgrade_success      = "升級成功",
    is_building          = "建造中",
    speed_up_time        = "加速時間",
    curr_have            = "當前擁有",
    chip_compose         = "碎片合成",
    compose              = "合成",
    beat_checkpoint      = "擊敗了關卡",
    max_level            = "已升至最高等級",
    drill_time           = "訓練時間",
    drill_pay            = "訓練花費",
    pay                  = "花費",
    victory_gain         = "勝利獲得",
    cishu                = "次數",
    talent               = "天賦",
    skill                = "技能",
    create_weapon_sub_time  = "減少時間",
    discount             = "當前折扣",
    hero_number          = "解鎖將領數量",
    output               = "產出",
    accumulation_max     = "累積上限",
    update_buy_number    = "刷新購買次數",
    loot_recovery_time   = "掠奪恢復時間",
    building_no_details  = "此建築暫無詳情",
    equiped              = "已裝備",
    need_level           = "需求等級",
    matrix_level         = "陣法等級",
    upgrade_matrix_need_level = APP_REVIEW and "(升級陣法需要主公等級 " or "(升級陣法需要主公Lv.",
    already_full_level   = "已滿級",
    full_level           = "滿級",
    enable_matrix        = "啟用陣法",
    need_vip             = APP_REVIEW and "需要至尊" or "需要VIP",
    need_lord_level      = "需要主公",
    upgrade_consume      = "升級消耗",
    matrix_effect        = "陣法效果",
    special_effect       = "特殊效果",
    number_position      = "號位",
    can_not_recruit      = "不可招募",
    already_recruit      = "已招募",
    recruit_success      = "招募成功",
    xilian_finish        = "洗煉完成",
    sell_can_gain        = "出售可獲得",
    origin_property      = "原屬性",
    new_property         = "新屬性",
    empty                = "空",
    finish               = "完成",
    revoke               = "撤銷",
    sell_number          = "出售數量",
    sell_price           = "出售單價",
    gain_money           = "獲得金幣",
    please_sell_number   = "選擇出售數量",
    skill_level          = "技能等級",
    achievement_level    = "成就等級",
    activated            = "啟動",
    already_activated    = "已啟動",
    not_activated        = "未啟動",
    property_add         = "屬性加成",
    need_material        = "需求材料",
    material             = "材料",
    please_select_equip  = "請先選擇裝備",
    activate_success     = "啟動成功",
    back_pay             = "返還費用",
    reborn_gain          = "重生獲得",
    smelt_gain           = "分解獲得",
    reborn_weapon_to_origin = "重生後，兵器將回到初始狀態",
    reborn_solider_to_origin = "重生後，將領將回到初始狀態",
    please_select_property_xilian = "選擇一條屬性進行洗煉",
    xilian_cover_origin_property  = "洗煉後將改變原有屬性",
    please_select_use_number      = "選擇使用數量",
    weapon               = "兵器",
    weapon_copy          = "兵器庫",
    weapon_advanced      = "兵器進階",
    weapon_advanced_skill      = "兵器進階後技能",
    weapon_advanced_replace_skill = "注意：兵器進階後新技能將會替換舊技能並重置技能等級。",
    advanced             = "進階",
    advanced_2             = "進 階",
    advanced_success     = "進階成功",
    select_weapon        = "選擇兵器",
    zhuanjing            = "專精",
    combatValue          = "戰鬥力",
    proficiency          = "熟練度",
    weapon_combat        = "兵器戰力",
    replace              = "更換",
    replace_2            = "更 換",
    strength_weapon      = "強化兵器",
    equip_strength       = "裝備強化",
    strength             = "強化",
    strength_2           = "強 化",
    all                  = "全部",
    long_handle          = "長柄",
    single_hand          = "鈍器",
    staff                = "法杖",
    sword                = "劍",
    fan                  = "扇子",
    magic_ball           = "法球",
    talent_scroll        = "兵器卷軸",
    scroll               = "卷軸",
    common               = "普通",
    easy                 = "簡單",
    hard                 = "困難",
    owned_soldier        = "已擁有的將領",
    not_owned_soldier    = "未擁有的將領",
    rest                 = "休息",
    go_out_to_battle     = "出征",
    active_skill         = "主動技能",
    talent_skill         = "被動技能",
    overplus_skill_point = "技能剩餘點數",
    consume              = "消耗",
    consumables          = "消耗品",
    combineSkill_Title   = "奧義",
    moraleSkill_Title    = "超必殺",
    commonSkill_Title    = "必殺",
    talentSkill_Title    = "天賦技",
    res_num_limit        = "最大容量",
    select_up_speed_card = "選擇加速卡",
    cur_building_time    = "當前建造時間",
    can_sub_building_time = "可減少建造時間",
    unlock_castle = "解鎖的命格",
    open_position_number  = "開啟位置個數",
    max_exp_add          = "最大經驗加成",
    unlock_general_manual = "解鎖將領圖鑒",
    general_manual = "圖鑒",
    friends_num_person_level_limit = "好友度人物等級上限",
    qunxiong_challenge_limit = "群雄挑戰次數上限",
    qunxiong_open = "開啟群雄",
    unlock_weaponcopy = "解鎖兵器庫",
    unlock_multicopy = "解鎖多人副本",
    weaponcopy_challengetimes_limit = "挑戰令上限",
    single_levy_money = "單次徵收銀幣",
    single_levy_wood = "單次徵收木材",
    single_levy_mineral = "單次徵收礦石",
    weapon_order         = "兵器品級",
    open_spectra_num     = "兵器譜啟動數",
    smithy_practice_level = "熟練度上限",
    open_businessman_name = "開啟商人名稱",
    delete_the_read      =  "刪除已讀",
    one_key_receive      =  "一鍵領取",
    drill_pos_quality    = "訓練位品質",
    drill_pos_time_count    = "訓練倒計時",
    drill_pos_time_total    = "訓練總時長",
    soldier_exp          = "將領經驗值",
    get_exp              = "獲得經驗",
    exp                  = "經驗",
    add_team             = "加入隊伍",
    free                 = "免費",
    free_2               = "免 費",
    after_free           = "後免費",
    overplus_time        = "剩餘時間",
    physics_attack_1     = "物理攻擊",
    strategy_attack_1    = "策略攻擊",
    curr_level           = "當前等級",
    curr_vip             = "當前特權",
    next_level           = "下一級",
    next_level_deng      = "下一等級級",
    curr_property        = "當前屬性",
    limit_property       = "極限屬性",
    next_level_property  = "下一級屬性",
    next_level_property1  = "下級屬性",
    attack_type          = "攻擊類型",
    weapon_type          = "兵器類型",
    weapon_name          = "兵器名稱",
    all_attr_look        = "總屬性預覽",
    sell_goods           = "物品出售",
    drillField           = "校場",
    drillSettlement        = "訓練結算",
    --聊天
    chat_world           = "世界",
    chat_country         = "國家",
    chat_private         = "私聊",
    chat_system          = "系統",
    chat_battleField     = "戰報",
    chat_customerService = "客服",
    view_playback        = "查看重播",
    chat_you             = "你",
    chat_you_to          = "你對",
    chat_say             = "說",
    chat_to_you          = "對你說",
    max_enter_tips       = "最多輸入50個字",
    max_enter_tips_7     = "最多輸入7個字",
    send2                = "發 送",
    --鐵匠鋪
    success_rate         = "成功率",
    strength_level       = "強化等級",
    advanced_desc        = "進階後屬性大幅度增加，兵器技能也會隨之增強。",
    cur_strength_success_rate    = "當前強化成功率",
    smith_synthesis      = "合 成",
    one_key_synthesis    = "一鍵合成",
    material_unenough    = "材料不足",
    -- -- 國家
    country              = "國家",
    country_name         = "國家名稱",
    country_name_1       = "國號",
    country_notice       = "國家公告",
    country_member       = "國家成員",
    country_build        = "建國",
    country_modify       = "修改",
    country_overview     = "總覽",
    country_member_1     = "國家人員",
    country_rank         = "國家排名",
    personal_rank        = "個人排名",
    country_help         = "國家幫助",
    country_log          = "國家日誌",
    country_setting      = "國家設置",
    country_war          = "國家戰爭",
    country_shop         = "國家商城",
    country_warehouse    = "國家倉庫",
    country_technology   = "國家科技",
    country_shop         = "國家商店",
    country_dart         = "押鏢",
    country_dartrob      = "打劫",
    country_dartwanted   = "通緝",
    country_worldboss    = "群雄逐鹿",
    country_nightWuchao  = "夜襲烏巢",
    country_monarch      = "君主",
    country_number       = "人數",
    country_add          = "加入",
    country_add2          = "加 入",
    country_create       = "創建國家",
    country_direct_add   = "快速加入",
    country_quit         = "叛 國",
    country_tichu        = "踢出",
    country_shanrang     = "禪讓",
    country_contribution = "總貢獻",
    country_today_contribution = "今日貢獻",
    country_tech_num     = "國家科技%s階",
    country_clear        = "清理",
    country_warehouse_level = "國家等級",
    country_position     = "官職",
    country_salary       = "國家俸祿",
    country_money_reserves    = "銀幣倉庫",
    country_wood_reserves    = "木材倉庫",
    country_ore_reserves    = "鐵礦倉庫",
    country_give         = "即將發放",
    country_time_desc    = "24小時發放俸祿",
    country_look_detial  = "查看詳情",
    country_warehouse_up_to  = "國庫升級至",
    country_reserves_up_limit_to  = "後儲量上限提升至",
    country_res_protect  = "資源保護",
    country_join_condition  = "加入條件",
    country_rank         = "排名",
    country_name_1       = "國號",
    country_level_above  = "級以上",
    country_level_limit  = "等級要求",
    country_onekey_help  = "一鍵幫助",
    country_helper       = "幫助者",
    country_help_me_create  = "幫我建造",
    country_help_me_upgrade = "幫我升級",
    country_log_info        = "日誌資訊",
    system_mail          = "系統郵件",
    general              = "將領",
    role                 = "角色",
    lord                 = "領主",
    leading_actor        = "主角",
    leading_trinket      = "飾品",
    identify             = "鑒定",
    reincarnate_desc_1   = "將領50級起轉生，每隔5級轉生一次",
    reincarnate_desc_2   = "轉生後，將領變為1級，將領等級上限提升5級",
    reincarnate_desc_3   = "每次轉生，將領攻擊、防禦、生命值的等級成長均獲得提升",
    reincarnate_desc_4   = "轉生次數越多，將領提升的幅度越大",    
    turn                    = "轉",
    to_up_general_level        = "用於提高將領的等級。",
    to_up_mainrole_level        = "用於提高主角的等級。",
    no_desc        = "暫無描述",
    private_chat        = "私 聊",
    wan        = "私 聊",
    wan        = "私 聊",
    ten_thousand   = "萬",
    a_hundred_million   = "億",
    level_achieve   = "等級達到",
    level_unlock   = "級解鎖",
    star_unlock   = "星解鎖",
    noraml_chapter   = "普通副本",
    elite_chapter   = "精英副本",
    is_or_not_buy   = "是否花費",
    activity_time   = "活動時間",
    get_reward_time   = "領獎時間",
    activity_reward   = "活動獎勵",
    join2   = "參 加",
    time   = "時間",
    need_join_country   = "需加入國家",
    hole_day = "全天",
    not_limit = "不限",
    rank_locked = "榜單已鎖定",
    activity_time_count_down = "活動倒計時",
    get_award_time_count_down = "領獎倒計時",
    my_fight_num_now = "我的當前戰力",
    di_x_ming = "第%s名",
    di_x_x_ming = "第%s-%s名",
    rank = "排行",
    userName = "角色名",
    fighting = "戰力值",
    canbuy = "可購買",
    signIn = "簽到",
    di_x_day = "第%s天",
    double = "雙倍",
    zi_bei = "倍",
    shengyu = "剩餘",
    yuan = "元",
    can_get_next_reward = "即可領取下一階段獎勵",
    recharge_count_achieve_all = "累計儲值獎勵已全部達成",
    have_recharged = "已儲值",
    recharge_count = "累計儲值",
    un_finish = "未完成", 
    qianwang = "前往", 
    qianwang_2 = "前 往",
    preview = "預覽",
    preview_2 = "預 覽",
    have_finished = "已結束",
    limit_num = "限量",
    old_price = "原價",
    now_price = "現價",
    discount_time = "折扣倒計時",
    presented = "送",
    un_finish_tollgate = "未通關",
    finish_tollgate = "通關",
    already_finish_tollgate = "已通關",
    finish_tollgate_achieve = "通關達成",
    refresh_reward = "刷新獎勵",
    refresh_success = "刷新成功",
    turn_ten_times = "轉10次",
    open_one_times = "轉一次",
    open_ten_times = "轉十次",
    godfight_nums = "武神榜挑戰次數",
    godfight = "武神榜",
    un_enough = "不足",
    score_recruit = "積分招募",
    get_score = "領取積分",
    rank_reward = "排名獎勵",
    now_can_challange = "當前可挑戰",
    time_count_down = "倒計時",
    kaiqi = "開啟",
    to_get = "去獲取",
    compound_cost = "合成花費",
    full = "滿",
    smelt_weapon_will_get = "熔煉該兵器將獲得",
    smelt = "熔煉",
    qiangzhanshengli = "搶佔勝利",
    resurgence2 = "複 活",
    helibuzhen = "合理佈陣",
    i_want_to_strong = "我要變強",
    level_up_to = "恭喜您等級升到",
    now_tili = "當前體力",
    max_tili = "體力上限",
    main_role_fight = "主角戰鬥力",
    zhuzhan_hero = "助戰英雄",
    matrix = "陣法",
    levelup_effect = "升級效果",
    role_choose = "角色選擇",
    elite_chapter_challenge_times = "精英副本挑戰次數",
    now_left_free_times = "今日剩餘免費次數",
    left_free_times = "剩餘免費次數",
    left_challenge_times = "剩餘挑戰次數",
    haicha = "還差",
    have_already_get = "已獲得",
    get = "獲得",
    have_already_enough = "已足夠",
    ci = "次",
    now_sweeping = "正在掃蕩",
    type_tollaget_drop = "此類型關卡掉落",
    godweapon_advance_scroll = "神兵進階卷軸",
    tollgate_introduce = "關卡介紹",
    drop = "掉落",
    cost_tili = "消耗體力",
    force_attact = "強攻",
    auto_sell = "自動出售",
    get_success = "領取成功",
    chuangguan = "闖關",
    shouguan = "守關",
    achieve = "達到",
    star_reward = "星獎勵",
    num_zhang = "章",
    num_di = "第",
    num_chong = "重",
    num_guan = "關",
    num_ceng = "層",
    goto_rightnow = "立即前往",
    breakthrough = "突破",
    breakthrough_2 = "突 破",
    already1 = "已",
    is_stop_train = "是否終止訓練",
    qing_zhuansheng = "請轉生",
    lang_press_to_tufei = "長按可連續突飛",
    recieve_email_box = "收件箱",
    write_email = "寫信",
    notice = "公告",
    title = "標題",
    receiver = "收件人",
    enter_title = "請輸入標題",
    enter_receiver_name = "請輸入收件人名稱",
    enter_email_text = "請輸入郵件內容",
    enter_text = "請輸入資訊",
    add = "添加",
    friends_num = "好友數量",
    renqi = "人氣",
    youqing = "友情",
    tongyi_2 = "同 意",
    jujue_2 = "拒 絕",
    yichu_2 = "移 除",
    add_friend = "添加好友",
    all_tongyi = "全部同意",
    one_key_jujue = "一鍵拒絕",
    jump_guide = "跳過引導",
    jump_story = "跳過劇情",
    reborn = "重生",
    can_reborn_hero = "可重生將領",
    smelt = "分解",
    smelt2 = "分 解",
    can_smelt_hero_card = "可分解將領卡",
    reborn_need_off_line = "將領需下陣後才可重生",
    smelt_gain_breakthroughstone = "分解將獲得突破石",
    smelt_can_get_after_things = "級將領的碎片，將獲得以下獎勵",
    today_have_levy = "今日已徵收",
    single_levy = "單次徵收",
    levy_2 = "征 收",
    force_levy_1 = "強征",
    force_levy_10 = "強征10次",
    levy_gain = "徵收獲得",
    earnings = "收益",
    tactical_analysis = "戰術分析",
    unlock_need_score = "解鎖需要特訓積分",
    quit_2 = "退 出",
    to_choose_server = "請選擇伺服器",
    area = "區",
    login_fail = "登錄失敗",
    recommend = "推薦",
    all_server = "所有伺服器",
    last_login_server = "上次登錄伺服器",
    server = "伺服器",
    huangjin_army = "黃巾軍",
    xiliang_army = "西涼軍",
    shu_army = "蜀軍",
    worldboss_reward_send_tips = "國家獎勵在活動結束後發放到國家倉庫",
    hurt = "傷害",
    my_hurt = "我的傷害",ips = "國家獎勵在活動結束後發放到國家倉庫",
    hurt = "傷害",
    player = "玩家",
    rank_change = "排行切換",
    unlock_condition = "解鎖條件",
    no = "無",
    fighting = "戰力",
    give_up = "放棄",
    give_up_2 = "放 棄",
    reserve_totle_num = "儲備總量",
    send_count_time = "發放倒計時",
    my_salary = "我的俸祿",
    country_reserve = "國家儲備",
    luoyang = "洛陽",
    luoyang_city = "洛陽城",
    changan_city = "長安城",
    level_up_time_count_down = "升級倒計時",
    items2 = "道 具",
    limit_time_2 = "限 時",
    reward_2 = "獎 勵",
    left_fresh_time = "剩餘刷新時間：",
    today_can_buy = "今日可買",
    need_country_tech = "需要國家科技",
    country_left = "國家剩餘",
    save = "保存",
    see_apply_for = "查看申請",
    leixing = "類型",
    my_promotion = "我的官職",
    panguo_tips = "叛國之後24小時不可加入其他國家",
    promotion = "升 官",
    direct_promotion = "直接升官",
    promotio_need_fight = "升官需要戰勝",
    is_to_fight = "是否發起戰鬥",
    not_conform_to_promotion_candition = "不符合升官條件",
    not_conform_to_promotion_candition2 = "貢獻不足不可挑戰",
    country_permission_unenough = "國家許可權不夠",
    seized = "搶佔了",
    defended = "駐守的",
    zi_de = "的",
    seized_mycountry_defended = "搶佔了本國駐守的",
    in_time_success_defended = "在結算時間內成功駐守",
    recieve_huge_money = "獲得大量銀幣",
    cannot_join = "不可加入",
    dart_help_tip = "建造可減少時間，可提升押鏢安全",
    level_dart_help_apply_for = "級押鏢申請押鏢支援",
    now_have_no_dartwanted_player = "暫無被通緝的玩家",
    now_have_no_dartrob_player = "暫無可劫掠的鏢車",
    dartrob_tips = APP_REVIEW and "[color=ff4c1212]首次劫掠至尊級[/color][color=ffff3644]免費[/color]" or "[color=ff4c1212]首次劫掠S級[/color][color=ffff3644]免費[/color]",
    dart_result_success_tip = "押鏢完成，獲得如下物資",
    dart_result_rob_success = "成功劫掠了來自",
    such_goods = "如下物資",
    dart_result_be_robed_success = "打劫了你的鏢車，損失了如下物資",
    dart_apply_your_help = "同意了您的幫助請求",
    dart_main_tips = "\t\t\t\t\t本次押鏢失敗！\n\n注意：在押鏢過程中退出押鏢頁面，會被判定為本次押鏢失敗。",
    dart_left_help_time = "剩餘支援次數",
    chufa = "出發",
    dart_now_have_no_can_help_member = "暫無可支援的國家成員!",
    dart_today_have_no_help_times = "今日已無被支援次數",
    get_dart = "接鏢",
    dartget_tips = APP_REVIEW and "[color=ffdeb05d]首次接取至尊級任務[/color][color=ffff3644]免費[/color]" or "[color=ffdeb05d]首次接取S級任務[/color][color=ffff3644]免費[/color]",
    country_tech_level_up_tip = "只有君主、丞相可以升級國家科技",
    country_tech_max_level = "已達到最大等級",
    country_tech_level_up_time = "升級時間",
    country_tech_desc = "科技描述",
    country_member_ask_for_member = "申請成員",
    country_member_ask_for_time = "申請時間",
    congratulations_extra_to_get_reward = "恭喜你額外獲得如下獎勵",
    congratulations_to_get_reward = "恭喜你獲得如下獎勵",
    dismissTeam = "解散隊伍",
    start_fight = "開始挑戰",
    outTeam = "退出隊伍",
    seize_times = "搶佔次數",
    SEND_INVITE = "發送邀請",
    SENDTOWORLD = "發送世界",
    SENDTOCOUNTRY = "發送國家",
    unReady = "取消準備",
    doReady = "準備",
    start_seize = "開始搶佔",
    team_to_fight = "帶隊攻打",
    heros_to_join = "各路英雄快來加入",
    heros_to_join = "各路英雄快來加入",
    reward_after_clearing = "結算後獲得",
    may_reward = "概率獲得",
    may_reward_after_clearing = "結算後有概率獲得",
    may_reward_after_seize = "搶佔後有概率獲得",
    may_reward_after_seize = "搶佔後有概率獲得",
    seize_country = "佔領國",
    un_seize = "未被佔領",
    clearing_count_time = "結算倒計時",
    for_country_reward_after_clearing = "結算後為佔領國家提供",
    for_member_reward_after_clearing = "結算後為駐守成員提供",
    defend_2 = "駐 守",
    seize_2 = "搶 占",
    invite_country_member_seize = "邀請國家成員搶佔",
    invite_country_member_defend = "邀請國家成員駐守",
    invite_success = "邀請成功",
    today_left_buy_times = "今日剩餘購買次數",
    today_already_buy_times = "今日已購買次數",
    buy_energy_tips = "[color=ffff0000]注：[/color]每兩小時恢復一個挑戰令",
    sure_to_double_in_1day = "確定在1天內加倍",
    dechanliang = "的產量麼",
    have_already_ask_for_country_help = "已請求國家幫助",
    main_line = "主線",
    back_to_city = "回城",
    activity = "活動",
    new_server_activity = "新手活動",
    sevenday_activity = "七日活動",
    give_caohong = "送曹洪",
    recharge = "儲值",
    fisrt_recharge = "首儲",
    leisure = "空閒",
    see_fightreport = "查看戰報",
    next_tiao = "下一條",
    jieshou_2 = "接 受",
    invite_to_defend = "邀請你駐守",
    denfend_now = "立即駐守",
    invite_to_seize = "邀請你加入搶佔",
    func = "功能",
    coming_soon = "即將開放",
    challenge_house = "挑戰建築",
    copy_open_week = "本副本星期",
    open = "開放",
    autoJoin = "自動加入",
    createTeam = "創建隊伍",
    possible_to_get_rewards = "可能獲得以下獎勵",
    known = "知道了",
    mainhero_achieve_space_level = "主角等級達到     級",
    and_house_level_achieve_space_level_open = "且酒館等級達到     級開啟",
    single_chou_2 = "單 抽",
    shilian_2 = "十 連",
    shilian = "十連",
    must_get = "必得",
    is_or_not_zhaomu_hero = "是否招募該將領",
    copy_drop = "副本掉落",
    duihuan = "兌換",
    duihuan_2 = "兌 換",
    shilianchou = "十連抽",
    today_can_duihuan_space_ci = "今日可兌換      次",
    goods_box = "寶箱",
    bangwai = "榜外",
    rank_title_tip1 = "獲取途徑：成為本榜單第",
    rank_title_tip2 = "時間期限：仍佔據本榜單第",
    num_ming = "名",
    to_get_right_now = "立即獲得",
    to_get_every_day = "每日領取",
    right_now_have_buy = "當前已購買",
    is_or_not_to_get = "是否前往領取",
    vip = "至尊",
    shengjie_2 = "升 階",
    right_now = "當前",
    num_unenough = "數量不足",
    reset = "重置",
    reset_2 = "重 置",
    use_bingfa = "啟用兵法",
    tingzhi_2 = "停 止",
    bingshutexing = "兵法特性",
    all_active_can_jinjie = "全部啟動可進階",
    already_full_jie = "已滿階",
    fubing_level = "兵法等級",
    use_effect = "啟用效果",
    use_special = "啟用特性",
    base = "基礎",
    reset_will_back_all_resource = "重置該兵法返還所有培養物資",
    biyuexiuhua = "閉月羞花",
    yuanshenfenjie = "元神分解",
    sell_hero_card_get = "出售將獲得",
    can_free_fresh = "可免費刷新",
    and_yanjiuyaun_achieve_level = "且研究院等級達到",
    attack_times = "進攻次數",
    enter_active_code = "請輸入啟動碼",
    enter_name = "請輸入姓名",
    id_card = "身份證",
    enter_id_card_num = "請輸入身份證號",
    commit_2 = "提 交",
    game_name = "昵稱",
    no_have_for_now = "暫無",
    items_preview = "道具預覽",
    resource_preview = "資源預覽",
    zhaomujuan = "招募卷",
    kuangshi_chang = "礦石場",
    mucai_chang = "木材場",
    nums = "數量",
    totle_capacity = "總容量",
    tili_recover_time = "體力恢復時間",
    tili_all_recover = "體力全部恢復",
    sount_effect_ctrl = "音效開關",
    sount_music_ctrl = "音樂開關",
    exchange_code = "兌換碼",
    change_account = "切換帳號",
    true_name_certification = "實名認證",
    beijiangli = "倍獎勵",
    main_role_advance_to = "主角資質進階為",
    new = "新",
    attribute_up = "屬性提升",
    all_heros = "全體",
    reset_all = "重置全部",
    reset_castle = "重置命格",
    can_active = "可啟動",
    need_prefore = "需前置",
    active_condition = "啟動條件",
    house_level = "建築等級",
    through_now_chapter_can_get = "通關當前章節可領取",
    friendship_plus = "親密度加成",
    friendship = "親密度",
    level_more_plus_more = "等級越高，屬性越高",
    use_love_can_plus_50 = "使用愛心標記的禮物會獲得50%的加成",
    tongquetai_house_level_achieve =  "銅雀台建築達到",
    goto_jiuguan = "前往酒館",
    use_gold_can_get_rare_gem = "使用元寶可獲得稀有寶石",
    greetings = "問候",
    patronize = "寵倖",
    endear = "親近",
    every_week = "每週",
    may_trigger_boss_fight = "有幾率觸發BOSS戰",
    disappear_time = "消失時間",
    dazhao_weapon = "打造兵器",
    valuate = "評價",
    star = "星",
    can = "可以",
    yuji_time = "預計時間",
    zhengtao = "征討",
    zhengtao_2 = "征 討",
    immediately_complete = "立即完成",
    can_zhengtao_times = "可征討次數",
    zhengtao_can_get_unless_equip_resource_and_all_rewards = "征討可獲得除裝備進階卷軸外的所有關卡獎勵",
    left_zhengtao_times = "剩餘征討次數",
    now_zhengtao = "正在征討",
    un_equiped = "未裝備",
    can_advance_to = "可進階為",
    cur_level_up_success_rate = "當前升級成功率",
    up_strength_success_rate = "提升成功率",
    daozao = "打造",
    daozao_ing = "正在打造",
    base_attack = "基礎攻擊",
    append_attack = "附加攻擊",
    base_defence= "基礎防禦",
    append_defence = "附加防禦",
    base_hp = "基礎生命",
    append_hp = "附加生命",
    level_limit = "等級上限",
    use_xinde = "使用心得",
    yanxi_2 = "研 習",
    long_press_can_yanxi = "長按可連續研習",
    all_pactice_reach_level = "所有熟練度都達到",
    can_goon_yanxi = "級後才可繼續研習",
    re_choose = "重新選擇",
    weapon_list = "兵器列表",
    need = "需要",
    num_ba = "把",
    un_casted = "未鍛造過",
    de_weapon = "的兵器",
    merit_reward = "成就獎勵",
    grab_food_rank = "搶糧榜",
    grab_food_times = "搶糧次數",
    cur_foodroom_level = "當前糧倉等級",
    up_limit = "上限",
    zi_wo = "我",
    zi_de = "的",
    zi_pai = "排",
    zi_ming = "名",
    zi_shang = "上",
    zi_qi = "期",
    already_have_role = "已擁有的角色",
    un_have_role = "未擁有的角色",
    general_is_lock = "該將領暫未解鎖",
    already_achieved_limit = "已達上限",
    advance_to = "進階至",
    quality = "品質",
    can_goon_strength = "可繼續強化",
    achieve_to_max_level = "已達到最大進階等級",
    fetter_unactive = "羈絆尚未啟動",
    next_level_need = "下一級需要",
    attribute_plus_for_all = "屬性加成針對所有",
    general_fetter = "將領羈絆",
    regional_map = "地域版圖",
    fetters_up_tips = "提升將領的等級和星級可增加羈絆屬性的加成",
    fetter_list = "羈絆列表",
    un_deblocking = "未解鎖",
    fetters_achieve = "羈絆達成",
    collect = "收集",
    un_achieve = "未達成",
    white_color = "白色",
    get_gem = "獲取勾玉",
    one_key_inlay = "一鍵鑲嵌",
    inlay = "鑲嵌",
    please_choose_level = "請選擇武器",
    have_no_can_inlay_gem = "無可鑲嵌的勾玉",
    have_no_can_inlay_herosoul = "無可裝備的燈魂",
    same_type_herosoul_can_inlay_onlyone = "同類型燈魂只能裝備壹個",
    already_max_level_gem = "已是頂級勾玉",
    already_max_level_herosoul = "已是頂級燈魂",
    choose_gem = "請選擇勾玉",
    have_num = "擁有數量",
    equiped_by = "裝備於",
    already_choosed = "已選擇",
    one_key_choose = "一鍵選取",
    choose_gem_to_max_num = "選取勾玉達到上限",
    choose_herosoul_to_max_num = "選取燈魂達到上限",
    already_up_to_max_star = "已升至最高星級",
    up_to = "升至",
    star_unlock_skill = "星解鎖技能",
    position_un_equip_trinket = "該位置未裝備飾品",
    trinket_totle_num = "飾品總數",
    level_unenough = "等級不足",
    main_role = "男主",
    woman_role = "女主",
    qiecuo_2 = "切 磋",
    weapon_quality = "兵器資質",
    count_food_num_achieve = "累計糧草數量達到",
    food = "糧草",
    already_be_defeated = "已經被擊敗",
    achieve_conditions_can_get = "達到指定條件就可領取相應獎勵",
    go_zhaomu = "去招募",
    zhaomu_times = "招募次數 [color=ffffffff]%d次[/color]",
    hero_detail = "將領詳情>>",
    zhaomujilei_pop_discribe_1 = "活動期間，所有消耗招募券的卡包都",
    zhaomujilei_pop_discribe_2 = "有概率招募到",
    zhaomujilei_pop_dis_name = "馬超",
    zhaomujilei_pop_dis_chenghao = "【神威的天將軍】",
    shijian = "時間：",
    can_exchange_times = "可兌換%d次",
    soulfete = "獵魂",
    include_equiped = "含已裝備",
    light_heroSoul = "燈魂",
    zengjia = "增加",
    retry_2 = "重 試",
    zi_zhejia = "折價",
    person = "個  人",
    country_ = "國  家",
    xiazhen = "將領需下陣才可重生,是否將其下陣?",
    yangcheng = "養成",
    zhanfa = "戰法",
    xiaoguoyulan = "效\n果\n預\n覽",
    xiaoguoyulan_ = "效 果 預 覽",
    weaponType = "武器類型",
    gailv = "概率",
    mainTarget = "主目標",
    huihe = "回合",
    xiqu = "吸取",
    life = "的生命值",
    clear = "清除",
    shiqi = "的士氣",
    shi_ = "使",
    pugong = "普攻",
    jiang = "將",
    cjnxx = "從技能上卸下嗎？",
    xxfh = "卸下只返回升級花費的所有將領碎片及",
    sjzy = "升級資源",
    tupoLimit = "突破等級不足！",
    xiaohao = "消\n耗",
    success = "成功",
    gongji = "攻\n擊\n型",
    fuzhu = "輔\n助\n型",
    isUseThisSKill = "是否啓用該奧義?",
    fujiashuxing = "附加屬性",
    manji = "戰法已達上限",
    jiefeng = "解封",
    thisHeroUsing = "該武將已被使用",
    zhanfa_xiazhen = "該武將已上陣，是否下陣？",
    zhaungbeied = "已被裝備於",
    isXiexia = "是否前往卸下?",
    sameRole = "同壹類型武將只能鑲嵌兩個",
    other_role = "已經裝備了其他將領戰法，是否前往卸下？",
    tips_duihuan_success = "兌換成功！",
    openInfo = "戰法功能開啟後解鎖",
    
    limitTimeHot = "限時熱點",
    zmkdh = "招募該將領後可兌換",
    xiaofeiCount = "累計消費",
    tishengVip = "提升VIP可獲得更多刷新次數",
    tisheng_ = "提升VIP",
    fuli = "福利",
    vip_max = "刷新次數已達上限",
    daozaoFJ = "打造附加產量",
    dancong = "每日單筆充值金額達到指定額度即可領取豐厚大禮",
    danbi_cong = "單筆充值",
    can_get_times = "可領取",
    target = "目標",
    meichongzhi = "每充值",
    getChange = "獲得壹次抽獎機會",
    againCz = "再充值",
    cangetChange = "可獲得抽獎次數",

    herocopy_countLimit = "今日購買次數已達上限",
    herocopy_country1 = "魏",
    herocopy_country2 = "蜀",
    herocopy_country3 = "吳",
    herocopy_country4 = "群雄",
    herocopy_noTimes = "次數已用完!",
    herocopy_firstReward = "首殺獎勵",
    herocopy_get = "得",
    herocopy_reward = "獎勵",
    herocopy_cannot = "不允許出戰武將所屬:",
    herocopy_star = "本章得星達",
    herocopy_unlock = "關卡未解鎖",
    zmkdh = "招募該將領後可兌換",
    heroCopy_copyName = "一騎當千",
    Make_breakItem = "進階材料",
    Make_starItem = "升星材料",
    Make_making = "打造中...",
    Make_canGet = "可收獲...",
    Make_leftTime = "倒計時: ",
    Make_makeFinish = "打造完成",
    Make_pleaseUplevel = "請提升鐵匠鋪等級，開啓該位置",
    Make_startMake = "開始打造",
    Make_selectItem = "請選擇材料",
    Make_add = "增加",
    Make_baseNum = "基礎産量",
    Make_topTitle = "提示：提升鐵匠鋪可增加附加産量",
    Make_freeFreshTime = "免費刷新時間:",
    Make_freshNow = "立即刷新",
    Make_getNow = "立即收獲",
    Make_get = "收獲",
    Make_houseLv = "鐵匠鋪Lv",
    active_date = "活動日期",
    active_recharge = "活動內充值：",
    change_name_card = "改名卡",
    change_name_hou = "來修改",
    -- 分享
    share_txt_1 = "微信",
    share_txt_2 = "朋友圈",
    share_txt_3 = "facebook",
    share_part_1 = "服務器：",
    share_part_2 = "地址：qlzj.zhanyougame.com",
    -- 神兵改
    change_shenbing = "切換神兵",
    change_shenbing_cost = "切換花費：",
    unlock_shenbing = "打造神兵",
    -- 提示語言包
    tips_send_success           = "發送成功",
    tips_function_not_open      = "功能暫未開放",
    tips_resourse_deficiency    = "資源不足",
    tips_lord_level_deficiency  = "領主等級不足",
    tips_buy_payqueue           = "是否要花費 250元寶 購買一個付費佇列？（持續24小時）",
    tips_buildingQueue_full     = "建築佇列已滿",
    tips_please_build_pub        = "請先創建酒館",
    tips_please_build_smithy     = "請先創建鐵匠鋪",
    tips_please_select_private_chat_user     = "請選擇私聊物件",
    tips_please_join_country     = "請先加入國家",
    tips_speed_up_finish        = "加速完成",
    tips_speed_up_success       = "提速成功",
    tips_user_level_deficiency  = "玩家等級不足",
    tips_house_level_deficiency  = "建築等級不足",
    tips_battle_field_success   = "分享戰報成功",
    tips_buy_success            = "購買成功",
    tips_max_level              = "已達最高等級，無法繼續升級",
    tips_max_level_only         = "已達最高等級",
    tips_contribution_full      = "捐獻已滿，無法繼續捐獻",
    tips_country_name_empty     = "國家名稱為空",
    tips_country_notice_empty   = "國家公告為空",
    tips_country_create_success = "創建國家成功",
    tips_country_notice_identical      = "國家公告與之前相同，不需要修改",
    tips_modify_success         = "修改成功",
    tips_money_deficiency       = "銀幣不足!",
    tips_gold_deficiency        = "元寶不足",
    tips_please_drill_time      = "請選擇訓練時間",
    tips_checkpoint_not_open    = "關卡未開啟",
    tips_matrix_full_level      = "陣法已滿級",
    tips_need_player            = "需要玩家",
    tips_soldier_activation     = "將領尚未啟動，無法招募",
    tips_no_trinkets_sell       = "無可飾品可賣",
    tips_no_prop_can_sell       = "道具數量過少，無法售出",
    tips_solider_level_reach_main_role_level  = "將領等級已達到主角等級",
    tips_please_select_hero = "請先選擇英雄",
    tips_no_have_this_type_goods = "無此類型商品",
    tips_go_to_soldier_view = "沒有可訓練將領",
    tips_mail_open_faild = "郵件打開失敗",
    tips_country_contributeCD_clear = "您捐獻的過於熱情，請稍後再捐獻，您也可以花費一些元寶直接清除冷卻時間！",
    tips_network_failed             = "無法連接到伺服器，請稍後重試！",
    tips_http_error_1               = "暫時無法連接，請稍後重試！",
    tips_downloadmanager_fail       = "下載失敗",
    tips_network_error              = "當前網路不佳！正在努力重連！",
    tips_network_not_reachable      = "無法獲取網絡連接，請檢查網絡後重試！",
    tips_data_error                 = "解析資料出錯，請稍後再試",
    tips_response_error             = "請求錯誤：狀態值異常",
    tips_click_empty_continue       = "點擊空白區域繼續",
    tips_add_friend_send_already    = "請求已發送，請耐心等待...",
    tips_info_error                 = "資訊錯誤！",
    tips_delete_friend_success      = "刪除好友成功！",
    tips_besure_delete_friend      = "你確定要刪除好友嗎？",
    tips_chapter_no_open      = "章節未開啟！",
    tips_login_error     = "登錄異常，請重試！",
    tips_game_version_low     = "您安裝的遊戲版本過低，請下載最新遊戲安裝包重試！",
    tips_clean_warning  = "注意：清除資料後可能需要重新下載補丁包，但不會影響遊戲資料、帳號等相關資訊，建議該功能只在遊戲出現異常狀況時使用，您確定清除緩存嗎？",
    tips_chapter_unlock = "該副本暫未解鎖！",
    tips_multicopy_unopen = "多人副本尚未開啟！",
    tips_unjoin_country = "尚未加入國家！",
    tips_armyshop_unopen = "軍功商店未開啟",
    tips_expcardshop_unopen = "突飛卡商店未開啟",
    tips_shop_unopen = "商店未開啟",
    tips_activity_finished = "活動已結束！",
    tips_buyTollgate_times = "是否重置關卡挑戰次數 %s 次",
    tips_recharge_unopen = "儲值暫未開放",
    tips_general_unopen = "該將領暫未開啟",
    tips_black_player_already = "已遮罩該玩家...",
    tips_unblack_player_already = "已從黑名單移出該玩家...",
    tips_unable_look_player = "無法查看該角色資訊",
    tips_unable_look_self = "無法查看自己的資訊",
    tips_relogin = "請重新登錄!",
    tips_fight_data_unexit = "戰鬥資料不存在！!",
    tips_fight_report_outoftime = "戰報信息已過期!",
    tips_synchronization_info = "正在同步儲值資訊，請稍後...",
    tips_have_no_uninlay_gem = "沒有未鑲嵌勾玉",
    tips_occupation_success = "佔領成功！",
    tips_blackmarket_fresh = "您的商品列表中還有紫色商品為購買哦！確定刷新麼？\n（點擊“勾選後刷新不變”不再提示！）",
    tips_blackmarket_countfresh = "您已鎖定全部商品，無法刷新！",
    tips_can_get_after_buy = "購買後可領取！",
    tips_less_level_cannot_get = "等級不足！當前不可領取！",
    tips_buy_growup_canget = "購買基金，達到相應等級，可領取",
    tips_click_box_can_preview = "點擊可預覽禮包獎勵",
    tips_sign_buqian = "是否花費%s元寶補簽？",
    tips_mouthcard_tip1 = "月卡和終身卡可 [image=res/Main/activity/mounthCard/bothHave.png offsety=-10][/image] 哦！",
    tips_mouthcard_tip2 = "每天可領取[color=ffffff00]%s[/color]元寶",
    tips_sevenday = "完成指定任務越多獲得獎勵越豐富",
    tips_weaponday = "只可以從六種兵器中選擇一把，選擇後無法更改",
    tips_weaponday_tip = "(提示：長按可查看兵器屬性)",
    tips_weaponday_need_choose = "請選擇一把兵器!",
    tips_gold_unenough = "元寶不足!",
    tips_godfight_cding = "挑戰冷卻中!",
    tips_godfight_clearcd = "是否花費%s元寶清除挑戰CD",
    tips_godfight_clear_success = "清除成功!",
    tips_qiangzhanzhushou_success = "搶佔【%s】駐守的“%s”成功",
    tips_result_challenge_success_unlock_train_position = "挑戰成功，訓練位解鎖!",
    tips_resurgence = "選擇一個屬性加成，然後復活",
    tips_only_mainrole_online = "只有主角可上陣！",
    tips_same_general_online = "只有主角可上陣！",
    tips_no_position_online = "沒有陣位可以上陣!",
    tips_online_num_limit = "上陣將領數量已達上限!",
    tips_vip_unenough_to_open_zhen = APP_REVIEW and "至尊等級不足，陣法無法開啟!" or "vip等級不足，陣法無法開啟!",
    tips_level_unenough_to_open_zhen = "等級不足，陣法無法開啟!",
    tips_mainrole_cannot_offline = "主角不能下陣!",
    tips_same_hero_online = "已有相同的英雄在陣上",
    tips_tili_unenough = "體力不足！",
    tips_trinkets_full = "飾品背包已滿，請先整理飾品!",
    tips_send_words = APP_REVIEW and "至尊1及以上玩家才可在世界發言" or "VIP1及以上玩家才可在世界發言",
    tips_unopen_fornow = "暫未開啟",
    tips_unselected_train_position = "未選擇訓練位!",
    tips_tufei_not_enough_tobuy = "突飛卡不足，是否前往商店購買？",
    tips_have_no_email_to_delete = "沒有可刪除的郵件",
    tips_have_no_rewards_to_get = "當前沒有可領取的物品！",
    tips_search_info_cannot_empty = "查找資訊不可為空！",
    tips_search_empty = "抱歉！沒有查找到相關玩家",
    tips_add_friend_waiting = "好友申請正在處理中，請稍候...",
    tips_already_friend_no_add = "已經是好友不需要再次添加！",
    tips_player_in_black_list = "該玩家正在黑名單中！",
    tips_today_have_send = "今日已贈送！",
    tips_tili_send_success = "體力贈送成功！",
    tips_sure_to_delete_friend = "你確定要刪除好友嗎？",
    tips_sure_to_remove_player_black_list = "你確定要將該玩家移除黑名單嗎？",
    tips_add_friend_fail_in_black_list = "添加失敗, 你在對方的黑名單中!",
    tips_add_friend_fail_in_list_full = "添加失敗, 對方好友數量已達上限!",
    tips_friend_num_limit = "好友數量已達上限!",
    tips_friend_now_have_no_response = "當前沒有好友申請請求!",
    tips_friend_tips1 = "眾裡尋她千百度，一枝紅杏出牆來",
    tips_friend_tips2 = "好友這麼多，大人真是好人緣~",
    tips_to_choose_reborn_target = "請選擇重生物件",
    tips_no_need_to_reborn = "無需重生",
    tips_to_choose_smelt_target = "請選擇分解物件",
    tips_to_choose_preview_target = "請選擇預覽物件",
    tips_no_smelt_target = "沒有可分解的物件！",
    tips_to_choose_smelt_targets_level = "請選擇可分解的將領卡品級！",
    tips_free_levy_times_have_over = "今日徵收次數已用完!",
    tips_unlock_success = "解鎖成功!",
    tips_sure_to_quit = "你確定要退出遊戲嗎？",
    tips_get_serverlist_success = "獲取伺服器資訊成功",
    tips_get_serverlist_fail = "無法獲取伺服器資訊！",
    tips_worldboss_unopen = "群雄逐鹿未開啟!",
    tips_country_tech_full_level = "當前科技已經滿級!",
    tips_country_tech_cannnot_donate = "當前科技不能捐獻!",
    tips_set_success = "設置成功!",
    tips_is_out_country = "您確定要叛國嗎？（叛國後貢獻清空，且24小時內不可加入其他國家）",
    tips_kick_out_success = "踢出成功!",
    tips_is_to_kick_out = "確定將該玩家踢出國家嗎？",
    tips_demise_success = "禪讓成功！",
    tips_is_to_demise_to = "確定將君主禪讓給該 %s 嗎？",
    tips_apply_for_success = "申請成功!",
    tips_dart_finished = "押鏢已結束！",
    tips_dart_to_help_success = "支援成功!",
    tips_country_to_help_success = "幫助成功!",
    tips_country_have_no_to_help = "沒有可幫助的建築!",
    tips_dart_quit = "退出後會浪費一次押鏢的機會，且消耗的物品也不返還，是否退出？",
    tips_darting = "正在押鏢!",
    tips_dart_out_of_time = "本次押鏢已超時，請重新接鏢!",
    tips_country_member_no_ask_player = "沒有申請玩家！",
    tips_do_success = "操作成功！",
    tips_is_to_quit_team = "是否要退出隊伍",
    tips_quit_team_success = "退出隊伍！",
    tips_is_to_dissolve_team = "是否要解散隊伍",
    tips_dissolve_team_success = "隊伍解散！",
    tips_kicked_out_team = "你被踢出隊伍！",
    tips_leader_can_use_func = "隊長才可使用該功能",
    tips_send_words_cding = "發送消息cd中，請稍候...",
    tips_invite_cding = "邀請cd中，請稍候...",
    tips_kick_out_player = "提出玩家！",
    tips_is_kick_out_team = "是否要將玩家“%s”踢出隊伍",
    tips_buy_times_limit = "購買次數達到上限!",
    tips_sure_to_dismantle_house = "是否確定要拆除改建築？",
    tips_worldboss_iscoming = "群雄逐鹿即將開放，請主公快來大顯身手！",
    tips_dart_ask_for_help = "國家成員正在押鏢，請求你的支援！",
    tips_dart_start = "押鏢開始了，請主公快來護送吧！",
    tips_field_resourse_full = "野外物資已達累計上限，快去收取吧！",
    tips_have_no_team_to_join = "暫無可加入的隊伍！",
    tips_wait_to_jion = "正在挑戰\"%s\",請求其他協助者加入。",
    tips_fight_less_2_player = "玩家人數小於2人不能開始戰鬥！",
    tips_fight_player_not_ready = "有玩家未準備，請稍候！",
    -- tips_duihuan_success = "對話成功！",
    tips_juanzhou_unopen = "所屬卷軸未開啟！",
    tips_rank_fresh_time = "排行榜每小時更新一次",
    tips_recharge_success = "恭喜您，儲值成功！",
    tips_bingfa_max_level = "當前兵法已經進階到最大等級!",
    tips_bingfa_un_active = "該兵法還未啟動!",
    tips_choose_one_bingfa = "請選擇一件兵法！",
    tips_now_cannot_reset = "當前不可重置！",
    tips_use_success = "啟用成功!",
    tips_tingyong_bingfa = "停用兵法!",
    tips_sure_to_reset_bingfa = "是否重置該兵法？",
    tips_no_more_hero_cards = "沒有多餘的將領卡!",
    tips_qunxiong_unopen = "該群雄未開啟!",
    tips_hero_card_unenough = "將領卡組合未湊齊!",
    tips_challenge_times_over = "當前挑戰次數已經用完!",
    tips_recover_every_hour = "每小時恢復一次！",
    tips_sure_to_get_card = "你確定要兌換該將領卡嗎？",
    tips_renzheng_success = "認證成功！",
    tips_renzheng_fail = "認證失敗，請重試！",
    tips_have_already_pass_certification = "您已通過了實名認證！",
    tips_shop_unopen = "該商店未開啟!",
    tips_no_need_to_reset_castle = "暫無啟動命格，無需重置!",
    tips_isto_castle_reback_all = "重置命格，所有消耗將全部返還。是否重置?",
    tips_need_active_prefore_castle = "需要啟動前置命格!",
    tips_castle_ceng_unopen = "該層命格未開啟!",
    tips_castle_need_resource_unenough = "所需資源不足!",
    tips_level_unenough_to_look = "等級不足，當前無法查看！",
    tips_now_main_task_all_finish = "當前主線任務已全部完成",
    tips_reward_fight_can_only_attack_once = "獎勵戰役只能攻打一次",
    tips_through_tollgate_condition_unenough =  "過關條件未達成！",
    tips_today_reset_times_over =  "今日重置次數已用完！",
    tips_tostrart_new_challenge = "是否開始新一輪挑戰？當前進度會被重置",
    tips_now_cannot_sweep = "當前不能掃蕩！",
    tips_now_cannot_zhengtao = "當前不可征討！",
    tips_zhengtao_time_unenough_back_tomorrow = "征討次數不足，請明日再來！",
    tips_zhengtao_time_unenough_up_vip = "征討次數不足，請先提升VIP等級！",
    tips_first_breakthrough_chapter_can_get = "首次通關章節可獲得",
    tips_to_choosse_cost_weapon = "請選擇消耗的兵器！",
    tips_congratulation_achieve_full_level = "恭喜將該成就升至滿級！",
    tips_after_advance_godweapon_tip = "進階後屬性大幅度增加，兵器技能也會隨之增強。",
    tips_congratulation_godweapon_full_level = "恭喜已達到滿級！",
    tips_godweapon_strength_fail = "強化失敗!",
    tips_godweapon_levelup_fail = "升級失敗!",
    tips_practice_desc = "兵器品級越高，收益越高。",
    tips_practice_reach_full_level = "已達最大等級上限!",
    tips_practice_up_house_can_yanxiu = "提升鐵匠鋪等級才可繼續研習!",
    tips_goods_unenough = "物品不足！",
    tips_not_selected_weapon = "尚未選擇兵器！",
    tips_weapon_cast_to_limit = "該兵器已鍛造至等級上限！",
    tips_click_right_to_choose_weapon_cast = "點擊右側兵器圖示，選擇要鍛造的兵器",
    tips_player_have_already_be_robed = "該玩家已被搶奪過！",
    tips_challenge_mainline_or_weaponcopy_can_get_is_go = "挑戰主線或兵器庫副本都可獲得兵器，是否前往？",
    tips_challenge_eaponcopy_can_get_is_go = "挑戰兵器庫副本可獲得各類兵器，是否立即前往？",
    tips_hero_fragment_unenough = "將領碎片不足！",
    tips_left_times_unenough = "剩餘次數不足！",
    tip_zhaomu_discribe = "本卡包招募 [color=ffff0000]%s[/color] 次,必得 [image=%s offsety=-8 w=%d h=%d][/image] 級將領",
    tip_exchange_activity_desc = "活動期間，挑戰 [color=ffff0000][size=17]%s[/size][/color] 即有概率獲得招財貓！",
    tip_exchange_tip = "是否要兌換%s？",
    tip_exchange_unenough = "道具不足！",
    tip_exchange_herosoul_ask = "是否要兌換該燈魂？",
    tip_no_soul_to_gather_fornow = "暫無可收取的燈魂！",
    tip_no_soul_to_sell_fornow = "暫無可出售的燈魂！",
    tip_soulbag_is_full_to_tidy = "擁有燈魂數量已達上限，請先升級燈魂！",
    tip_bubble_godfight_canreward = "武神榜獎勵已經可領取，請主公前往領取！",
    tip_jiejiegao = "活動期間內充值達到相應檔位，可按比例獲得元寶返利，返利元寶直接為您添加上",
    tip_change_name = "點擊輸入妳的新名字",
    tip_change_name_tip = "(每七天可以修改壹次)",
    tip_buy_card = "是否話費%s元寶購買改名卡？",
    tip_changename_2 = "用戶名不能爲空",
    tip_changename_3 = "修改成功",
    tip_share_failed = "分享失敗",
    tip_xiandazao  = "請先打造壹把神兵",

    selet_shoushi = "請先選擇手勢！",
    now_caiquan = "正在猜拳中！",
    current_jifen = "當前積分:",
    select_num = "請選擇兌換數量！",
    ci_noenough = "次數不足！",
    tip_discount_tip = "限時特賣結束後將恢復為",
    tip_limit_buy = "限購[color=ffff0000]%d[/color]次",
    tip_limit_buy2 = "，剩余[color=ff00ff00]%d[/color]個",
    tip_limit_0 = "全服",
    tip_limit_1 = "單服",
    tip_limit_2 = "個人",
    tip_limit_over = "限時特賣已結束",
    tip_limit_unstart = "即將開場",
    tip_buy_limit_goods = "是否花費%d元寶購買？",
    getReward = "達到指定等級就可領取相應獎勵",
    buyed = "已購買人數",
    levelLabel1 = "等級越高",
    levelLabel2 = "獎勵越豐盛",
    continuity = "每天登錄即可獲得獎勵",
    continuity_ = "登錄遊戲",
    libao = "禮包",
    gouyu = "勾玉",
    activityend = "活動結束",
    -- 切换神兵
    change_shenbing_tip = "是否花費%d元寶切換該神兵？",
}

zc = zc or {}
function zc.lang( ... )
    local arg = { ... }
    if #arg == 0 then
        return ""
    end
    local langKey = arg[1] or ""
    local langVal = arg[2] or ""
    return langConfig[langKey] or ""
end
