--[[
	奖励兑换
]]

local AccumulatedChongzhi = class("AccumulatedChongzhi", function()
    local layer = cc.Sprite:create()
    layer:setContentSize(975,490)
	return layer
end)

function AccumulatedChongzhi:create( params )
	return AccumulatedChongzhi.new( params )
end

function AccumulatedChongzhi:ctor( params )
    self._activityType = params.activityType
	self._size = self:getContentSize()
	self:initData( params )
	self:initUI()
end

function AccumulatedChongzhi:onEnter( ... )
	if self.id == 27 then
		zc.addEventListener({
	        name = CUSTOM_EVENT.EVENT_DANCHONG,
	        callback = function(data)
		        if tolua.isnull(self) then
		        	return
		        end
	        	dump(data,"---test---")
	        	self:initData(data.data)
	        	self._tableview:reloadData()
	        end
	    })
	end
end

function AccumulatedChongzhi:onExit( ... )
	if self.id == 27 then
		zc.removeEventListener( CUSTOM_EVENT.EVENT_DANCHONG )
	end
end

function AccumulatedChongzhi:initData( params )
	-- dump(params)
	self.id = params.id or 22
	self._stateTable = {}
	if self.id == 27 then
		self.openStatus = params.awardTimes
		local single_saleData = gameData.getDataFromCache("single_sale")
		-- dump(single_saleData)
		for k,v in pairs(self.openStatus) do
			local data = single_saleData[k] or {}
			data.type = 27
			data.id = tostring(data.id)
			table.insert(self._stateTable,data)
		end
	else
		self._stateTable = params.table or {}
		self.openStatus = params.status
	end
	self:freshListData()
end

function AccumulatedChongzhi:freshListData( sType )
	local bt = {}
	for k,v in pairs(self._stateTable) do
		if tonumber(self.id) == tonumber(v.type) then
			table.insert(bt,v)
		end
	end
	self._nowShowList = bt
	self:sortData()
end

function AccumulatedChongzhi:sortData( ... )
	local list_1 = {}
	local list_2 = {}
	local list_all = {}
	self.total_can_get = 0
	for k,v in pairs(self._nowShowList) do
		if v then
			local status = tonumber(self.openStatus[v.id]) or 0
			-- id == 27 --0充值 >1 可领奖次数 -1已领完
			if self.id == 27 then
				if status >= 0 then
					self.total_can_get = self.total_can_get + status
					table.insert(list_1,v)
				else
					table.insert(list_2,v)
				end
			else
				if status > 0 then
					table.insert(list_1,v)
				else
					table.insert(list_2,v)
				end
			end
		end
	end
	print("cou 11.",self.total_can_get)
	table.sort(list_1, function( a, b )
		-- if not a or not b then return end
		local statusA = tonumber(self.openStatus[a.id]) or 0
		local statusB = tonumber(self.openStatus[b.id]) or 0
		if statusB ~= statusA then
			if self.id == 27 then
				return statusA > statusB
			else
				return statusA < statusB
			end
		else
			return tonumber(a.id) < tonumber(b.id)
		end
	end)
	
	for k,v in pairs(list_1) do
		table.insert(list_all,v)
	end

	table.sort(list_2, function( a, b )
		local statusA = tonumber(a.id) or 0
		local statusB = tonumber(b.id) or 0
		return statusA < statusB
	end)
	for k,v in pairs(list_2) do
		table.insert(list_all,v)
	end
	self._nowShowList = list_all
	-- dump(self._nowShowList,"self._nowShowList")
end

function AccumulatedChongzhi:initUI()
	self._tableviewSize = cc.size(955, 455)
	local tableview = zc.ZCTableView:create(self._tableviewSize)
    tableview:setBounceable( true )
    tableview:setInertia( true )
    tableview:setDirection( cc.SCROLLVIEW_DIRECTION_HORIZONTAL )
    tableview:setPosition( cc.p(20,35))
    tableview:setDelegate()
    tableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = 250
    local cellHeight = 455
    local function cellSizeForTable(table, index) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, index)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, cellWidth, cellHeight)
        end
        self:updateCell( cell, index + 1 )
        return cell
    end
    local function numberOfCellsInTableView()
    	return #self._nowShowList
    end
    tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    self:addChild(tableview)
    self._tableview = tableview
    tableview:reloadData()
    self:initAnimation()
end
-- 入场动画
function AccumulatedChongzhi:initAnimation()
	local cellWidth = 250
    local cellNum = math.ceil( self._tableviewSize.width/cellWidth )
    for i = 1, cellNum do
        local cell = self._tableview:cellAtIndex( i - 1 )
        if cell then
        	local cellPosY = cell:getPositionY()
        	local cellPosX = cell:getPositionX()
            cell:stopAllActions()
            cell:setPosition(self._tableviewSize.width + 300,cellPosY)
            cell:runAction(
                cc.Sequence:create(
                    cc.DelayTime:create( i*0.15 ),--math.sqrt( ( i - 1 )*0.05 ) ),
                    cc.EaseExponentialOut:create( cc.MoveTo:create( 0.8, 
                    	cc.p(cellPosX,cellPosY)))
                )
            )
        end
    end
end

function AccumulatedChongzhi:buildCell( cell, cellWidth, cellHeight)
	-- x,y,w,h
	local bg =  zc.createSprite("res/Main/limittimehot/leijiselect.png") 
	bg:setPosition( cellWidth/2,cellHeight/2)
	cell:addChild( bg )
	local bgSize = bg:getContentSize()
	cell._bg = bg
	-- 红条
	local tiao = zc.createSprite("res/Main/limittimehot/redtiao.png")
	tiao:setPosition(tiao:getContentSize().width/2,bgSize.height - 50)
	bg:addChild(tiao)
	-- title
	local label = zc.createLabel({
		text = "",
		fontSize = 20,
		ap = cc.p(0,0.5),
		color = cc.c3b(234,202,141),
		pos = cc.p(10,tiao:getContentSize().height/2),
		outLine = true,
	})
	tiao:addChild(label)
	cell.label = label
	-- num
	local numLable  = zc.createLabel({
		text = "100",
		fontSize = 26,
		ap = cc.p(0,0.5),
		color = cc.c3b(253,237,60),
		outLine = true,
		pos = cc.p(label:getPositionX() + label:getContentSize().width,tiao:getContentSize().height/2)
	})
	tiao:addChild(numLable)
	cell.numLable = numLable
	-- 元宝
	local info = zc._getIconInfo({
		data = {
			mainType = 1,
            type = 1, 
            id = 1,
		},
		scale = 0.5,
	})
	local yuanbao = zc.createSprite(info.img)
	yuanbao:setAnchorPoint(0,0.5)
	yuanbao:setPosition(tiao:getContentSize().width,tiao:getContentSize().height/2)
	tiao:addChild(yuanbao)
	cell.yuanbao = yuanbao

	local pos = {
		cc.p(80,bgSize.height - 150),
		cc.p(160,bgSize.height - 150),
		cc.p(80,bgSize.height - 250),
		cc.p(160,bgSize.height - 250),
	}
	local bg_list = {}
	-- icon
	for i = 1,4 do
		local _icon = zc.createIconByData({
				 data = {
		            mainType = 1,
		            type = 1, 
		            id = 1,
		        },
		        scale = 0.61,
		        pos = pos[i],
		        showCount = true
			})
		_icon:setTouchEndedShowTip()
		cell["_icon"..i] = _icon
		bg:addChild(_icon)
	end

    -- 按钮
    local str = LANGUAGE_TOLLGATEHERO.fetch_reward
	local btn = zc.createCommomBtn({
    	tag = 3,
    	fontSize = 30,
    	text = str,
    	needEnableWhenMoving = true,
    	needSwallow = false,
    	scale = 0.8,
    	pos = cc.p(bgSize.width/2, 70),
    	endCallback = function()
	    	
    	end,
	})
	bg:addChild(btn)

	-- 单冲按钮
	local danchongbtn = zc.createCommomBtn({
    	tag = 3,
    	fontSize = 30,
    	text = LANGUAGE_TOLLGATEHERO.fetch_reward,
    	needEnableWhenMoving = true,
    	needSwallow = false,
    	scale = 0.8,
    	pos = cc.p(bgSize.width/2, 70),
    	endCallback = function()
	    	
    	end,
	})
	bg:addChild(danchongbtn)
	cell.danchongbtn = danchongbtn

	-- 不足的
	local unGetImag = zc.createSprite("res/Main/limittimehot/xiaofei.png")
	unGetImag:setPosition(btn:getPosition())
	bg:addChild(unGetImag)
	local yiwancheng = zc.createSprite("res/Main/activity/monthSign/fetched.png")
	yiwancheng:setPosition(btn:getPosition())
	bg:addChild(yiwancheng)

	-- 可领取次数
	local timeslabel = zc.createLabel({
		text = zc.lang("can_get_times"),
		fontSize = 19,
		ap = cc.p(0.5,0.5),
		color = cc.c3b(255,242,199),
		outLine = true,
		pos = cc.p(danchongbtn:getPositionX(),danchongbtn:getPositionY() - danchongbtn:getContentSize().height/2 - 10)
	})
	bg:addChild(timeslabel)
	cell.timeslabel = timeslabel

	cell.yiwancheng = yiwancheng
	cell.unGetImag = unGetImag
	cell.btn = btn
end

function AccumulatedChongzhi:updateCell( cell, index )
	local _data = self._nowShowList[index]
	if not _data then return end  -- 判断为空时直接返回
	cell._data = _data
	if self.id == 27 then
		local reward = _data.rewards
		local _cont_arr = string.split(reward or "",",")
		local count = #_cont_arr
		print("count:",count)
		for i = 1,4 do
			if i <= count then
				local _data_cont_arr = string.split(_cont_arr[i] or "","|") 
				cell["_icon"..i]:setVisible(true)
				zc.updateIconByData(cell["_icon"..i], {
					data = {
						mainType = tonumber(_data_cont_arr[1]),
						type = _data_cont_arr[2],
						id = tonumber(_data_cont_arr[2]),
						num = tonumber(_data_cont_arr[3]),
					},	
					showCount = true
				})
				cell["_icon"..i]:setTouchEndedShowTip()
			else
				cell["_icon"..i]:setVisible(false)
			end
		end
	else
		for i = 1,4 do
			local reward = _data["reward"..i]
			if #reward ~= 0 then
				cell["_icon"..i]:setVisible(true)
				local _cont_arr = string.split(reward or "","|")
				zc.updateIconByData(cell["_icon"..i], {
					data = {
						mainType = tonumber(_cont_arr[1]),
						type = _cont_arr[2],
						id = tonumber(_cont_arr[2]),
						num = tonumber(_cont_arr[3]),
					},	
					showCount = true
				})
				cell["_icon"..i]:setTouchEndedShowTip()
			else
				cell["_icon"..i]:setVisible(false)
			end
		end
	end
	if self.id == 27 then
		cell.label:setString(zc.lang("danbi_cong"))
	else
		cell.label:setString(_data.name)
	end

	if self.id ~= 27 then
		local str
		if (tonumber(_data.type) == 23 or tonumber(_data.type) == 24) then
			str = "res/Main/limittimehot/xiaofei.png"
		else
			str = "res/Main/limittimehot/chongzhi.png"
		end 
		cell.unGetImag:setTexture(str)
	end
	local status = tonumber(self.openStatus[_data.id]) or 0
	-- 0 不可领取 1 -- 可领取 2 -- 已领取
	if self.id == 27 then
		cell.numLable:setString(_data.payNumber)
	else
		cell.numLable:setString(_data.parameter)
	end
	cell.numLable:setPositionX(cell.label:getPositionX() + cell.label:getContentSize().width + 2)
	cell.yuanbao:setPositionX(cell.numLable:getPositionX() + cell.numLable:getContentSize().width)
	if self.id == 27 then
		local status = self.openStatus[tostring(_data.id)] or 0
    	local text_
    	if status == 0 then -- 0充值 >1 领奖次数 -1已领完
    		text_ = zc.lang("recharge")
    	elseif status >= 1 then
    		text_ = LANGUAGE_TOLLGATEHERO.fetch_reward
    	end
    	cell.danchongbtn:setString(text_)
    	cell.btn:setVisible(false)
    	cell.danchongbtn:setVisible(true)
    	cell.unGetImag:setVisible(false)
    	cell.yiwancheng:setVisible(false)

    	if status < 0 then
    		cell.danchongbtn:setVisible(false)
			cell.yiwancheng:setVisible(true)
    	end
    	if status <= 0 then
    		cell.timeslabel:setVisible(false)
    	else
    		cell.timeslabel:setVisible(true)
			local str_times = zc.lang("can_get_times").." "..status.." "..zc.lang("ci")
			cell.timeslabel:setString(str_times)
    	end
    	if status >= 0 then -- 0充值 >1 领奖次数 -1已领完
    		cell._bg:setTexture("res/Main/limittimehot/blue.png")
    	else
    		cell._bg:setTexture("res/Main/limittimehot/unblue.png")
    	end
    	cell.danchongbtn:setTouchEndedCall(function()
    		if status == 0 then
    			LayerManager.backToMainCity(false)
    			zc.createRechargePop()
    		else
    			if status > 0 then
	    			zc.sendHttp({
			    		apiName = "HotTime_DanChong_Get",
			    		params = {id = (_data.id)},
			    		successCallback = function( net_data )
			    			-- dump(net_data)
			    			self.openStatus = net_data.awardTimes
			    			-- PlayerData:updataData(net_data)
			    			zc.createShowReward(net_data)
			    			dump(self.openStatus)
			    			self:sortData()
			    			self._tableview:reloadData()
			    			print("refresh cou .",self.total_can_get)
			    			if self.total_can_get <= 0 then
			    				PlayerData:updateRedDotData(15,0)
			    				zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_LIMINT_HOT,data = {id = 27}})
			    			end
			    		end
					})
    			end
    		end
		end)
    else
    	cell.timeslabel:setVisible(false)
    	cell.yiwancheng:setVisible(true)
    	cell.unGetImag:setVisible(true)
    	cell.danchongbtn:setVisible(false)
    	cell.btn:setVisible(true)
		cell.btn:setTouchEndedCall(function ()
			zc.sendHttp({
	    		apiName = "RechargeFirst_get",
	    		params = {type = (_data.type),id = (_data.id)},
	    		successCallback = function( net_data )
	    			dump(net_data)
	    			self.openStatus = net_data.status
	    			net_data.noAnimation = true
	    			PlayerData:updataData(net_data)
	    			zc.createShowReward(net_data)
	    			dump(self.openStatus)
	    			self:sortData()
	    			self._tableview:reloadData()
	    		end
			})
		end)
		cell._bg:setTexture("res/Main/limittimehot/leijiselect.png")
		if status == 0 then
			cell.btn:setVisible(false)
			cell.unGetImag:setVisible(true)
			cell.yiwancheng:setVisible(false)
			cell._bg:setTexture("res/Main/limittimehot/leijiunselect.png")
		elseif status == 1 then
			cell._bg:setTexture("res/Main/limittimehot/leijiselect.png")
			cell.btn:setVisible(true)
			cell.unGetImag:setVisible(false)
			cell.yiwancheng:setVisible(false)
		elseif status == 2 then
			cell._bg:setTexture("res/Main/limittimehot/leijiunselect.png")
			cell.btn:setVisible(false)
			cell.unGetImag:setVisible(false)
			cell.yiwancheng:setVisible(true)
		end
	end
end
return AccumulatedChongzhi