--  Created by wangming on 17-02-24.
local jixielongche = class("jixielongche", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function jixielongche:create(params)
	return jixielongche.new(params)
end

function jixielongche:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.ATK then
		for k,hero in pairs(hurtTargets) do
			local point  		= hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "jixielongche" , actName = "atk_1", loop = true, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete and (movementID == "atk_2" ) then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
		    if self:getSide() == BATTLE_SIDE.LEFT then
		    	armature:setScaleX(-1 * armature:getScaleX())
		    end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				_arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)
			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("atk_2")
    			self:doHurt(params)
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	else
		self:doHurt(params)
	end
end

function jixielongche:shouldMoveAttack(atkName)
	if atkName == BATTLE_ANIMATION_ACTION.SUPER then
    	return true
    end
	return false
end

function jixielongche:getAttackPoint(skillType, targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	local _x = 0
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
        _x = -200
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	if skillType == 3 then
		local _position = targetHero:getBattlePosition()
		if inArray(_position, {1, 4, 7}) then
			_position = 1
		elseif inArray(_position, {2, 5, 8}) then
			_position = 2
		else
			_position = 3
		end
    	y = zc.battle.getInitialMatrixPoint({side = targetHero:getSide(), position = _position}).y
	end
	-- dump(denfenser_point,"denfenser_point")
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
		_x = -_x
	end
	local pos 				= cc.p(x + _x, y)
	return pos
end

function jixielongche:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 1 then
		count = 3
	elseif skillType == 3 then
		count = 5
	end
	return count
end

function jixielongche:showDefenseEffect( params)
	local skillType = params.skillType
	local hero 		= params.hero
    
    if skillType == BATTLE_SKILL_TYPE.SUPER then
    	local runningScene 	= cc.Director:getInstance():getRunningScene()
    	local armature = zc.battle.createBattleEffect({fileName = "jixielongche", actName = "atk3_1", loop = false, moveCallback = function (armatureBack,movementType,movementID)
            if movementType == ccs.MovementEventType.complete and (movementID == "atk3_1") then
                xpcall(function() armatureBack:removeFromParent() end, function ()
                    print("armatureBack已被删除")
                end)
            end
        end})
	    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
	    if self:getSide() == BATTLE_SIDE.LEFT then
	    	armature:setScaleX(-1 * armature:getScaleX())
	    end
		zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature, zorder = hero:getLocalZOrder() + 1},
		})
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
    	self:showCommonDefenseEffect(params)
    end
end

return jixielongche




