-- 
local liubiao = class("liubiao", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function liubiao:create(params)
	return liubiao.new(params)
end

function liubiao:getSkillHurtCount(skillType)
	local count = 1
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		count = 2
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		count = 3
	end
	return count
end

function liubiao:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets
	local runningScene 	= cc.Director:getInstance():getRunningScene()

	if skillType == BATTLE_SKILL_TYPE.ATK then
		for k,hero in pairs(hurtTargets) do
			local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
		    local armature = zc.battle.createBattleEffect({fileName = "liubiao", actName = "atk_01", loop = false, moveCallback = function (armatureBack,movementType,movementID)
                if movementType == ccs.MovementEventType.complete then
                    xpcall(function() armatureBack:removeFromParent() end, function ()
                        print("armatureBack已被删除")
                    end)
                end
            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
            	if self:isAttackEvent(evt) and hero == hurtTargets[1] then
            		params.evt = evt
					self:doHurt(params)
            	end
            end})
		    armature:setPosition(self:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))
		    -- if self:getSide() == BATTLE_SIDE.LEFT then
		    -- 	armature:setScaleX(-1 * armature:getScaleX())
		    -- end
		    local _arrow = armature
			--起始位置
			local _targetSlot    	= cc.p(self:getPositionX(),self:getPositionY())
			--目标位置
			local endPos 			= point
			--计算角度
			-- 判定斜率,非弓箭状态
			local deltaY = endPos.y - _targetSlot.y;
			local deltaX = endPos.x - _targetSlot.x;
			local angel = deltaX > 0 and 0 or 180;
			local K = deltaY / deltaX;
			if deltaX ~= 0 then
				-- _arrow:setRotation(angel-CC_RADIANS_TO_DEGREES(math.atan(K)));
			end
			local pos_delta = cc.pGetDistance(endPos, _targetSlot)
			local dt = zc.getDynamicTime(pos_delta, 4000)

			_arrow:runAction(cc.Sequence:create(cc.MoveTo:create(dt,endPos),cc.CallFunc:create(function()
				armature:getAnimation():play("atk_02")
			end)))
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = _arrow, zorder = hero:getLocalZOrder() + 1},
			})
		end
	elseif skillType == BATTLE_SKILL_TYPE.SUPER then
		for k,hero in pairs(hurtTargets) do
			if string.find(evt,"hit0") then
				if hero == hurtTargets[1] then
					local point_2 = hero:getSlotPositionInNode(BATTLE_BONE_NAME.TOP, runningScene)
				    local armature_2 = zc.battle.createBattleEffect({fileName = "liubiao", actName = "atk3_01", loop = false, moveCallback = function (armatureBack,movementType,movementID)
		                if movementType == ccs.MovementEventType.complete then
		                    xpcall(function() armatureBack:removeFromParent() end, function ()
		                        print("armatureBack已被删除")
		                    end)
		                end
		            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
		            	
		            end})
				    armature_2:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.TOP, runningScene))
				    armature_2:setPositionY(zc.height + 10)
					zc.dispatchEvent({
						name = EVENT_NAME_BATTLE_PLAY_EFFECT,
						data = {node = armature_2, zorder = hero:getLocalZOrder() + 2},
					})
				end
			else
				local point = hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene)
			    local armature = zc.battle.createBattleEffect({fileName = "liubiao", actName = "atk3_02", loop = false, moveCallback = function (armatureBack,movementType,movementID)
	                if movementType == ccs.MovementEventType.complete then
	                    xpcall(function() armatureBack:removeFromParent() end, function ()
	                        print("armatureBack已被删除")
	                    end)
	                end
	            end, eventCallback = function(bone, evt, originFrameIndex, currentFrameIndex)
	            	zc.battle.doShockAndFlash(evt)
	            	if self:isAttackEvent(evt) and hero == hurtTargets[1] then
	            		params.evt = evt
						self:doHurt(params)
	            	end
	            end})
			    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.ROOT, runningScene))
				zc.dispatchEvent({
					name = EVENT_NAME_BATTLE_PLAY_EFFECT,
					data = {node = armature, zorder = hero:getLocalZOrder() + 1},
				})
			end
		end
	else
		self:doHurt(params)
	end
end

function liubiao:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		-- local runningScene 		= cc.Director:getInstance():getRunningScene()
		-- local armature = zc.battle.createBattleEffect({fileName = "liubiao", actName = "atk3_02", autoRemove = true})
	 --    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))			
	 --    zc.dispatchEvent({
		-- 	name = EVENT_NAME_BATTLE_PLAY_EFFECT,
		-- 	data = {node = armature , zorder = hero:getLocalZOrder() + 30},
		-- })
		-- hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	elseif skillType == BATTLE_SKILL_TYPE.ATK then
	    local runningScene 		= cc.Director:getInstance():getRunningScene()
		local armature = zc.battle.createBattleEffect({fileName = "liubiao", actName = "atk_02", autoRemove = true})
	    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))			
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = hero:getLocalZOrder() + 30},
		})
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	elseif skillType == BATTLE_SKILL_TYPE.ATK0 then
		local runningScene 		= cc.Director:getInstance():getRunningScene()
		local armature = zc.battle.createBattleEffect({fileName = "liubiao", actName = "atk0_01", autoRemove = true})
	    armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID, runningScene))			
	    zc.dispatchEvent({
			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
			data = {node = armature , zorder = hero:getLocalZOrder() + 30},
		})
		hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
	end

end


-- function liubiao:isSkillEventAllDone(skillType,evt)
-- 	local ret = true
-- 	-- if skillType == 3 then
-- 	-- 	if not string.find(evt,"hit3") then
-- 	-- 		ret = false
-- 	--     end 
-- 	-- end
-- 	return ret
-- end

function liubiao:shouldMoveAttack(atkName)
	local ret = false
	if atkName == BATTLE_ANIMATION_ACTION.ATK0 then
		ret = true
	end
	return ret
end


return liubiao