--  Created by zhangchao on 16-03-29.
local nanzhu = class("nanzhu", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function nanzhu:create(params)
	return nanzhu.new(params)
end

function nanzhu:doAnimationEvent(evt)
	if evt == "change" then
		local armature = self:getArmature()
		if armature:getBone("weapons") then
			do
				local _bone = armature:getBone("change")
				local armature = zc.battle.createBattleEffect({fileName = "change" , actName = "change" , autoRemove = true, completeCallback = function()					
				end})
			    _bone:addDisplay(armature, 0)
                _bone:changeDisplayWithIndex( 0, true )
                _bone:getDisplayRenderNode():setCascadeOpacityEnabled( false )
                _bone:setOpacity( 255 )
			end

			local data = {}
			zc.dispatchEvent({name = EVENT_NAME_BATTLE_GET_GUIDEINFO,data = data})
			local weaponId = 1003
			if data.guide1 
			  or data.guide2 
			  or data.guide3 
			  or data.guide5 
			  then
			  	weaponId = 9
		    elseif data.guide6 then
		    	weaponId = 1004
		    end
			zc.soldierChangeWeapon(armature, weaponId)
		else
	    	print(self._heroName.."不存在weapons******************************************")
	    end
	elseif evt == "change2" then
		local data 	= {}
	    zc.dispatchEvent({name = EVENT_NAME_BATTLE_GET_ALL_HEROES,data = data})
		local all_heroes = data.heroes
		if all_heroes then
			for k,hero in pairs(all_heroes) do
				if hero:getResourceId() == "nanzhu_shan" then
					hero:playAction("change2_done", false)
					hero:setVisible(true)
					self:setVisible(false)
					self:setAlive(false)
					hero:setColor(cc.c3b(255,255,255))
					break;
				end
			end
		end
	end
end

function nanzhu:isSkillEventAllDone(skillType,evt)
	local ret = true
	if skillType == 2 then
		if not string.find(evt,"hit15") then
			ret = false
	    end 
	elseif skillType == 3 then
		if not string.find(evt,"hit5") then
			ret = false
	    end 
	end
	return ret
end

function nanzhu:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 15
	elseif skillType == 3 then
		count = 5
	end
	return count
end

function nanzhu:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.SUPER then
		local flag = 0
		local ret = self:isSkillEventAllDone(skillType,evt)
		if evt == "hit_fly" then
			flag = flag + 1
			local _tmp_ = flag
			for k,hero in pairs(hurtTargets) do
				local point = hero:getInitialPoint()
				-- hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
				local _shadow = hero:getArmature():getBone(hero:getResourceId().."_shadow")
				if not tolua.isnull( _shadow ) then
					-- _shadow:getDisplayManager():setVisible( false )
					local _posX, _posY = _shadow:getPosition()
					_posX, _posY = 0, 0
					_shadow:stopAllActions()
					_shadow:runAction(
						cc.Sequence:create(
							cc.Spawn:create(
								cc.EaseExponentialOut:create( cc.MoveTo:create(0.5, cc.p(_posX, _posY - 100)) ),
								cc.ScaleTo:create( 0.5, 0.85 )
							),
							cc.Spawn:create(
								cc.EaseExponentialIn:create( cc.MoveTo:create(0.5, cc.p(_posX, _posY)) ),
								cc.ScaleTo:create( 0.5, 1 )
							)
						)
					)
				else
					print("~~~~~~~~~~~~~~~~~~~~~"..hero:getResourceId().."_shadow not exist")
				end
				hero:runAction(
					cc.Sequence:create(
						cc.CallFunc:create(function()
							hero:playAction("hit_fly",true)
						end),
						cc.EaseExponentialOut:create( cc.MoveTo:create(0.5, cc.p(point.x, point.y+100)) ),
						cc.CallFunc:create(function()
							hero:playAction("hit_down",true)
						end),
						cc.EaseExponentialIn:create( cc.MoveTo:create(0.5, cc.p(point.x, point.y)) ),
						cc.CallFunc:create(function()
							hero:playAction("hit_rise",false)
							if ret and _tmp_ == 1 then
				    			self:doHurt(params)
				    		end
						end)
					)
				)
			end
		else
			self:doHurt(params)
		end
	else
		self:doHurt(params)
	end
end

return nanzhu




