--  Created by wangming on 17-01-18.
local zhoutai = class("zhoutai", function ( params )
	local hero = BattleHero.new(params)
	return hero
end)

function zhoutai:create(params)
	return zhoutai.new(params)
end

function zhoutai:getSkillHurtCount(skillType)
	local count = 1
	if skillType == 2 then
		count = 2
	elseif skillType == 3 then
		count = 9
	end
	return count
end

function zhoutai:showDefenseEffect(params)
	local skillType = params.skillType
	local hero 		= params.hero    
    local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.SUPER then
    	
    	hero:playAction(BATTLE_ANIMATION_ACTION.DEFENSE)
	else
		self:showCommonDefenseEffect(params)
    end
end

function zhoutai:doAttack(params)
	local skillType 	= params.skillType
	local process 		= params.process
	local evt     		= params.evt
	local hurtTargets   = params.hurtTargets

	local runningScene 	= cc.Director:getInstance():getRunningScene()
	if skillType == BATTLE_SKILL_TYPE.SUPER and evt == "do_atk3_hit" then
		for k,hero in pairs(hurtTargets) do
			local armature = zc.battle.createBattleEffect({
				fileName = "zhoutai",
				actName = "atk3_1",
				moveCallback = function(armatureBack,movementType,movementID)
	                if movementType == ccs.MovementEventType.complete and (movementID == "atk3_1" ) then
	                    xpcall(
	                    	function()
	                    		armatureBack:removeFromParent()
	                    	end,
	                    	function()
	                            print("armatureBack已被删除")
	                        end
                        )
	                end
	            end,
	            eventCallback = function(bone, evt)
	            	
	            end,
            })
			armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
            if self:getSide() == BATTLE_SIDE.LEFT then
				armature:setScaleX(-1)
			end
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = hero:getLocalZOrder() + 1},
			})
			local armature = zc.battle.createBattleEffect({
				fileName = "zhoutai",
				actName = "atk3_2",
				moveCallback = function(armatureBack,movementType,movementID)
	                if movementType == ccs.MovementEventType.complete and (movementID == "atk3_2" ) then
	                    xpcall(
	                    	function()
	                    		armatureBack:removeFromParent()
	                    	end,
	                    	function()
	                            print("armatureBack已被删除")
	                        end
	                    )
	                end
	            end,
	        })
			armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
	        if self:getSide() == BATTLE_SIDE.LEFT then
				armature:setScaleX(-1)
			end
			zc.dispatchEvent({
				name = EVENT_NAME_BATTLE_PLAY_EFFECT,
				data = {node = armature, zorder = hero:getLocalZOrder() + 1},
			})
		end
		self:doHurt(params)
	-- elseif skillType == BATTLE_SKILL_TYPE.SUPER and evt == "do_atk3_hit9" then
	-- 	local ret = self:isSkillEventAllDone(skillType,evt)
	-- 	for k,hero in pairs(hurtTargets) do
	-- 		local armature = zc.battle.createBattleEffect({
	-- 			fileName = "zhoutai",
	-- 			actName = "atk3_3",
	-- 			moveCallback = function(armatureBack,movementType,movementID)
	--                 if movementType == ccs.MovementEventType.complete and (movementID == "atk3_3" ) then
	--                     xpcall(
	--                     	function()
	--                     		armatureBack:removeFromParent()
	--                     	end,
	--                     	function()
	--                             print("armatureBack已被删除")
	--                         end
 --                        )
	--                 end
	--             end,
	--             eventCallback = function(bone, evt)
	            	
	--             end,
 --            })
	-- 		armature:setPosition(hero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene))
 --            if self:getSide() == BATTLE_SIDE.LEFT then
	-- 			armature:setScaleX(-1)
	-- 		end
	-- 		zc.dispatchEvent({
	-- 			name = EVENT_NAME_BATTLE_PLAY_EFFECT,
	-- 			data = {node = armature, zorder = hero:getLocalZOrder() + 1},
	-- 		})
	-- 	end
	-- 	self:doHurt(params)
	else
		self:doHurt(params)
	end
end

function zhoutai:getAttackPoint(skillType, targetHero)
	local rect 			= BATTLE_BONE_NAME.RECT_ATK
	local _x = 0
	if skillType == 1 then --1.普通攻击
    elseif skillType == 2 then --2.小技能 
        rect 			= BATTLE_BONE_NAME.RECT_ATK0
    elseif skillType == 3 then--3.士气技能 大招
        rect 			= BATTLE_BONE_NAME.RECT_SUPER
    elseif skillType == 4 then
        --4.合体技
    end
    local runningScene 		= cc.Director:getInstance():getRunningScene()
	local y 				= targetHero:getPositionY()
	local denfenser_point 	= targetHero:getSlotPositionInNode(BATTLE_BONE_NAME.MID,runningScene)
	if skillType == 3 then
		local _position = targetHero:getBattlePosition()
		if inArray(_position, {1,4,7}) then
			_position = 1
		elseif inArray(_position, {2, 5, 8}) then
			_position = 2
		else
			_position = 3
		end
		denfenser_point = zc.battle.getInitialMatrixPoint({side = targetHero:getSide(), position = _position})
		_x = -30
	end
	local attackerMidBox	= self:getBoneBoundingBoxByName(rect)
	local x 				= denfenser_point.x - attackerMidBox.width / 2
	if self:getSide() == BATTLE_SIDE.RIGHT then
		x 					= denfenser_point.x + attackerMidBox.width / 2
		_x = -_x
	end
	
	local pos 				= cc.p(x + _x, y)
	return pos
end

return zhoutai




