--[[
	FileName: StarBoxPop.lua
	Author: andong
	Date: 2016-03-17
	Purpose: xx弹窗
]]
local StarBoxPop = class( "StarBoxPop", function ()
    return ZCPopLayer:create()
end)
function StarBoxPop:create(params)
	return StarBoxPop.new(params)
end
function StarBoxPop:ctor(params)
	-- dump(params, "params=====")
    if params.hideCall then
        self:setHideCallback(params.hideCall)
    end
	self:initData(params)
	self:initUI()
	self:show()
end
function StarBoxPop:initData(params)
	local static = gameData.getDataFromCache("starTreasure", {["chapterId"]=params.chapterId or 1} )
	-- dump(static, "static======")
	self._treasureInfo = static
	self._chapterId = params.chapterId
    self._chapterInfo = PlayerData:getCopyInfoByChapterId(params.chapterId) or {}
    self._callback = params.callback
    -- dump(self._chapterInfo, "self._chapterInfo ~~~~~~~~~~~~~~~ ")
    
    self:getScrollIndx()
end
function StarBoxPop:getScrollIndx()
	self._toGetIndx = nil --如果有可以领取的滑到可领取的地方
	self._toNotIndx = nil --如果没有可领取的有未完成的滑到未完成的位置
    if self._chapterInfo["gift"] then
    	for i = 1, table.nums(self._chapterInfo["gift"]) do
    		if tonumber(self._chapterInfo["gift"][tostring(i)]) ~= 2 then
    			if tonumber(self._chapterInfo["gift"][tostring(i)]) == 1 then
    				self._toGetIndx = i --如果有可以领取的
    				break
    			else
    				if not self._toNotIndx then
    					self._toNotIndx = i --如果有没有完成的
    				end
    			end
    		end
    	end
    end 
end
function StarBoxPop:initUI()
    local popBg = zc.createSprite("res/Main/wushenTower/pop_reward.png")
    popBg:setPosition(zc.width/2, zc.height/2)
    self:addContent(popBg)
    self._popBg = popBg
    self._popSize = popBg:getContentSize()
    local close = zc.createBackButton({
        pos = cc.p(popBg:getContentSize().width-10, popBg:getContentSize().height-10),
        listener = function () 
            self:hide()
        end,
    })
    popBg:addChild(close)
    self._closeBtn = close

    self:createTableView()

end
function StarBoxPop:createTableView()
    local tableSize = cc.size(435, 200)
    local tableNode = self._popBg
    local myTableBg = ccui.Scale9Sprite:create(cc.rect(26,25,1,1), "res/Main/wushenTower/pop_tableBg.png")
    myTableBg:setContentSize(tableSize)
    myTableBg:setAnchorPoint(cc.p(0.5, 0.5))
    myTableBg:setPosition(cc.p(tableNode:getContentSize().width/2, tableNode:getContentSize().height/2 + 20))
    tableNode:addChild(myTableBg)
    local myTable = zc.ZCTableView:create(cc.size(myTableBg:getContentSize().width-4,myTableBg:getContentSize().height-4))
    myTable:setPosition(2,2)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(true)
    myTable:setAutoAlign(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_HORIZONTAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    
    myTableBg:addChild(myTable)
    
    local function cellSizeForTable(table,idx)
        return tableSize.height-4, tableSize.width-4
    end
    local function numberOfCellsInTableView(table)
        return #self._treasureInfo
    end
    local function tablePageAfterSliding( table, cell )
    	local currentPage = table:getCurrentPage()
    	self:createGetButton(tonumber(currentPage)+1)
        local nowIdx = currentPage+1
        if nowIdx <= 1 then
            self._leftBtn:setVisible(false)
            self._rightBtn:setVisible(true)
        elseif nowIdx >= #self._treasureInfo then
            self._leftBtn:setVisible(true)
            self._rightBtn:setVisible(false)
        else
            self._leftBtn:setVisible(true)
            self._rightBtn:setVisible(true)
        end
    end
    local function tableCellAtIndex(table,idx)
        local nowIdx = idx + 1
        local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(cc.size(tableSize.width-4, tableSize.height-4))
        else
            cell:removeAllChildren()
        end
        xpcall(function()
            self:updateCell(cell, nowIdx)
        end, function() end)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    myTable:registerScriptHandler(tablePageAfterSliding,zctech.TABLECELL_AFTER_SLIDING)
    
    myTable:reloadData()
    self._myTable = myTable

    --左右 button
    local leftBtn = zc.createPushButton({
        normalFile = "res/Main/common/arrow_left.png",
        selectedFile = "res/Main/common/arrow_left.png",
        needSwallow = true,
        needEnableWhenMoving = true,
        touchSize = cc.size(60, 70),
        endCallback = function()
            local nowIdx = myTable:getCurrentPage()
            if nowIdx > 0 then
                myTable:scrollToCell(nowIdx-1, true)
            end
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(-50, tableSize.height/2)
    })
    myTableBg:addChild(leftBtn,11) 
    leftBtn:setVisible(false)

    local rightBtn = zc.createPushButton({
        normalFile = "res/Main/common/arrow_right.png",
        selectedFile = "res/Main/common/arrow_right.png",
        needSwallow = true,
        needEnableWhenMoving = true,
        touchSize = cc.size(60, 70),
        endCallback = function()
            local nowIdx = myTable:getCurrentPage()
            if nowIdx < 3 then
                myTable:scrollToCell(nowIdx+1, true)
            end
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(tableSize.width+50, tableSize.height/2)
    })
    myTableBg:addChild(rightBtn, 11)

    self._rightBtn = rightBtn
    self._leftBtn = leftBtn

    leftBtn:getStateNormal():setOpacity(0)
    rightBtn:getStateNormal():setOpacity(0)

    leftBtn:runAction(cc.Sequence:create(
        cc.Spawn:create(cc.MoveBy:create(0.4, cc.p(50, 0)),cc.CallFunc:create(function()
            leftBtn:getStateNormal():runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))
        end))
    ))
    rightBtn:runAction(cc.Sequence:create(
        cc.Spawn:create(cc.MoveBy:create(0.4, cc.p(-50, 0)),cc.CallFunc:create(function()
            rightBtn:getStateNormal():runAction(cc.Sequence:create(cc.FadeIn:create(0.4)))
        end)),
        cc.DelayTime:create(0.1),
        cc.CallFunc:create(function()
            leftBtn:runAction(
                cc.RepeatForever:create(cc.Sequence:create(
                    cc.MoveBy:create(0.8, cc.p(10,0)),
                    cc.MoveBy:create(0.8, cc.p(-10,0))
                ))
            )
            rightBtn:runAction(
                cc.RepeatForever:create(cc.Sequence:create(
                    cc.MoveBy:create(0.8, cc.p(-10,0)),
                    cc.MoveBy:create(0.8, cc.p(10,0))
                ))
            )
        end)
    ))

    -- performWithDelay(self, function()
        if self._toGetIndx then
            self._myTable:scrollToCell(self._toGetIndx-1, false)
        elseif self._toNotIndx then
            self._myTable:scrollToCell(self._toNotIndx-1, false)
        end
    -- end, 0.1)
end

function StarBoxPop:updateCell(cell, nowIdx)

	local cellSize = cell:getContentSize()
	local cellData = self._treasureInfo[nowIdx]
	-- dump(cellData, "self._treasureInfo =============== ")
	local myLab = zc.createLabel({
	    text = zc.lang("achieve") .. cellData.starNumber .. zc.lang("star_reward"),
	    outLine = true,
	    fontSize = 22,
	    ap = cc.p(0.5, 0.5),
	    pos = cc.p(cellSize.width/2, 165),
	    color = display.COLOR_WHITE,
	    color2 = display.COLOR_BLACK,
	    align = kCCTextAlignmentCenter,
	    pixel = 1.3
	})
	cell:addChild(myLab)

	local _re = string.split(cellData["boxReward"], ",")

    local _length = #_re
    local canTouch = _length > 3 and true or false
    local _innerWidth = (_length - 1) * 140 + 110
    local myscrollview = zc.createScrollview({
        size = cc.size(cellSize.width-10, 120),
        innerSize = cc.size(_innerWidth, 120),
        dir = ccui.ScrollViewDir.horizontal,
        bounceEnable = canTouch,
        touchEnable = true,
    })
    cell:addChild(myscrollview)
    myscrollview:setPosition(5, 20)
    if _length == 1 then
        myscrollview:setPositionX(165)
    elseif _length == 2 then
        myscrollview:setPositionX(100)
    elseif _length == 3 then
        myscrollview:setPositionX(30)
    end

	for i = 1, _length do
		local reward = string.split(_re[i], "|")
	    local item, info = zc.createIconByData({
	        data = {
	            mainType = reward[1],
	            type = reward[2], 
	            id = reward[2],
	            num = reward[3],
	        }, 
	        showDetailPop = true,
	        pos = cc.p(55+(i-1)*130 , 60), 
	        color = iconcolor
	    })
	    item:setScale(0.9)
	    myscrollview:addChild(item)
	end

	if nowIdx == 1 then
    	self:createGetButton(nowIdx)
	end

end
function StarBoxPop:createGetButton(_nowPage)
	if self._getBtn then
		self._getBtn:removeFromParent()
        self._getBtn = nil
	end
	if _nowPage < 1 or _nowPage > #self._treasureInfo then
		return
	end
    local getBtn = zc.createCommomBtn({
        tag = 1,
        text = "",
        needSwallow = true,
        endCallback = function()
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(self._popSize.width/2, 61)
    })
    self._popBg:addChild(getBtn)
    self._getBtn = getBtn

    if self._chapterInfo and self._chapterInfo["gift"] then
    	local gift = self._chapterInfo["gift"]
    	local state = tonumber(gift[tostring(_nowPage)])
    	if state == 0 then
    		getBtn:setEnable(false)
    		getBtn:setText(zc.lang("un_finish"))
    	elseif state == 1 then
    		getBtn:setEnable(true)
    		getBtn:setText(zc.lang("fetch"))
    		getBtn:setTouchEndedCall(function() 
    			zc.sendHttp({
                    apiName = "Tollgate_getStarTreasure",
                    params = {chapterId=self._chapterId,id=_nowPage},
                    successCallback = function (net_data)
    			        local _currentGID = getGuideManager():getCurrentGID()
                        if _currentGID == GuideKey.KEY_4008 then
                            zc.setGuideFuncNextStep(_currentGID)
                        end
                        if getBtn and not tolua.isnull(getBtn) then
                    		getBtn:setEnable(false)
        					getBtn:setText(LANGUAGE_TOLLGATEHERO.fetched)
                        end
    					self._chapterInfo["gift"][tostring(_nowPage)] = 2
    					if self._callback then
    						self._callback()
    					end
    					--重置状态
    					self:getScrollIndx()
    					local function endhandle()
                            local _currentGID = getGuideManager():getCurrentGID()
                            if _currentGID == GuideKey.KEY_4009 then
                                getGuideManager():setObjTarget(self._closeBtn)
                                getGuideManager():startGuide()
                            end
                            if not self._toGetIndx and not self._toNotIndx then
						      self:hide()
                            elseif self._toGetIndx then
						    	self._myTable:scrollToCell(self._toGetIndx-1, true)
						    elseif self._toNotIndx then
						    	self._myTable:scrollToCell(self._toNotIndx-1, true)
						    end
						end
						--奖励
	                    zc.createShowReward({
	                        clientItems = net_data.clientItems,
	                        clientResources = net_data.clientResources,
	                        callback = endhandle
	                    })
	                    net_data.noAnimation = true
	    				PlayerData:updataData(net_data)
    			    end,
    			})
    		end)
    	elseif state == 2 then
    		getBtn:setEnable(false)
    		getBtn:setText(LANGUAGE_TOLLGATEHERO.fetched)
    	end
    end
end

function StarBoxPop:onEnter()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_4008 then
        getGuideManager():addMaskLayer()
        performWithDelay(self, function()
            getGuideManager():removeMaskLayer()
            if self._getBtn:isEnable() then
                getGuideManager():setObjTarget(self._getBtn)
                getGuideManager():startGuide()
            else
                getGuideManager():setCurrentGID(GuideKey.KEY_4009)
                getGuideManager():setObjTarget(self._closeBtn)
                getGuideManager():startGuide()
            end
        end, 0.3)
    end
end

return StarBoxPop