--[[
	武将说明弹窗
	唐实聪
	2016.4.27
]]
local HeroInfoPop = class("HeroInfoPop", function( params )
	if params.showHero then
		return zc.createNormalDialog({
			showYun = true,
			yunTag = 2,
			yunOffY = {0, -70},
			-- floweZorder = {3, -1, -1, -1},
			showFlowerFlag = {1, 0, 1, 1},
			closeCallBack = function()
                LayerManager.removeLayout(true)
			end,
		})
	else
		return ZCPopLayer:create()
	end
end)

function HeroInfoPop:create( params )
	return HeroInfoPop.new( params )
end

function HeroInfoPop:ctor( params )
	self:initData( params )
	self:initUI( params )
	if self._isShowHero then
		self:initShowHero()
	else
		self:getContainerLayer():setTouchEndedCallback(function() 
		    self:hide({noAction = true})
		end)
		self:show(false)
	end
end

function HeroInfoPop:initData( params )
	self._isShowHero = params.showHero
    self._isOthers = params.heroId
    
	if params.id then
		-- 已拥有的武将
		self._own = true
		self._heroData = PlayerData:getGeneralInfoById( params.id )
		self._heroData.attribute = self._heroData.attribute or {}
		-- dump(self._heroData, "self._heroData")
		self._weaponData = PlayerData:getWeaponsInfoById( params.id )
		-- dump(self._weaponData, "self._weaponData")
		self._heroList = gameData.getDataFromCacheWithPrimaryKey("hero", self._heroData.heroId)
		-- dump(self._heroList, "self._heroList")
		self._talentData = gameData.getDataFromCacheWithPrimaryKey("hero_talent", self._heroData.talentId)
		-- dump(self._talentData, "self._talentData")
		if tonumber( PlayerData.info.heroId or 0 ) == tonumber( params.id or 0 ) then
			self._isMainRole = true
		else
			self._isMainRole = false
		end
		-- 
		self._mainRoleName = PlayerData.info.userName
	elseif params.heroId then
		-- 未拥有的武将
		self._own = false
		self._heroData = gameData.getDataFromCacheWithPrimaryKey("hero", params.heroId, true)
		self._heroData.attribute = self._heroData
		self._heroList = self._heroData
		self._talentData = gameData.getDataFromCacheWithPrimaryKey("hero_talent", self._heroData.talentId)
		self._isMainRole = false
		self._mainRoleName = PlayerData.info.userName
		--静态武将，下面属性要算上天赋
		local attrKey = {
		    [1] = "hpLimit",
		    [2] = "attack",
		    [3] = "defense",
		    [4] = "attackStrategy",
		    [5] = "defenseStrategy",
		}
		local addKey = {
		    [1] = "hpLimitAdditionBase",
		    [2] = "attackAdditionBase",
		    [3] = "defenseAdditionBase",
		    [4] = "attackStrategyAdditionBase",
		    [5] = "defenseStrategyAdditionBase",
		}
		for i = 1, #attrKey do
			local _attr = attrKey[i]
			local _addAttr = addKey[i]
			local base = tonumber(self._heroData[_attr]) or 0
			local _addbase = tonumber(self._talentData[_addAttr]) or 0
			local newAttr = base
			-- if i == 1 then 
			-- 	local soma = tonumber(self._heroData["soma"]) or 0
			-- 	newAttr = base + base * soma * _addbase * 0.002
			-- else
			-- 	newAttr = base + base * _addbase
			-- end
			self._heroData[_attr] = newAttr
		end
	elseif params.heroData and params.weaponData and params.isMainRole ~= nil and params.name then
		-- 别人的武将
		self._own = true
		self._heroData = params.heroData
		self._heroData.attribute = self._heroData.attribute or {}
		-- dump(self._heroData, "self._heroData")
		self._weaponData = params.weaponData
		-- dump(self._weaponData, "self._weaponData")
		self._heroList = gameData.getDataFromCacheWithPrimaryKey( "hero", self._heroData.heroId)
		-- dump(self._heroList, "self._heroList")
		self._talentData = gameData.getDataFromCacheWithPrimaryKey("hero_talent", self._heroData.talentId)
		-- dump(self._talentData, "self._talentData")
		self._isMainRole = params.isMainRole
		-- 主角名字
		self._mainRoleName = params.name
	end

	self._weaponType = 1
	if self._isMainRole then
		-- 主角
		self._weaponType = self._weaponData.type or 1
	else
		self._weaponType = self._heroList.weaponType or 1
	end

	local _size = self:getContentSize()
	self._width = _size.width
	self._height = _size.height
end

function HeroInfoPop:initUI( params )
	-- 背景
    local _addH = 24
	local _bgWidth = 373
	local _bgHeight = 475 + 31 + _addH
	local _bg = zc.createNormalPop({
        tag = 1,
        titleTag = 1,
        height = _bgHeight,
        showSide = self._isShowHero,
    })

	if self._isShowHero then
		_bg:setPosition(self._width*0.75 + 20, self._height*0.5)
		self:addChild(_bg, 2)
	else
		_bg:setPosition(self._width*0.5, self._height*0.5)
		self:addContent(_bg)
	end

	-- 顶部
	local _topBgWidth = _bgWidth - 26
	local _topBgHeight = 130 + 15
    local _topBg = zc.createGeneralPopScale({
        width = _topBgWidth,
        height = _topBgHeight,
    })
	_topBg:setPosition( _bgWidth/2, _bgHeight - 152 )
	_bg:addChild( _topBg, 1 )

	-- 英雄介绍
	local _descBgWidth = _topBgWidth - 35
	local _descBgHeight = _topBgHeight - 30
	local _descBg = zc.createGeneralPopScale({
        tag = 2,
        width = _descBgWidth,
        height = _descBgHeight,
    })
	_descBg:setPosition( _topBgWidth/2, _topBgHeight/2 + 5 )
	_topBg:addChild( _descBg )
	-- 英雄介绍标题
	local _descTitle = cc.Sprite:create( "res/Main/role/attribute/heroDesc.png" )
    _descTitle:setPosition( _descBgWidth/2, _descBgHeight - 20 )
    _descBg:addChild( _descTitle )
    local _descTitleLeft = cc.Sprite:create( "res/Main/common/lace.png" )
    _descTitleLeft:setAnchorPoint( 1, 0.5 )
    _descTitleLeft:setPosition( 0, _descTitle:getContentSize().height/2 )
    _descTitle:addChild( _descTitleLeft )
    local _descTitleRight = cc.Sprite:create( "res/Main/common/lace.png" )
    _descTitleRight:setAnchorPoint( 0, 0.5 )
    _descTitleRight:setPosition( _descTitle:getContentSize().width, _descTitle:getContentSize().height/2 )
    _descTitleRight:setFlippedX( true )
    _descTitle:addChild( _descTitleRight )
    -- 英雄介绍文字
    local _descLabelWidth = 290
    local _descLabel = zc.createLabel({
    	text = ( self._talentData.name or "" ).."："..( self._talentData.desc or "" ),
    	width = _descLabelWidth,
		fontSize = 20,
        color = cc.c3b( 230, 224, 163 ),
    	align = cc.TEXT_ALIGNMENT_LEFT,
        ap = cc.p( 0, 1 ),
        pos = cc.p( ( _descBgWidth - _descLabelWidth )/2, _descBg:getContentSize().height - 37 ),
    })
    _descBg:addChild( _descLabel )

	-- 底部
	local _bottomBgWidth = _bgWidth - 26
	local _bottomBgHeight = 263 + _addH
	local _bottomBg = zc.createGeneralPopScale({
        tag = 3,
        width = _bottomBgWidth,
        height = _bottomBgHeight,
    })
	_bottomBg:setAnchorPoint( 0.5, 0 )
	_bottomBg:setPosition( _bgWidth/2, 15 )
	_bg:addChild( _bottomBg )

	-- 属性值
    local _features = string.split(self._heroData.feature or "", ",")
    local _type = tonumber(self._heroData.type) or 1
    if self._isMainRole and self._weaponData then
        _type = tonumber(self._weaponData.heroType) or 1
    end
    local _attrKey = {}
    for i = 1, 3 do
        _attrKey[#_attrKey + 1] = i
    end
    _attrKey[#_attrKey + 1] = 34
    _attrKey[#_attrKey + 1] = 27
    
    if _type == 1 then
        _attrKey[#_attrKey + 1] = 6
    else
        _attrKey[#_attrKey + 1] = 10
    end
    _attrKey[#_attrKey + 1] = 8
    _attrKey[#_attrKey + 1] = 12
    _attrKey[#_attrKey + 1] = 4
    if _type == 1 then
        _attrKey[#_attrKey + 1] = 7
    else
        _attrKey[#_attrKey + 1] = 11
    end
    _attrKey[#_attrKey + 1] = 9
    _attrKey[#_attrKey + 1] = 13
    _attrKey[#_attrKey + 1] = 5
    if _type == 1 then
        _attrKey[#_attrKey + 1] = 14
    else
        _attrKey[#_attrKey + 1] = 16
    end
    _attrKey[#_attrKey + 1] = 15
    _attrKey[#_attrKey + 1] = 17
    _attrKey[#_attrKey + 1] = 18
    _attrKey[#_attrKey + 1] = 20
    _attrKey[#_attrKey + 1] = 19



	local _attrLineHeight = 28
	for i, v in ipairs( _attrKey ) do
		local _attrY = _bottomBgHeight + 8 - _attrLineHeight*(math.ceil( i/2))

        local _text = zc.getEquipAttriNameByEffectType( v, true )
        if tonumber(v) == 6 or tonumber(v) == 8 or tonumber(v) == 10 or tonumber(v) == 12 then
            _text = zc.lang("base") .. _text
        elseif tonumber(v) == 4 then
            _text = zc.lang("base_hp")
        end
 
		local _attrText = zc.createLabel({
			text = _text..":",
	        fontSize = 20,
        	color = cc.c3b( 230, 224, 163 ),
	        ap = cc.p( 0, 0.5 ),
	        pos = cc.p( 10 + _bottomBgWidth/2*( 1 - i%2 ), _attrY ),
		})
		_bottomBg:addChild( _attrText )
		-- 属性加成
		local _attrAdd = self._heroData["attribute"][self:getAttrKeyByType( v )] or 0
        
		if v == 19 then
			_attrAdd = _attrAdd + 1.5
		end

        local _color = zc.COLOR_WHITE
        if i == _type then
            _color = zc.COLOR_RED
        else
            for k,value in pairs(_features) do
                if tonumber(v) == tonumber(value) then
                    _color = zc.COLOR_BLUE
                    break
                end
            end
        end
        local _num = zc.getAttributeNumById( v, _attrAdd )
        if v == 27 then
            -- dump(self._heroData)
            print("士气 ".. _num)
        end
        if tonumber(_num) then
            _num = zc.getWan(_num)
        end
        if _num and string.len(_num) == 0 then
            _num = 0
        end

		local _attrNum = zc.createLabel({
			text = _num or 0,
	        fontSize = 20,
	        color = _color,
	        ap = cc.p( 0, 0.5 ),
	        pos = cc.p( _attrText:getPositionX() + 95, _attrY ),
		})
		_bottomBg:addChild( _attrNum )
	end
end

function HeroInfoPop:initShowHero()
	local heroInfo = self._heroList
	local _dialog = cc.Node:create()
	self:addChild(_dialog, 1)

    local _skillTable = self:findSkillInfo(heroInfo)

    local _w_x = zc.width*0.5 - 210
    local _w_y = zc.height*0.5 - 110

    local _colorDi = zc.getSprite({
    	src = "res/Main/pub/pubColor.png",
    	ap = cc.p(0.5, 0),
    })
    _colorDi:setPosition(_w_x, _w_y - 50)
    _dialog:addChild(_colorDi) 

    local _heroImg = "res/Main/hero/body/"..tostring(heroInfo.picture)..".png"
    if not zc.checkFileExist(_heroImg) then
        _heroImg = "res/Main/hero/body/1.png"
    end
    local _hero = zc.getSprite({
    	src = _heroImg,
    	ap = cc.p(0.5, 0),
    	scale = 0.5,
    })
    _hero:setPosition(cc.p(_w_x, _w_y))
    _dialog:addChild(_hero) 


    local _heroHide = zc.getSprite({
    	src = "res/Main/pub/pubHide.png",
    	ap = cc.p(0.5, 1),
    })
    _heroHide:setPosition(_w_x, (zc.height*0.5 + 640*0.5))--_w_y))
    _dialog:addChild(_heroHide) 

    local _spine = zc.getSpine("juese_fazhen")
    _spine:setPosition(_w_x, _w_y)
    _dialog:addChild(_spine,1)
    -- _spine:setOpacity(255*0.5)

    local _zhenfaCircle = zc.getSprite({
        src = "res/Main/pub/zhenfaCircle.png",
        pos = cc.p(_w_x, _w_y + 20),
    })
    _dialog:addChild(_zhenfaCircle)
    _zhenfaCircle:runAction(cc.RepeatForever:create(cc.Sequence:create(
        cc.FadeTo:create(1.2, 255*0.6),
        cc.FadeTo:create(1.2, 255)
    )))

    local _qualityDi = zc.getSprite({
        src = "res/Main/talent/talentBg.png",
        pos = cc.p(80, 70),
    	scale = 0.42,
    })
    _dialog:addChild(_qualityDi, 1)

    local _qualitySp = zc.getSprite({
        src = zc.getHeroQualificationsPath(heroInfo.qualifications, 2),
        pos = cc.p(_qualityDi:getPosition()),  
    })
    _dialog:addChild(_qualitySp, 1)

    if #_skillTable == 4 then
        _qualityDi:setPosition(590,560)
        _qualitySp:setPosition(590,560)
    end

    local _nameDi = zc.createSprite("res/Main/smithy/clear/weaponNameBg.png")
    _nameDi:setPosition(_w_x + 160, _w_y + 270)
    _dialog:addChild(_nameDi) 
    local _nameLab = zc.createLabel({
    	text = heroInfo.name,
    	fontSize = 24,
    	width = 30,
    })
    _nameLab:setPosition(_nameDi:getContentSize().width*0.5, _nameDi:getContentSize().height*0.5 + 15)
    _nameDi:addChild(_nameLab)

    local _posTb =  {
        {-230, 158},
        {225, 165},
    }
    if #_skillTable == 3 then
        -- _posTb[2] = {220, 100}
        _posTb[3] = {80, -130}
    elseif #_skillTable == 4 then
        _posTb[3] = {-160, -150}
        _posTb[4] = {150, -140}
    end
    local _partH = 55
    for i=1, #_skillTable do
        local _item = zc.createIconByData({
            data = {
                mainType = zc.mainTypeSkill,
                type = -1, 
                id = _skillTable[i].id,
            }, 
            -- showName = true,
            pos = cc.p(_w_x + _posTb[i][1], _w_y + _posTb[i][2]),
        })
        _item:setScale(0.8)
        _dialog:addChild(_item) 
        local _pic = _item:getChildByName("pic")
        if _pic then
            _pic:setScale(1.35)
            _pic:setPositionY(_pic:getPositionY() - 2)
        end
        local _itemSize = _item:getContentSize()

        if _skillTable[i].isMax == 1 then --如果是合体
            local aoyi = zc.createSprite("res/Main/pub/aoyi.png")
            aoyi:setAnchorPoint(0.5, 1)
            aoyi:setPosition(_itemSize.width*0.5 , 30)
            _item:addChild(aoyi)
            local sp
            if _skillTable[i].id == _skillTable[i].combineSkillId then
                sp = zc.createSprite("res/Main/role/1.png")
            else
                sp = zc.createSprite("res/Main/role/2.png")
            end
            sp:setPosition(_itemSize.width*0.5 + 30 , 15)
            _item:addChild(sp)
        elseif _skillTable[i].isMax == 2 then --如果是大招
            local aoyi = zc.createSprite("res/Main/pub/critical.png")
            aoyi:setAnchorPoint(0.5, 1)
            aoyi:setPosition(_itemSize.width*0.5 , 30)
            _item:addChild(aoyi)
        end
        local _skillDesc = zc.buildSkillDesc(_skillTable[i].id, _skillTable[i].level)
        local _skillInfo = gameData.getDataFromCacheWithPrimaryKey("skill", _skillTable[i].id)
        local _heroId1 = tonumber(_skillInfo.heroId1) or 0
        if _heroId1 ~= 0 then
            local _heroInfo = gameData.getDataFromCacheWithPrimaryKey("hero", _heroId1)
            _skillDesc = LANGUAGE_heti_skill_tip(_heroInfo.name, _skillDesc)
        end
        local _label
        if i == 3 and #_skillTable == 3 then
            _label = zc.createLabel({
                text = _skillDesc,
                fontSize = 16,
                color = cc.c3b(255, 229, 200),
            })
            _label:setAnchorPoint(0, 0)
            if _label:getContentSize().width > 260 then
                _label:setWidth(260)
            end
            -- _label:setPosition(_w_x + _posTb[i][1] + 85, _w_y + _posTb[i][2] + _partH)
            _label:setPosition(_w_x + _posTb[i][1] - 70, _w_y + _posTb[i][2] + _partH)
        elseif i == 4 then
            _label = zc.createLabel({
                text = _skillDesc,
                fontSize = 16,
                color = cc.c3b(255, 229, 200),
            })
            _label:setAnchorPoint(0, 0)
            if _label:getContentSize().width > 260 then
                _label:setWidth(260)
            end
            -- _label:setPosition(_w_x + _posTb[i][1] + 85, _w_y + _posTb[i][2] + _partH)
            _partH = 55
            _label:setPosition(_w_x + _posTb[i][1] - 130, _w_y + _posTb[i][2] + _partH)
        else
            _label = zc.createRichLabel({
                text = _skillDesc,
                fontSize = 16,
                color = cc.c3b(255, 229, 200),
            })
            print("desc:",_skillDesc)
            if _label:getContentSize().width > 200 then
                if #_skillTable == 4 then
                    if i < 3  then
                        _label:setDimensions(cc.size(200, 500))
                    else
                        print("width:",_label:getContentSize().width)
                        if _label:getContentSize().width > 420 then
                            _label:setDimensions(cc.size(260, 58))
                        elseif _label:getContentSize().width > 200 and _label:getContentSize().width <= 420 then
                            _label:setDimensions(cc.size(260, 40))
                        else
                            _label:setDimensions(cc.size(260, 20))
                        end
                    end
                else
                    _label:setDimensions(cc.size(200, 500))
                end
            end
            _label:setAnchorPoint(0.5, 1)
            if #_skillTable == 4 then 
                if i < 3 then
                    _label:setPosition(_w_x + _posTb[i][1], _w_y + _posTb[i][2] - _partH)
                else
                    _label:setAnchorPoint(0.5, 0)
                    _label:setPosition(_w_x + _posTb[i][1],_item:getPositionY() + _item:getContentSize().height/2 - 10)
                end
            else 
                _label:setPosition(_w_x + _posTb[i][1], _w_y + _posTb[i][2] - _partH)
            end
            
        end
        _dialog:addChild(_label) 
    end
    _spine:playAction("idle", true)
end

--查找技能信息
function HeroInfoPop:findSkillInfo(heroInfo)
    local heroId = tonumber(heroInfo.id)
    if not heroId then
        return {}
    end
    local _params = {heroId = heroId}
    if self._own then
        _params.newAdvance = self._heroData.newAdvance
        _params.star = self._heroData.star
    end
    local _skillData = zc.getHeroSkillData(_params)

    local skillIdMap = {}
    for k,v in pairs(_skillData) do
        local _subType = tonumber(v.skillType) or 0
        if _subType == 3 then
            v.isMax = 2
            v.level = heroInfo.moraleSkillLevel
        elseif _subType == 4 then
            v.isMax = 1
            v.level = heroInfo.combineSkillLevel
        else
            v.isMax = 3
            for i=1, 5 do
                local _commonSkillId = tonumber(heroInfo["commonSkillId"..i]) or 0
                if _commonSkillId == v.id then
                    _flag = true
                    v.level = tonumber(heroInfo["commonSkillLevel"..i]) or 1
                    break
                end
            end
        end
    end

    table.sort(_skillData,function(a, b)
        return a.isMax < b.isMax
    end)

    return _skillData
end

-- 根据属性类型获取后端数据的key
function HeroInfoPop:getAttrKeyByType(type)
    local _type = tonumber( type or 1)

    local attrKey = {
        [1] = "force",
        [2] = "wisdom",
        [3] = "soma",
        -- [4] = "hpLimit",

        [4] = "hpLimitFoundation",
        [5] = "hpLimitAddition",
        -- [6] = "attack",
        [6] = "attackFoundation",
        [7] = "attackAddition",
        -- [8] = "defense",
        [8] = "defenseFoundation",

        [9] = "defenseAddition",
        -- [10] = "attackStrategy",
        [10] = "attackStrategyFoundation",

        [11] = "attackStrategyAddition",
        -- [12] = "defenseStrategy",
        [12] = "defenseStrategyFoundation",

        [13] = "defenseStrategyAddition",
        [14] = "hit",
        [15] = "dodge",
        [16] = "precision",
        [17] = "foresight",
        [18] = "crit",
        [19] = "critValue",
        [20] = "critResistance",
        [21] = "dizziness",
        [22] = "dizzinessResistance",
        [23] = "damageAddition",
        [24] = "damageDerate",
        [25] = "effectAddition",
        [26] = "effectDerate",
        -- [27] = "initMorale",
        --初始士气综合值 修改 新字段viewMorale-------------------------------
        [27] = "viewMorale", 
        [28] = "reduceMoraleResistance",
        [29] = "reverseDamage",
        [34] = "speed",
    }

    if self._isOthers then
        attrKey[4] = "hpLimit"
        attrKey[6] = "attack"
        attrKey[8] = "defense"
        attrKey[10] = "attackStrategy"
        attrKey[12] = "defenseStrategy"
    end

    return attrKey[_type]
end

return HeroInfoPop