--[[
-- 国家捐助
-- @author lph
-- Creation  2016-4-9
]]
local CountryContributePop = class("CountryContributePop", function ()
    return ZCPopLayer:create() 
end);

function CountryContributePop:create(params)
	local _countryContribute = CountryContributePop.new(params)
	return _countryContribute
end

function CountryContributePop:ctor(params)
    self:initData(params)
	self:initUI()
end

function CountryContributePop:initData(params)
	self._techdata = params.techData
	self._info = params.data
	self._callback = params.callback  --捐赠回调
    self._levelUp = params.levelUp    --升级回调
    self._country_positionId = PlayerData:getCountryInfo().countryPositionId   --职位
end
function CountryContributePop:getNowAndNextData()
        --等级效果
    if not self._staticTechInifo then
        self._staticTechInifo = gameData.getDataFromCache( "country_tech_level", {techId = self._techdata.techId} )
    end
    local _data = self._staticTechInifo
    local function findTechData(_level)
        for i = 1, #_data do
            local v = _data[i]
            if v and v.level then
                if tonumber(_level) == tonumber(v.level) then
                    return v
                end
            end
        end
        return nil
    end
    local _nowData = findTechData(self._techdata.level) or {}
    local _nextData = findTechData(tonumber(self._techdata.level)+1) or {}
    return _nowData, _nextData
end
function CountryContributePop:initUI()
	--通用背景
    local _contribute_bgSize = cc.size(632, 443)
    if not self._contribute_bg then
        local _contribute_bg = zc.getScaleNode("res/Main/common/popBg/popup_Bg_blue.png", _contribute_bgSize)
        _contribute_bg:setAnchorPoint(cc.p(0.5, 0.5))
        _contribute_bg:setPosition( cc.p(zc.width/2, zc.height/2)  )
        self:addContent(_contribute_bg)
        self._contribute_bg = _contribute_bg
    end
    local _contribute_bg = self._contribute_bg

    local nameBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(230,32) )
    nameBg:setPosition(cc.p(_contribute_bgSize.width/2, _contribute_bgSize.height - 33))
    _contribute_bg:addChild(nameBg)
    local teachName = zc.createLabel({
        text = "",
        fontSize = 23,
        outLine = true,
        pos = cc.p(nameBg:getContentSize().width/2, nameBg:getContentSize().height/2),
    })
    nameBg:addChild(teachName)
    self._teachName = teachName

    local infoBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", cc.size(593, 111))
    infoBg:setAnchorPoint(cc.p(0.5, 0.5))
    infoBg:setPosition(cc.p(_contribute_bgSize.width/2, _contribute_bgSize.height - 125))
    _contribute_bg:addChild(infoBg)

    --科技icon
    local _posY = infoBg:getPositionY()
    local _justX = 15
    local _itemIcon = zc.createIconByData({
        data = {
            mainType = zc.mainTypeTech,
            type = 1, 
            id = tonumber(self._techdata.techId) or 1,
            level = zc.getLevelTipShow()..self._techdata.level,
        }, 
        showLevel = true,
        pos = cc.p(60+_justX, _posY ),
    })
    _itemIcon:setScale(0.75)
    _contribute_bg:addChild(_itemIcon)


    local _cur_effectId = 0
    local _cur_effectValue = 0

    local _nowData, _nextData= self:getNowAndNextData()
    _cur_effectId = _nowData.effectId1 or 0
    _cur_effectValue = _nowData.effectValue1 or 0

    local _next_effectId = _nextData.effectId1 or ""
    local _next_effectValue = _nextData.effectValue1 or ""
    
    self:initDesLabel(self._techdata.name, self._techdata.techId, _posY + 30)

    self._teachName:setString(self._techdata.name)
    for i=1,2 do
        local _text = ""
        local _value = ""
        local _addNum = "" --增加的储备量
        if i == 1 then 
            _text = zc.lang("curr_level")
            _value = self._techdata.level
            _addNum = _cur_effectValue
        else
            _text = zc.lang("next_level")
            _value = tonumber(self._techdata.level) + 1
            _addNum = _next_effectValue
        end
        if self._techdata.icon then
            if self._techdata.icon == "jianzhuCD" or self._techdata.icon == "bangzhujianshao" then
                _addNum = _addNum .. zc.lang("date_seconds")
            end
        end

        local _hasLab = true
        if i == 2 then
            if not _nextData.effectId1 then
                _hasLab = false
            end
        end
        if _hasLab then
            local _des_label = zc.createLabel({
                text = _text .." ：" .. _value .. zc.lang("level_1") .. "    ".._addNum,
                fontSize = 20,
                ap = cc.p(0,0.5),
                pos = cc.p(110+_justX, _posY-(i-1)*30),
                color = cc.c3b(93,40,1),
            })
            self._contribute_bg:addChild(_des_label)
        end
    end

    --科技星级
    self:initLevelStar(_contribute_bg,self._techdata)
    --进度
    self:initProgressTimer(_contribute_bg,self._techdata)

    --检查当前状态
    self:checkCanLevelUp()
end
function CountryContributePop:checkCanLevelUp()
    if tonumber(self._techdata.exp) >= tonumber(self._techdata.expLimit) then --可以升级
        self:createLevelUpInfo()
    else
        self:createDonateInfo()
    end
end
function CountryContributePop:createDonateInfo()
    self._btn_table = {}
    local _contribute_bg = self._contribute_bg
    --贡献
    local function _doNext()
        --计时
        self:initTimerCount(self._info.cd)

        self._btn_bg_list = {}
        for i=1,3 do
            local _btn_bg_s = zc.getScaleNode("res/Main/country/techinfo/techinfo_itembg.png", cc.size(170, 160))
            _btn_bg_s:setAnchorPoint( cc.p(0,0) )
            _btn_bg_s:setPosition( cc.p(45 + (i -1)*185, 20) )
            _contribute_bg:addChild(_btn_bg_s)
            self._btn_bg_list[#self._btn_bg_list+1] = _btn_bg_s
            --可获得
            local _heartImg = zc.getSprite({
                src = "res/Main/country/techinfo/contribute_icon.png",
                pos = cc.p(50, 120),
                scale = 0.7,
            })
            _btn_bg_s:addChild(_heartImg)
            local _heart_exp_label = zc.createLabel({
                text = self._techdata.spend[i].addExp,
                fontSize = 18,
                ap = cc.p(0,0.5),
                outLine = true,
                pos = cc.p(80, 120),
            })
            _btn_bg_s:addChild(_heart_exp_label)

            local _taxImg = zc.getSprite({
                src = "res/Main/common/common_icon_tax.png",
                pos = cc.p(50, 90),
                scale = 0.7,
            })
            _btn_bg_s:addChild(_taxImg)
            local _tax_label = zc.createLabel({
                text = self._techdata.spend[i].addTax,
                fontSize = 18,
                ap = cc.p(0,0.5),
                outLine = true,
                pos = cc.p(80, 90),
            })
            _btn_bg_s:addChild(_tax_label)

            local _btn = zc.createCommomBtn({
                tag = 1,
                needSwallow = false,
                touchScale = 0.9,
                endCallback = function()
                    if self:isCanContribute() then
                        self:clickContributeBtn(i)
                    else
                        --花费元宝清除计时
                        self:clearCdNeedGold()
                    end
                end,
                pos = cc.p( 85 ,40 ), 
            })
            _btn_bg_s:addChild(_btn)

            local _sprite = self:getSpriteByType(self._techdata.spend[i].spendType)
            _sprite:setPosition(cc.p(45,_btn:getContentSize().height/2))
            _btn:addChild(_sprite)
            local _pay_label = zc.createLabel({
                text = self._techdata.spend[i].spendNum,
                fontSize = 18,
                ap = cc.p(0,0.5),
                outLine = true,
                pos = cc.p(70, _btn:getContentSize().height/2),
            })
            _btn:addChild(_pay_label)
            self._btn_table[i] = {}
            self._btn_table[i]._btn = _btn
            self._btn_table[i]._tax_label = _tax_label
            self._btn_table[i]._heart_exp_label = _heart_exp_label
            self._btn_table[i]._sprite = _sprite
            self._btn_table[i]._pay_label = _pay_label
            
            if self._techdata.spend[i].canUse == 0 then
                _btn:setEnable(false)
                if i > 1 then
                    _sprite:setVisible(false)
                    _pay_label:setText("???")
                    _pay_label:setPositionX(_btn:getContentSize().width/2-31/2)
                end
            else
                _btn:setEnable(true)
                if self._techdata.spend[i].haveNum < self._techdata.spend[i].spendNum then
                    _btn:setEnable(false)
                end
            end 
        end
    end

    _doNext()
end
function CountryContributePop:createLevelUpInfo()
    local _contribute_bg = self._contribute_bg

    local _btn_bg_s = zc.getScaleNode("res/Main/country/techinfo/techinfo_itembg.png", cc.size(500, 160))
    _btn_bg_s:setAnchorPoint( cc.p(0.5,0) )
    _btn_bg_s:setPosition( cc.p(_contribute_bg:getContentSize().width/2, 20) )
    _contribute_bg:addChild(_btn_bg_s)

    local touchBtn
    touchBtn = zc.createCommomBtn({
        tag = 1,
        btnText = zc.lang("upgrade_2"),
        needSwallow = false,
        endCallback = function()  
            zc.sendHttp({
                apiName = "Country_upgradeTech",
                params = {id = self._techdata.id},
                successCallback = function (net_data)
                    touchBtn:setEnable(false)
                    if self._levelUp then
                        self._levelUp(net_data)
                    end
                    self._techdata.exp              = net_data.exp
                    self._techdata.expLimit         = net_data.expLimit
                    self._techdata.level            = net_data.level
                    self._techdata.researchEndTime  = net_data.researchEndTime

                    if net_data and net_data.researchEndTime then

                        local _timeDiff = tonumber(net_data.researchEndTime) - PlayerData:getTime()
                        self._levelUp_time_label:setString(zc.getTimeHMS(_timeDiff))
                        schedule(self,function()
                            _timeDiff = _timeDiff - 1
                            local _strTime = zc.getTimeHMS(_timeDiff)
                            self._levelUp_time_label:setString(_strTime)
                            if _timeDiff <= 0 then
                                self:stopAllActions()

                                self._contribute_bg:removeAllChildren()
                                self:initUI()
                            end
                        end,1.0)
                    end
                end
            })
        end,
        pos = cc.p(250, 90)
    })
    _btn_bg_s:addChild(touchBtn)

    local tipLab = zc.createLabel({
        text = zc.lang("country_level_up_tip"),
        outLine = true,
        fontSize = 22,
        pos = cc.p(250, 30),
    })
    _btn_bg_s:addChild(tipLab)
    local _flag = self:isCanUpgrade(self._country_positionId)
    if not _flag then
        touchBtn:setEnable(false)
    end
    --已经满级
    if tonumber(self._techdata.level) >= tonumber(self._techdata.levelLimit) then
        touchBtn:setEnable(false)
        tipLab:setString(zc.lang("country_tech_max_level"))
    else

        local _levelUpLab = zc.createLabel({
            text = zc.lang("country_tech_level_up_time") .. "：",
            outLine = true,
            fontSize = 22,
            ap = cc.p(0, 0.5),
            pos = cc.p(400, 240),
        })
        self._contribute_bg:addChild(_levelUpLab)

        local _nowData, _nextData= self:getNowAndNextData()

        local _levelUp_time_label = zc.createLabel({
            text = zc.getTimeHMS(_nowData.researchTime),
            fontSize = 20,
            ap = cc.p(0,0.5),
            outLine = true,
            pos = cc.p(_levelUpLab:getPositionX()+_levelUpLab:getContentSize().width, 240),
            color = display.COLOR_GREEN,
        })
        self._contribute_bg:addChild(_levelUp_time_label)
        self._levelUp_time_label = _levelUp_time_label
    end
end
--国家职位权限
function CountryContributePop:getCountryPrivileges(_positionId)
    local _data = gameData.getDataFromCacheWithPrimaryKey("country_position", _positionId)
    local _privileges = ""
    if next(_data) ~= nil then
        _privileges = _data.privileges
    end
    local _data = {}
    if tonumber(_str) ~= 0 then 
        _data = string.split(_privileges,",")
    else
        _data = nil
    end
    return _data
end
--是否可以升级科技
function CountryContributePop:isCanUpgrade(_positionId)
    local _data = self:getCountryPrivileges(_positionId)
    local _flag = false
    if _data then
        for k,v in pairs(_data) do
            if tonumber(v) == 7 then  --可以升级
                _flag = true
            end
        end
    end
    return _flag
end
function CountryContributePop:clickContributeBtn(tag)
    self._btn_table[tag]._btn:setEnable(false)
	zc.sendHttp({
        apiName = "Country_contribution",
        params = {id=self._techdata.id,type = tag},
        successCallback = function (data)
            PlayerData:updataData(data)

            self._techdata.spend = data.spend
            self._techdata.exp = data.exp
            self._info.cd = data.cd

            self._contribute_bg:removeAllChildren()
            self:initUI()

            self._callback(data)
        end,
        errorCallback = function(_errorCode,_msg)
            zc.tipInfo(_msg)
            if _errorCode == 355 then
                if not tolua.isnull(self._btn_table[tag]._btn) then
                    self._btn_table[tag]._btn:setEnable(true)
                end
            end
        end,
    })
end

--科技星级
function CountryContributePop:initLevelStar(_bg,_techData)
    if not tolua.isnull(self._di) then self._di:removeFromParent() self._di = nil end
    local _di = cc.LayerColor:create(cc.c4b(0, 0, 0, 0), _bg:getContentSize().width, _bg:getContentSize().height)
    _di:setAnchorPoint(cc.p(0,0))
    local _src_1 = "res/Main/common/common_hero_star_1.png"
    local _src_2 = "res/Main/common/common_hero_star_2.png"
    local _starLimit = 5
    local _data = gameData.getDataFromCache( "country_tech_level", {techId = _techData.techId,level = _techData.level} )
    if next(_data) ~= nil then
        _starLimit = tonumber(_data.starNum)
    end
    local _expTem = tonumber(_techData.expLimit)/tonumber(_starLimit)
    for i=1,_starLimit do
        local _starImg = zc.getSprite({
                src = _src_2,
                pos = cc.p(220+(i-1)*40, 240),
            })
        _di:addChild(_starImg)
    end
    for i=1,_starLimit do
        if tonumber(_techData.exp) >= tonumber(_expTem)*i then
            local _starImg = zc.getSprite({
                src = _src_1,
                pos = cc.p(220+(i-1)*40, 240),
            })
            _di:addChild(_starImg)
        end
    end
    _bg:addChild(_di)
    self._di = _di
end

function CountryContributePop:initProgressTimer(_bg,_techData)
    local expImgBg = cc.Sprite:create("res/Main/country/techinfo/contribute_exp_bg.png")
    expImgBg:setAnchorPoint(cc.p(0, 0.5))
    _bg:addChild(expImgBg)
    expImgBg:setPosition(cc.p(170,210))
    self.expPrgress = cc.ProgressTimer:create(cc.Sprite:create("res/Main/country/techinfo/contribute_exp.png"))
    self.expPrgress:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    self.expPrgress:setBarChangeRate(cc.p(1, 0))
    self.expPrgress:setMidpoint(cc.p(0, 0))
    self.expPrgress:setPosition(cc.p(expImgBg:getContentSize().width/2,expImgBg:getContentSize().height/2))
    expImgBg:addChild(self.expPrgress, 1)
    local _percent = tonumber(_techData.exp)/tonumber(_techData.expLimit)*100
    self.expPrgress:setPercentage(_percent)
    local _heartImg = zc.getSprite({
        src = "res/Main/country/techinfo/contribute_icon.png",
        pos = cc.p(165, 210),
    })
    self._contribute_bg:addChild(_heartImg,2)
    self._exp_label = zc.createLabel({
        text = _techData.exp .. "/" .. _techData.expLimit,
        fontSize = 18,
        ap = cc.p(0.5,0.5),
        outLine = true,
        pos = cc.p(151, 7),
    })
    self.expPrgress:addChild(self._exp_label)
end

function CountryContributePop:updateView(_data)
    for _k,_v in pairs(self._techdata) do
        if _data[_k] then
            self._techdata[_k] = _data[_k]
        end
    end 
    local _percent = tonumber(self._techdata.exp)/tonumber(self._techdata.expLimit)*100
    self.expPrgress:setPercentage(_percent)
    self._exp_label:setText(self._techdata.exp .. "/" .. self._techdata.expLimit)
    self:initLevelStar(self._contribute_bg,self._techdata)

    --数据更新
    for i=1,#self._btn_table do
        self._btn_table[i]._tax_label:setText(self._techdata.spend[i].addTax)
        self._btn_table[i]._heart_exp_label:setText(self._techdata.spend[i].addExp)
        self._btn_table[i]._pay_label:setText(self._techdata.spend[i].spendNum)
        self._btn_table[i]._pay_label:setPositionX(70)
        if self._techdata.spend[i].canUse == 0 then
            self._btn_table[i]._btn:setEnable(false)
            if i > 1 then
                self._btn_table[i]._sprite:setVisible(false)
                self._btn_table[i]._pay_label:setText("???")
                self._btn_table[i]._pay_label:setPositionX(self._btn_table[i]._btn:getContentSize().width/2-31/2)
            end
        else
            if i > 1 then
                self._btn_table[i]._sprite:removeFromParent()
                local _sprite = self:getSpriteByType(self._techdata.spend[i].spendType)
                _sprite:setPosition(cc.p(30, self._btn_table[i]._btn:getContentSize().height/2))
                self._btn_table[i]._sprite = _sprite
                self._btn_table[i]._btn:addChild(_sprite)
            end
            self._btn_table[i]._btn:setEnable(true)
            if self._techdata.spend[i].haveNum < self._techdata.spend[i].spendNum then
                self._btn_table[i]._btn:setEnable(false)
            end
        end
    end 
end

function CountryContributePop:getSpriteByType(_type)
    local _src = zc.getImgByType(_type)
    local _sprite = zc.createSprite(_src)
    return _sprite
end

function CountryContributePop:initDesLabel(_type, _techId, _posY)
    local teachInfo = gameData.getDataFromCacheWithPrimaryKey("country_tech", _techId )
    -- local _text = LANGUAGE_getAttributeTextById(_type)
    local _des_label = zc.createLabel({
        -- text = _type.."  ：".. teachInfo.desc,
        text = zc.lang("country_tech_desc") .. " ：".. teachInfo.desc,
        fontSize = 20,
        ap = cc.p(0,0.5),
        -- stroke = true,
        pos = cc.p(110 + 15, _posY),
        -- color = display.COLOR_BLACK,
        color = cc.c3b(93,40,1),
    })
    self._contribute_bg:addChild(_des_label)
    return _des_label
end

function CountryContributePop:initTimerCount(_cd)
    local _timeDiff = tonumber(_cd.cdEndTime) - PlayerData:getTime()
    local _strTime = zc.timeToClock(_timeDiff,false)
    if _timeDiff <= 0 then 
        _strTime = ""
    else 
        self:updateTimerCount(_cd)
    end
    local _time_label = zc.createLabel({
        text = _strTime,
        fontSize = 20,
        ap = cc.p(0,0.5),
        outLine = true,
        pos = cc.p(400, 240),
        color = display.COLOR_RED,
    })
    self._contribute_bg:addChild(_time_label)
    self._time_label = _time_label
end

function CountryContributePop:updateTimerCount(_cd)
    self._info.cd = _cd

    local _timeDiff = tonumber(_cd.cdEndTime) - PlayerData:getTime()
    local _strTime = zc.getTimeHMS(_timeDiff)
    if _timeDiff <= 0 then 
        _strTime = ""
    end
    if not tolua.isnull(self._time_label) then 
        self._time_label:setText(_strTime)
    end
    self:stopAllActions()
    schedule(self,function()
        local _timeDiff = tonumber(_cd.cdEndTime) - PlayerData:getTime()
        local _strTime = zc.getTimeHMS(_timeDiff)
        if _timeDiff <= 0 then
            self:stopAllActions()
            _strTime = ""
        end
        if not tolua.isnull(self._time_label) then 
            self._time_label:setText(_strTime)
        end
    end,1.0)
end

--是否可捐献
function CountryContributePop:isCanContribute()
    local _flag = true
    local _time = tonumber(self._info.cd.cdEndTime) - PlayerData:getTime()
    if tonumber(_time) >= tonumber(self._info.cd.limit) then
        _flag = false
    end
    if tonumber(self._info.cd.flag) == 1 and tonumber(_time) > 0 then
        _flag = false
    end
    return _flag
end

-- 清理CD所需元宝
function CountryContributePop:clearCdNeedGold()
    local _time = tonumber(self._info.cd.cdEndTime) - PlayerData:getTime()
    local _need_gold = self._info.cd.rate * math.ceil(_time/60)
    local function _callback(_cd)
        self:updateTimerCount(_cd)
    end
    zc.createSourcePop("CountryTechCdClear", "src/layer/country/CountryTechCdClearPop.lua", {needGold = _need_gold,callback = _callback})
end


return CountryContributePop