--[[
-- 国家列表
-- @author lph
-- Creation  2016-4-6
]]
local CountryListPop = class("CountryListPop", function ()
    return ZCPopLayer:create() 
end);

function CountryListPop:create(params)
	local _CountryList = CountryListPop.new(params)
	return _CountryList
end

function CountryListPop:ctor(params)
    self:initData(params)
	self:initUI()
    self:show(false)
end

function CountryListPop:initData(params)
	self._names = {zc.lang("country_name_1"),zc.lang("level"),zc.lang("country_monarch"),zc.lang("country_level_limit"),zc.lang("country_number")}
	self._applyLimit = params.applyLimit
	self._countryData = params.countrys
end

function CountryListPop:initUI()
	--通用背景
    local _country_list_bg = zc.getSprite({
        src = "res/Main/country/countryList/list_bg.png",
        ap = cc.p(0.5,0.5),
        pos = cc.p(zc.width/2, zc.height/2) 
    })
    self:addContent(_country_list_bg)
    self._country_list_bg = _country_list_bg
    local popBgSize = _country_list_bg:getContentSize()
    local _bianImg = zc.getScaleNode("res/Main/common/frame.png", cc.size(popBgSize.width, popBgSize.height))
    _bianImg:setPosition(popBgSize.width*0.5, popBgSize.height*0.5)
    _bianImg:setName("bianImg")
    _country_list_bg:addChild(_bianImg, 1)
    --标题
    local _title = zc.getSprite({
        src = "res/Main/country/countryList/title.png",
        ap = cc.p(0,0.5),
        pos = cc.p(-40, _country_list_bg:getContentSize().height-15) 
    })
    _country_list_bg:addChild(_title, 10)
    --国家列表标题
    for i=1,#self._names do
    	local _text = self._names[i]
    	local _label = zc.createLabel({
	        text = _text,
	        fontSize = 24,
	        ap = cc.p(0.5,0.5),
	        -- stroke = true,
	        pos = cc.p(90+140*(i-1), 445),
	        color = display.COLOR_BLACK,
	    })
	    _country_list_bg:addChild(_label)
    end
    --国家列表
    self:initCountryList()

    --创建国家
    local _createCountryBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("country_create"),
        pos = cc.p( 90,45 ), 
        endCallback = function () 
            zc.createSourcePop( "CountryCreate", "src/layer/country/CountryCreatePop.lua")
        end,
    })
    _country_list_bg:addChild(_createCountryBtn)
    --快速加入
    local _quick_add_Btn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("country_direct_add"),
        pos = cc.p( 240 ,45 ), 
        endCallback = function () 
            self:quickAddCountry()
        end,
    })
    _country_list_bg:addChild(_quick_add_Btn)

    --关闭按钮
    local _closeButton = zc.createBackButton({
        pos = cc.p(_country_list_bg:getBoundingBox().width-10  , _country_list_bg:getBoundingBox().height), 
        listener = function () 
            self:hide({noAction=true})
        end,
    })
    _country_list_bg:addChild(_closeButton, 10)
end


function CountryListPop:initCountryList()
    local _tableSize = cc.size(880, 330)
    local _tableView = zc.ZCTableView:create(_tableSize)
    _tableView:setPosition(12, 90)
    _tableView:setInertia(true)
    _tableView:setBounceable(true)
    _tableView:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL)
    _tableView:setDelegate()
    _tableView:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    self._country_list_bg:addChild(_tableView)
    self._countryTable = _tableView

    local _cellSize = cc.size(860, 70)

    local function numberOfCellsInTableView( table )
        return #self._countryData
    end
    local function cellSizeForTable( table, index )
        return _cellSize.height , _cellSize.width
    end
    local function tableCellAtIndex( table, index )
        local cell = table:dequeueCell()
        if cell then
            cell:removeAllChildren()
        else
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(_cellSize)
        end

        local _di = cc.LayerColor:create(cc.c4b(0, 0, 0, 255*0.2), _cellSize.width, _cellSize.height)
        if index%2 == 0 then
        	_di = cc.LayerColor:create(cc.c4b(80, 0, 0, 255*0.2), _cellSize.width, _cellSize.height)
        else
        	_di = cc.LayerColor:create(cc.c4b(0, 0, 0, 0), _cellSize.width, _cellSize.height)
        end
        cell:addChild(_di)
        self:createOneCell(_di, index)
        return cell
    end
    _tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    _tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    _tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    _tableView:reloadData()
end

function CountryListPop:createOneCell( cell, index )
	local _country_data = self._countryData[index+1]
	if _country_data then
        -- dump(_country_data, "-----------dump----_country_data----ad-------------" )
		local _text_num = _country_data.memberNum .. "/" .. _country_data.memberLimit
		local _data = {_country_data.name,_country_data.level,_country_data.monarchName,_country_data.joinLimit,_text_num}
	    for i=1,5 do
	    	local _text = _data[i]
	    	local _label = zc.createLabel({
		        text = _text,
		        fontSize = 20,
		        ap = cc.p(0.5,0.5),
		        outLine = true,
		        pos = cc.p(90+140*(i-1), 30),
		        -- color = display.COLOR_BLACK,
		    })
		    cell:addChild(_label)
		end
        --申请加入
        local joinLimitType = tonumber(_country_data.joinLimitType) or 1
        local _btnText = zc.lang("country_add2")
        local _enable = true

        if joinLimitType == 1 then

        elseif joinLimitType == 2 then
            _btnText = zc.lang("apply_for2")
        elseif joinLimitType == 3 then
            _btnText = zc.lang("cannot_join")
            _enable = false
        end

        if _country_data.apply and tonumber(_country_data.apply) == 1 then
            _btnText = zc.lang("have_apply_for")
            _enable = false
        end

        --等级不满足
        if tonumber(_country_data.joinLimit) > tonumber(PlayerData:getBaseInfo().level) then
            _enable = false
        end

		local _button = zc.createCommomBtn({
            tag = 1,
            scale = 0.8,
			pos = cc.p( 780, 35 ),
			text = _btnText,
			endCallback = function() 
				zc.sendHttp({
                    apiName = "Country_apply",
                    params = {id=_country_data.id,type=1},
                    successCallback = function (data)
                       if tonumber(data.result) == 2 then
                            zc.tipInfo(zc.lang("tips_apply_for_success"))
                            _country_data.apply = 1
                            self._countryTable:reloadDataAndScrollToCurrentCell()
                        elseif tonumber(data.result) == 3 then
                            PlayerData:setBaseInfoByTag("countryId",_country_data.id)
                            PlayerData:setBaseInfoByTag("countryName",_country_data.name)
                            LayerManager.removeLayout(true)
                            zc.createCountryScene()
                        end
                    end,
                })
			end
		})
		cell:addChild(_button)


        if not _enable then
            _button:setEnable(false)
        end
    end
end

--快速加入国家
function CountryListPop:quickAddCountry()
    for k,v in pairs(self._countryData) do
        if tonumber(v.needApply) == 0 and tonumber(v.memberNum) < tonumber(v.memberLimit) and tonumber(v.joinLimit) <= tonumber(PlayerData:getBaseInfo().level) then
            zc.sendHttp({
                apiName = "Country_apply",
                params = {id=v.id,type=1},
                successCallback = function (data)
                    if tonumber(data.result) == 2 then
                        zc.tipInfo(zc.lang("tips_apply_for_success"))
                    elseif tonumber(data.result) == 3 then
                        PlayerData:setBaseInfoByTag("countryId",v.id)
                        PlayerData:setBaseInfoByTag("countryName",v.name)
                        LayerManager.removeLayout(true)
                        zc.createCountryScene()
                    end
                end,
            })
            break
        end
    end
    
end

function CountryListPop:onEnter()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_12402 then
        zc.setGuideFuncNextStep(_currentGID, false)
        local function _callBack()
            getGuideManager():setFuncGuideOver()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    end
end

return CountryListPop