--[[
-- 国家商店
-- @author lph
-- Creation  2016-4-6
]]
local CountryShopLayer = class("CountryShopLayer",function ()
    return zc.createNormalDialog({
        showFlower = false,
    })
end)

function CountryShopLayer:create(data)
	return CountryShopLayer.new(data)
end

function CountryShopLayer:ctor(data)
    self:initData(data)
	self:initUI()
    self:createTabBtn()
end

function CountryShopLayer:initData(data)
    self._countryTechLevel = data["countryTechLevel"] or {}
    self._playerUid = PlayerData.info["userId"] --玩家uid
    --设置数据
    self:refreshInfo(data)
end

function CountryShopLayer:initUI()

    --背景
    local _background = zc.createNormalPop({
        src = "",
        width = 885,
        height = 524+31,
    })
    _background:setPosition(zc.width*0.5, zc.height*0.5)
    self:addChild(_background)

    local popSize = cc.size(880, 524)

    local _titleImg = zc.getSprite({
        src = "res/Main/common/popBg/titleBg2.jpg",
        ap = cc.p(1, 1),
        name = "titleImg",
    })
    _titleImg:setPosition(cc.p(_background:getContentSize().width-3, _background:getContentSize().height-3))
    _background:addChild(_titleImg,2)

    local titleLeft = zc.createSprite("res/Main/common/popBg/titleBg2.jpg")
    titleLeft:setAnchorPoint(0, 1)
    titleLeft:setPosition(3, _titleImg:getPositionY())
    _background:addChild(titleLeft,1)

    -- 背景
    -- 商店背景
    local shopBg = zc.createSprite( "res/Main/shop/shopBg.jpg" )
    shopBg:setAnchorPoint( 0.5, 1 )
    shopBg:setPosition( popSize.width/2 + 12, popSize.height - 50 )
    _background:addChild( shopBg )

    self._bg = _background
    self._bgSize = _background:getContentSize()
    

    -- 标题
    local title = cc.Sprite:create( "res/Main/country/main/country_shop_title.png" )
    title:setPosition( 60, self._bgSize.height - 18 )
    self._bg:addChild( title, 10 )

end

function CountryShopLayer:createTabBtn()
    local nameTable = {[1]=zc.lang("items2"),[2]=zc.lang("limit_time_2"),[3]=zc.lang("reward_2")}

    -- 分页背景
    local tabBg = zc.createTabButtonBg({tag=3})
    tabBg:setAnchorPoint( 0, 0 )
    tabBg:setPosition( 4, 7 )
    local splitY = cc.Sprite:create( "res/Main/common/tab_split_y.png" )
    splitY:setPosition( tabBg:getContentSize().width + 3, tabBg:getContentSize().height/2 )
    splitY:setScaleY( 464/493 )
    tabBg:addChild( splitY , 2)
    
    self._bg:addChild( tabBg ,1)
    self._tabBtn = {}
    -- 分隔线
    local split1 = zc.createSprite("res/Main/common/tab_split_x_new.png")
    split1:setPosition(tabBg:getContentSize().width/2, 332 + 62 )
    tabBg:addChild(split1)
    -- tab
    for i=1,#self._goodsList do
        local pos = cc.p( tabBg:getContentSize().width/2, 440 - i*62 )
        local tabBtn = zc.createComTabButton({
            tag = 4,
            btnText =  nameTable[i] or "",
            touchSize = cc.size( 153, 62),
            needSwallow = false,
            needEnableWhenOut = true,
            needEnableWhenMoving = true,
            pos = pos,
            endCallback = function() end,
        })
        tabBtn:setTag(i)
        tabBg:addChild(tabBtn, 1)
        tabBtn:setTouchEndedCall(function()
            self:changeTabButton(tabBtn)
        end)
        -- 分隔线
        local split = zc.createSprite("res/Main/common/tab_split_x_new.png")
        split:setPosition(tabBtn:getPositionX(), tabBtn:getPositionY() - tabBtn:getContentSize().height*0.5 - 9 )
        tabBg:addChild(split)

        if 1 == i then 
            self:changeTabButton(tabBtn)
        end
    end
end
function CountryShopLayer:changeTabButton( _node )
    if not self._selectedBtn or self._selectedBtn ~= _node then
        local _tag = _node:getTag()
        if not self._selectedBtn then
            self._selectedBtn = _node
            _node:setSelected( true )
        else
            self._selectedBtn:setSelected( false )
            self._selectedBtn = _node
            self._selectedBtn:setSelected( true )
        end
        self._tag = _tag
        self._showList = {}
        self._showList = self._goodsList[_tag] or {}
        self:refreshTable()
    end
end
function CountryShopLayer:changeTab( _node )
    local function getNormal()
        return zc.getScaleNode("res/Main/common/img_empty.png", cc.size(153,88))
    end
    local function getSelect()
        return zc.getScaleNode("res/Main/common/button/btn_light_middle.png",cc.size(153,88))
    end
    if not self._selectedBtn or self._selectedBtn ~= _node then
        local _tag = _node:getTag()
        if not self._selectedBtn then
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelect() )
            self._selectedBtn._normalLab:setVisible(false)
            self._selectedBtn._selectLab:setVisible(true)
        else
            self._selectedBtn:setStateNormal( getNormal() )
            self._selectedBtn._normalLab:setVisible(true)
            self._selectedBtn._selectLab:setVisible(false)
            self._selectedBtn = _node
            self._selectedBtn:setStateNormal( getSelect() )
            self._selectedBtn._normalLab:setVisible(false)
            self._selectedBtn._selectLab:setVisible(true)
        end
        self._tag = _tag
        self._showList = {}
        self._showList = self._goodsList[_tag] or {}
        self:refreshTable()
    end
end
function CountryShopLayer:refreshTable()
    if not self._myTableBg then
        local tableSize = cc.size(715, 470)
        local tableNode = self._bg
        -- local myTableBg = zc.getScaleNode("res/Main/setting/scale9_1.png", tableSize)
        local myTableBg = zc.createSprite()
        myTableBg:setContentSize(tableSize)
        myTableBg:setAnchorPoint(cc.p(1, 0))
        myTableBg:setPosition(cc.p(tableNode:getContentSize().width-9, 7))
        tableNode:addChild(myTableBg)
        self._myTableBg = myTableBg

        local bottomBg = ccui.Scale9Sprite:create( cc.rect( 20, 10, 549, 71 ), "res/Main/role/trinket/sellDi.png" )
        bottomBg:setContentSize( 720, 90 )
        bottomBg:setAnchorPoint( 0.5, 0 )
        bottomBg:setPosition( tableSize.width/2-1, -5)
        myTableBg:addChild( bottomBg, 2 )
        self._bottomBg = bottomBg

        if self._tag == 2 then
            bottomBg:setVisible(true)
        else
            bottomBg:setVisible(false)
        end
        -- 时间背景
        local totalRefreshBg = ccui.Scale9Sprite:create( cc.rect( 12, 11, 14, 10 ), "res/Main/role/common/name_bg.png" )
        totalRefreshBg:setContentSize( 240, 30 )
        totalRefreshBg:setPosition( 150, 45 )
        bottomBg:addChild( totalRefreshBg )
        local timeToRefreshLab = zc.createLabel({
            text = zc.lang("left_fresh_time"),
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(10, totalRefreshBg:getContentSize().height/2),
            -- color = display.COLOR_GREEN,
            pixel = 1.3
        })
        totalRefreshBg:addChild(timeToRefreshLab)
        --倒计时
        local timeToRefresh = zc.createLabel({
            text = zc.getTimeHMS(self._nextRefreshTime ),
            outLine = true,
            fontSize = 20,
            ap = cc.p(0, 0.5),
            pos = cc.p(20+timeToRefreshLab:getContentSize().width, totalRefreshBg:getContentSize().height/2),
            color = display.COLOR_GREEN,
            pixel = 1.3
        })
        totalRefreshBg:addChild(timeToRefresh)
        local myTable = zc.ZCTableView:create(cc.size(myTableBg:getContentSize().width-4,myTableBg:getContentSize().height-10))
        myTable:setPosition(2,2)
        myTable:setInertia(true) --设置惯性
        myTable:setBounceable(false)
        myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL) --设置横向纵向
        myTable:setDelegate()
        myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
        myTableBg:addChild(myTable)
        local function cellSizeForTable(table,idx)
            return 125, tableSize.width
        end
        local function numberOfCellsInTableView(table)
            return math.floor(#self._showList-1)/2+1
        end
        local function tableCellAtIndex(table,idx)
            local nowIdx = idx + 1
            local cell = table:dequeueCell()
            if cell == nil then
                cell = zc.ZCTableViewCell:new()
                cell:setContentSize(cc.size(tableSize.width, 125))
            else
                cell:removeAllChildren()
            end
            self:createCell(cell, nowIdx)
            return cell
        end
        myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
        myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
        myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
        myTable:reloadData()
        self._myTable = myTable
        --倒计时  
        schedule(totalRefreshBg, function()
            self._nextRefreshTime = self._nextRefreshTime - 1
            if self._nextRefreshTime < 0 then
                --时间到了就重置信息
                self:resetAllInfo()
            else
                local timeStr = zc.getTimeHMS(self._nextRefreshTime)
                timeToRefresh:setText(timeStr)
            end
        end, 1.0)

    else
        self._myTable:reloadData()
        if self._tag == 2 then
            self._bottomBg:setVisible(true)
        else
            self._bottomBg:setVisible(false)
        end
    end
end
function CountryShopLayer:createCell( cell,nowIdx )
    local _tag = self._tag
    local leftId = tonumber(nowIdx)*2-1
    local rightId = tonumber(nowIdx)*2
    local cellData = {[1]=self._showList[leftId], [2]=self._showList[rightId]}
    -- dump(cellData, "cellData === ")
    local cellSize = cell:getContentSize()
    local pos = zc.sortFromMiddle(cc.p(cellSize.width/2,cellSize.height/2),2, 355)
    for i = 1, 2 do
        if cellData[i] then
            local itemData = cellData[i]
            local itemImg = zc.createSprite("res/Main/shop/cellBg.png")
            itemImg:setPosition(pos[i])
            cell:addChild(itemImg)
            -- dump(itemData, "itemData =================================== ")
            -- noteBg
            local noteBg = cc.Sprite:create( "res/Main/shop/shop_zk.png" )
            noteBg:setAnchorPoint( 0, 1 )
            noteBg:setPosition( 0, itemImg:getContentSize().height + 10 )
            -- itemImg:addChild( noteBg , 10)
            -- note
            local note = zc.createLabel({
                text = zc.lang("limit_num"),
                outLine = true,
                fontSize = 20,
                fontName = zc.getFont(1),
                ap = cc.p(0.5, 0.5),
                pos = cc.p(noteBg:getContentSize().width/2-14, noteBg:getContentSize().height/2+5),
                color = display.COLOR_GOLD,
                color2 = display.COLOR_BLACK,
                align = kCCTextAlignmentCenter,
                pixel = 1.3
            })
            noteBg:addChild(note)
            note:setRotation( -45 )
            --icon
            local item,info = zc.createIconByData({
                data = {
                    mainType = itemData.itemType,
                    type = itemData.itemId,
                    id = itemData.itemId,
                    quality = 1,
                    num = itemData.itemNum,
                },
            })
            item:setTouchEndedShowTip()
            itemImg:addChild(item)
            item:setScale(90/120)
            item:setAnchorPoint(cc.p(0.5, 0.5))
            item:setPosition(52, itemImg:getContentSize().height/2)
            itemData["info"] = info
            itemData["name"] = info["name"]
            local nameBg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(123, 27))
            nameBg:setPosition( 156+4, 83 )
            itemImg:addChild(nameBg)
            -- name
            local nameStr = info.name
            local name = zc.createLabel({
                text = nameStr,
                fontSize = 19,
                fontName = zc.getFont(1),
                ap = cc.p(0.5, 0.5),
                pos = cc.p( nameBg:getContentSize().width/2, nameBg:getContentSize().height/2),
                color = zc.getColorType(tonumber(itemData.info.color)),
                color2 = display.COLOR_BLACK,
                align = kCCTextAlignmentCenter,
                pixel = 1.3,
                outLine = true,
            })
            nameBg:addChild(name)

            local _canBuy = true
            if _tag == 1 then
                if itemData.isOpen then --如果已经是开启出售的
                    local ownNumLab = zc.createLabel({
                        text = zc.lang("today_can_buy") .. itemData.buyNum.. zc.lang("ci"),
                        fontSize = 18,
                        ap = cc.p(0.5, 0.5),
                        pos = cc.p(155, 26),
                        color = display.COLOR_BROWN,
                    })
                    itemImg:addChild(ownNumLab)
                else
                    _canBuy = false
                    local needLab1 = zc.createLabel({
                        text = itemData.descname,
                        -- text = zc.lang("need_country_tech"),
                        fontSize = 18,
                        ap = cc.p(0.5, 0.5),
                        pos = cc.p(155, 46),
                        color = display.COLOR_BROWN,
                        pixel = 1.3
                    })
                    itemImg:addChild(needLab1)
                    local needLab2 = zc.createLabel({
                        text = zc.lang("achieve") .. (tonumber(itemData.level)).. zc.lang("level_1"),
                        -- text = zc.lang("achieve") .. (tonumber(self._countryTechLevel) + 1).. zc.lang("level_1"),
                        fontSize = 18,
                        ap = cc.p(0.5, 0.5),
                        pos = cc.p(155, 23),
                        color = display.COLOR_BROWN,
                        pixel = 1.3
                    })
                    itemImg:addChild(needLab2)
                end
            elseif _tag == 2 then
                local ownNumLab = zc.createLabel({
                    text = zc.lang("country_left") .. itemData.buyNum .. zc.lang("piece"),
                    fontSize = 18,
                    ap = cc.p(0.5, 0.5),
                    pos = cc.p(155, 26),
                    color = display.COLOR_BROWN,
                })
                itemImg:addChild(ownNumLab)
            elseif _tag == 3 then
                -- dump(itemData,"itemData")
                print("self.level::",self.level)
                if itemData.tech >= self.techId then
                    local state = false
                    if itemData.tech == self.techId then
                        if tonumber(itemData.need) >= tonumber(self.level) then
                            state = true
                        end
                    else
                        state = true
                    end
                    if state then
                        _canBuy = false
                        local needLab1 = zc.createLabel({
                            text = itemData.descname,
                            fontSize = 18,
                            ap = cc.p(0.5, 0.5),
                            pos = cc.p(155, 46),
                            color = display.COLOR_BROWN,
                            pixel = 1.3
                        })
                        itemImg:addChild(needLab1)
                        local needLab2 = zc.createLabel({
                            text = zc.lang("achieve") .. itemData.need.. zc.lang("level_1"),
                            fontSize = 18,
                            ap = cc.p(0.5, 0.5),
                            pos = cc.p(155, 23),
                            color = display.COLOR_BROWN,
                            pixel = 1.3
                        })
                        itemImg:addChild(needLab2)
                    end
                end
            end

            -- 消耗
            local posY = 80
            if tonumber(itemData["priceType"..2]) > 0 and itemData["isOpen"] then
                posY = 95
            end
            for j = 1, 2 do
                if j == 1 or (j == 2 and itemData["isOpen"]) then
                    -- icon
                    if tonumber(itemData["priceType"..j]) > 0 then
                        local cellInfo = zc._getIconInfo({
                            data = {
                                mainType = 1,
                                type = itemData["priceType"..j],
                                num = itemData["price"..j],
                            }
                        })
                        local consumeIcon = zc.createSprite(cellInfo.img)
                        consumeIcon:setAnchorPoint(0.5, 0.5)
                        consumeIcon:setPosition(250, posY-(j-1)*28)
                        itemImg:addChild(consumeIcon)
                        consumeIcon:setScale(0.8)
                        if _tag == 2 and j == 1 then --限时的price1表示的时原价,其它的表示价格1
                            consumeIcon:setVisible(false)
                            consumeIcon:setPositionX(250 + 15)
                            local myLab = zc.createLabel({
                                text = zc.lang("old_price") .. "：",
                                outLine = true,
                                fontSize = 20,
                                ap = cc.p(0, 0.5),
                                pos = cc.p(233, consumeIcon:getPositionY()),
                                pixel = 1.3
                            })
                            itemImg:addChild(myLab)
                            -- local redLine = zc.getScaleNode("res/Main/shop/split.png", cc.size(125, 3))
                            local redLine = zc.createSprite("res/Main/activity/blackMarket/redLine.png")
                            redLine:setAnchorPoint(cc.p(0.5, 0.5))
                            redLine:setPosition(cc.p(285, consumeIcon:getPositionY()))
                            itemImg:addChild(redLine,1)
                        end
                        -- num
                        local consumeNum = zc.createLabel({
                            text = cellInfo.num,
                            outLine = true,
                            fontSize = 20,
                            fontName = zc.getFont(1),
                            ap = cc.p(0, 0.5),
                            pos = cc.p(consumeIcon:getPositionX()+consumeIcon:getContentSize().width/2, consumeIcon:getPositionY() ),
                            pixel = 1.5
                        })
                        itemImg:addChild(consumeNum)
                    end
                end
            end

            -- 购买按钮
            local btnText = zc.lang("buy2")
            if itemData.alreadyBuy then 
                btnText = LANGUAGE_SHOP.bought
                _canBuy = false
            end
            if tonumber(itemData.buyNum) <= 0 then
                _canBuy = false
            end
            -- 区分type = 3的情况
            if itemData["goodsType"] == 3 then
                if itemData["buyNum"] <= 0 then
                    _canBuy = false
                    btnText = LANGUAGE_SHOP.bought
                else
                    if itemData.buy and tonumber(itemData.buy) == 0 then
                        _canBuy = false
                    elseif itemData.buy and tonumber(itemData.buy) == 1 then
                        _canBuy = true
                    end
                end
            end
            local buyBtn = zc.createCommomBtn({
                tag = 3,
                scale = 0.6,
                labScale = true,
                text = btnText,
                needSwallow = false,
                endCallback = function()
                    self:buyItem(itemData.id,itemData["goodsType"],itemData)
                end,
                pos = cc.p( 285, 30 )
            })
            itemImg:addChild(buyBtn)
            buyBtn:setEnable(_canBuy)  
        end
    end
end

function CountryShopLayer:buyItem(_id,_type, _itemInfo, _index)
    -- zc.gotohttp  = false
    local function buy(num, callback)
        zc.sendHttp({
            apiName = "Country_goods_buy",
            params = {type=_type,id=_id,num=num},
            successCallback = function(net_data)
                musicManager.playEffect( zc.effect.shopBuy )
                PlayerData:updataData(net_data)
                if _type == 1 then --道具可以一直购买
                    if tonumber(_itemInfo["itemType"]) == 1 then
                        local _ownNum = PlayerData:getResourcesInfoById(_itemInfo["itemId"])
                        _itemInfo["ownNum"] = tonumber(_ownNum)
                    else
                        _itemInfo["ownNum"] = tonumber(_itemInfo["ownNum"]) + num * (tonumber(_itemInfo["itemNum"]))
                    end
                    local goods = net_data["goods"] or {}
                    local curTabInfo = goods["1"] or {}
                    local buyItemInfo = curTabInfo[tostring(_itemInfo["id"])] or {}
                    _itemInfo["buyNum"] = (tonumber(_itemInfo["number"]) or 0) - tonumber(buyItemInfo[tostring(self._playerUid)]) or 0
                else --限时和奖励只能购买一次
                    _itemInfo["alreadyBuy"] = true
                    _itemInfo["buyNum"] = tonumber(_itemInfo["buyNum"]) - 1
                    if _itemInfo["buyNum"] < 0 then _itemInfo["buyNum"] = 0 end
                end
                if callback then
                    callback()
                end
                if _itemInfo["buy"] then
                    _itemInfo["buy"] = 1
                end
                self._myTable:reloadDataAndScrollToCurrentCell()
            end,
        })
    end
    if _type == 1 then
        local params = {
            info = _itemInfo,
            rightFunc = function(_num, callback) buy(_num, callback) end,
        }
        zc.createCommonBuyPop(params)
    else
        local _info = table.copy(_itemInfo)
        --特殊处理，price1做为原价，price2做为现价
        _info["priceType1"] = _info["priceType2"]
        _info["price1"] = _info["price2"]
        _info["priceType2"] = 0
        _info["price2"] = 0
        _info["desc"] = _info["info"]["desc"]
        zc.createShopBuyPop({info = _info, 
            limit = true,
            clickHide = true,
            callback = function(_callback)
                buy(1)
                
                if _callback then
                    _callback()
                end
            end
        })
    end
end
--重置数据
function CountryShopLayer:resetAllInfo()
    zc.sendHttp({
        apiName = "Country_goods_list",
        params = {type="1|2|3"},
        successCallback = function (data)
            self:refreshInfo(data)
            self._myTable:reloadData()
        end
    })
end
function CountryShopLayer:refreshInfo( data )
    self._goodsList = nil
    self._goodsList = {}
    self._nextRefreshTime = 0
    if data.goods then
        for i = 1, table.nums(data.goods) do --i-->对应商品类型 (道具、限时、奖励)
            self._goodsList[i] = {}
            local _v = data.goods[tostring(i)]
            for k,m in pairs(_v) do
                if k == "nextRefreshTime" then
                    self._nextRefreshTime = tonumber(m) - PlayerData:getTime()
                elseif tonumber(k) then
                    local _goodsStatic = gameData.getDataFromCacheWithPrimaryKey("country_shop", k, true)
                    local country_tech = gameData.getDataFromCacheWithPrimaryKey("country_tech",_goodsStatic.tech)
                    dump(country_tech)
                    local idx = #self._goodsList[i] + 1
                    self._goodsList[i][idx] = {}
                    self._goodsList[i][idx] = _goodsStatic
                    self._goodsList[i][idx]["isOpen"] = true --是否开启
                    self._goodsList[i][idx]["alreadyBuy"] = false --是否已经购买
                    self._goodsList[i][idx]["ownNum"] = 0 --拥有的数量
                    self._goodsList[i][idx]["buyNum"] = 0 --可购买数量
                    self._goodsList[i][idx]["buy"] = m["buy"] -- 能否购买 0 不能 1 能
                    self._goodsList[i][idx]["num"] = m["num"] -- 已购买次数

                    self._goodsList[i][idx]["descname"] = country_tech.name -- 名称
                    local totalBuy = tonumber(_goodsStatic["number"])
                    self._goodsList[i][idx]["buyNum"] = totalBuy - tonumber(m["num"])
                    if tonumber(i) ~= 1 then --限购
                        if m[tostring(self._playerUid)] then
                            self._goodsList[i][idx]["alreadyBuy"] = true
                        end
                    else
                        local _ownNum = 0
                        if tonumber(_goodsStatic["itemType"]) == zc.mainTypeResource then --资源
                            _ownNum = PlayerData:getResourcesInfoById(_goodsStatic["itemId"])
                        elseif tonumber(_goodsStatic["itemType"]) == zc.mainTypeWeapon then --兵器
                            _ownNum = PlayerData:getWeaponNumInBagById(_goodsStatic["itemId"])
                        elseif tonumber(_goodsStatic["itemType"]) == zc.mainTypeProp then --道具
                            local itemInfo = PlayerData:getBagInfoByID(_goodsStatic["itemId"]) or {}
                            _ownNum = itemInfo["num"] or 0
                        end
                        self._goodsList[i][idx]["ownNum"] = _ownNum --拥有的数量
                    end
                end
            end
            table.sort(self._goodsList[i],function(a,b)
                return tonumber(a["shopType"]) < tonumber(b["shopType"])
            end)
        end
    end

    --国家科技下一等级开启的道具
    local _nextOpenList = self:getNextOpenInfo(1) or {}
    -- dump(_nextOpenList,"sssss")
    if self._goodsList[1] then
        for i = 1, #_nextOpenList do
            self._goodsList[1][#self._goodsList[1]+1] = _nextOpenList[i]
        end
    end
end

function CountryShopLayer:getNextOpenInfo(type)
    if not self._nextOpenInfo then
        --提示开启下一级的道具
        
        local _list = {}
        local tech_list = {}
        local name = ""
        local level = 1
        -- dump(self._countryTechLevel)
        local techId = tonumber(self._countryTechLevel["techId"])
        local techLevel = tonumber(self._countryTechLevel["level"])

        local techData = gameData.getDataFromCache("country_tech_level") or {}
        local maxtechID = 1

        for k,v in pairs(techData) do
            if v.techId == tonumber(techId) then
                table.insert(tech_list,v)
            end
            if maxtechID < tonumber(v.techId) then
                maxtechID = tonumber(v.techId)
            end 
        end

        table.sort(tech_list,function (a,b)
            return a.level < b.level
        end)
        -- dump(tech_list)
        print("1-----,techId ",techId,"techLevel>",techLevel,"maxtechID:",maxtechID)
        if tonumber(techLevel) >= (tech_list[#tech_list].level) then
            if techId >= maxtechID then
                techId = maxtechID
                techLevel = tech_list[#tech_list].level - 1
                print("2-----,techId ",techId,"techLevel>",techLevel)
            else
                techId = techId + 1
                techLevel = 1
                print("3-----,techId ",techId,"techLevel>",techLevel)
            end
        else
            techLevel = techLevel + 1
        end
        print("4-----,techId ",techId,"techLevel>",techLevel)

        for k,v in pairs(techData) do
            if v.techId == tonumber(techId) and tonumber(techLevel) == v.level then
                local static = gameData.getDataFromCacheWithPrimaryKey("country_tech",techId)
                name = static.name
                level = v.level
            end
        end
        self.level = level
        self.name = name
        self.techId = techId
        local static = gameData.getDataFromCache("country_shop", {
            need = level,
            goodsType=type,
            tech = techId
        }) or {}
        if static.shopType then
            static = {static}
        end
        -- dump(techData,"-----")
        for k,v in pairs(static) do
            if v and v.shopType then
                local _index = #_list + 1 
                _list[_index] = v
                _list[_index]["isOpen"] = false --是否开启
                _list[_index]["ownNum"] = 0 --拥有的数量
                _list[_index]["buyNum"] = 0 --可购买数量
                _list[_index]["descname"] = name 
                _list[_index]["level"] = level
            end
        end
        table.sort(_list,function(a,b)
            return tonumber(a["shopType"]) < tonumber(b["shopType"]) 
        end)
        self._nextOpenInfo = _list
    end
    return self._nextOpenInfo
end
return CountryShopLayer