--[[
	FileName: GrabMineInviteListPop.lua
	Author: andong
	Date: 2016-12-06
	Purpose: 国家抢矿邀请界面
]]
local GrabMineInviteListPop = class( "GrabMineInviteListPop", function ()
    return ZCPopLayer:create({opacityValue=150})
end)
function GrabMineInviteListPop:create(parmas)
	return GrabMineInviteListPop.new(parmas)
end
function GrabMineInviteListPop:ctor(parmas)
	self:initData(parmas)
	self:initUI()
	self:show(false)
end

function GrabMineInviteListPop:initData(parmas)
    if parmas and parmas.callback then
        self._callback = parmas.callback
    end

    self._playerList = parmas.data or {}
    self._extraData = parmas.extraData or {}
    self._type = tonumber(self._extraData._type) or 1
end
function GrabMineInviteListPop:initUI(params)
	local popSize = cc.size(510, 478)
    local listPopBg = zc.getScaleNode("res/Main/common/popBg/popup_Bg_blue.png", popSize)
    listPopBg:setAnchorPoint( 0.5, 0.5 )
    listPopBg:setPosition(  zc.width/2, zc.height/2 )  
    self:addContent(listPopBg)
    self._listPopBg = listPopBg
    self._listPopSize = popSize

    local _titleTextDi = zc.getSprite({
        src = "res/Main/common/popBg/tipDi.png",
        pos = cc.p(popSize.width*0.5, popSize.height - 34),
    })
    listPopBg:addChild(_titleTextDi)

    local _titleText = zc.getSprite({
        src = "res/Main/country/grabMine/invite_title_"..self._type..".png",
        pos = cc.p( _titleTextDi:getPosition() ),
    })
    listPopBg:addChild(_titleText)

    local _closeButton = zc.createBackButton({
        pos = cc.p(popSize.width-10  , popSize.height), 
        listener = function () 
            self:hide({noAction=true})
        end,
    })
    listPopBg:addChild(_closeButton, 10)

    self:createPlayerList()

    --
    local cancelBtn = zc.createCommomBtn({
        tag = 2,
        text = zc.lang("cancel2"),
        needSwallow = true,
        endCallback = function()
            self:hide()
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(popSize.width/2-110, 46)
    })
    listPopBg:addChild(cancelBtn)

    local occupyBtn = zc.createCommomBtn({
        tag = 1,
        text = zc.lang("SENDTOCOUNTRY"),
        needSwallow = true,
        touchSize = cc.size(160, 70),
        endCallback = function()
            local _type = tonumber(self._extraData._type) or 1
            local _info = zc.lang("invite_country_member_seize") .. "!"
            local _flag = 1
            if _type == 1 then 
                local _data = gameData.getDataFromCacheWithPrimaryKey("mine", self._extraData.id) or {}
                _info = zc.lang("invite_country_member_defend") .. "“" .. _data.name.."”"
            elseif _type == 2 then 
                _flag = 2
                local mineInfo = self._extraData.mineInfo or {}
                local countryName = mineInfo["countryName"] or ""
                local mineUserName = ""
                for m = 1, 3 do
                    if mineInfo["userName"..m] and mineInfo["userName"..m] ~= "" then
                        if mineUserName == "" then
                            mineUserName = mineInfo["userName"..m]
                        else
                            mineUserName = mineUserName.."、"..mineInfo["userName"..m]
                        end
                    end
                end
                local _data = gameData.getDataFromCacheWithPrimaryKey("mine", mineInfo.countryMineId) or {}
                _info =  zc.lang("invite_country_member_seize") .. "“"..(mineInfo.countryName or "").."”"..zc.lang("defended").."“"..(_data.name or " ").."”"
            end
            local _text = {
                info = _info,
                _tag = _flag,
                _id = self._extraData.id ,
                _mineId = self._extraData.mineId ,
                _teamId = self._extraData.teamId ,
            }

            local _countryId = tonumber(PlayerData:getBaseInfoByTag("countryId")) or 0
            if _countryId == 0 and PlayerData:getBaseInfoByTag("countryName") == ""  then 
                zc.tipInfo(zc.lang("tips_unjoin_country"))
                return
            end
            zc.tipInfo(zc.lang("tips_send_success") .. "！")
            local _data = {countryId = _countryId}
            getNetManager():getRequestCenter():sendWords(2, _text, _data)

            self:hide({noAction=true})
        end,
        anchor = cc.p(0.5, 0.5),
        pos = cc.p(popSize.width/2+110, 46)
    })
    listPopBg:addChild(occupyBtn)
end
function GrabMineInviteListPop:createPlayerList()

    local tableSize = cc.size(469, 324)
    local tableNode = self._listPopBg
    local tableNodeSize = self._listPopSize

    local myTableBg = zc.getScaleNode("res/Main/common/popBg/di_1.png", tableSize)
    myTableBg:setAnchorPoint( 0.5, 0 )
    myTableBg:setPosition( tableNodeSize.width/2, 82 )
    tableNode:addChild(myTableBg)
    
    local myTable = zc.ZCTableView:create(cc.size(myTableBg:getContentSize().width-4,myTableBg:getContentSize().height-4))
    myTable:setPosition(2,2)
    myTable:setInertia(true) --设置惯性
    myTable:setBounceable(true)
    myTable:setDirection(zctech.SCROLLVIEW_DIRECTION_VERTICAL) --设置横向纵向
    myTable:setDelegate()
    myTable:setVerticalFillOrder(zctech.TABLEVIEW_FILL_TOPDOWN)
    
    myTableBg:addChild(myTable)
    
    local cellSize = cc.size(465, 98)
    self._cellSize = cellSize
    local function cellSizeForTable(table,idx)
    	return cellSize.height, cellSize.width
    end
    local function numberOfCellsInTableView(table)
        return #self._playerList
    end
    local function tableCellAtIndex(table,idx)
    	local nowIdx = idx + 1
    	local cell = table:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize( cellSize.width, cellSize.height ) 
            self:createCell(cell, nowIdx)
        end
        self:updateCell(cell, nowIdx)
        return cell
    end
    myTable:registerScriptHandler(numberOfCellsInTableView,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    myTable:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    myTable:registerScriptHandler(tableCellAtIndex,cc.TABLECELL_SIZE_AT_INDEX)
    myTable:reloadData()
    self._myTable = myTable

    if #self._playerList == 0 then
        local itemEmpty = zc.createSprite("res/Main/common/empty.png")
        itemEmpty:setPosition(tableSize.width/2, tableSize.height/2)
        myTableBg:addChild(itemEmpty)
    end
end
function GrabMineInviteListPop:createCell(cell, index)
	local cellSize = self._cellSize
	local middlePosy = cellSize.height/2

	local cell_img = zc.createSprite("res/Main/friend/add_cell_img.png")
	cell_img:setAnchorPoint(0.5, 0.5)
	cell_img:setPosition(cellSize.width/2, middlePosy)
	cell:addChild(cell_img)
	cell_img:setScaleX(455/360)

    local _headIcon = zc.createIconByData({
        data = {
            mainType = zc.mainTypeSoldier,
            type = 1, 
            id = 101,
            level = zc.getLevelTipShow().."10",
        }, 
        showLevel = true,
        mainRoleIcon = 1,
        pos = cc.p(60, middlePosy ),
    })
    _headIcon:setScale(74 / 120)
    cell:addChild(_headIcon)

    local name_bg = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(175, 30) )
    name_bg:setAnchorPoint(0, 0 )
    name_bg:setPosition( 123, 60)
    cell:addChild(name_bg)

    local weaponType = zc.createSprite( zc.getHeroTypeImg(1) )
    weaponType:setAnchorPoint(0, 0.5)
    weaponType:setPosition(-11, name_bg:getContentSize().height/2)
    name_bg:addChild(weaponType)
    name_bg:setScale(0.9)

    local name = zc.createLabel({
        fontSize = 18,
        ap = cc.p(0, 0.5),
        pos = cc.p(28, name_bg:getContentSize().height/2 ),
        color = display.COLOR_WHITE,
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.3
    })
    name_bg:addChild(name)

    local fight_bg = cc.Sprite:create( "res/Main/role/common/fight_bg.png" )
    fight_bg:setAnchorPoint(0, 0 )
    fight_bg:setPosition( 110, 7 )
    fight_bg:setScale( 0.6 )
	cell:addChild( fight_bg )
	local _fightingNum = zc.createFntLabel({
		text = 2500000,
        fnt = "res/Main/common/fnt/fight_change.fnt",
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 80, fight_bg:getContentSize().height/2 ),
        addwidth = -14,
    })
    fight_bg:addChild( _fightingNum )
    _fightingNum:setScale( 0.8 )


	local inviteBtn = zc.createPushButton({
		normalFile = "res/Main/country/grabMine/invite_btn_normal.png",
		selectedFile = "res/Main/country/grabMine/invite_btn_normal.png",
		disableFile = "res/Main/country/grabMine/invite_btn_disable.png",
		pos = cc.p(395, middlePosy),
        noScaleAction = true,
		endCallback = function() end
	})
	cell:addChild(inviteBtn)

	cell._headIcon = _headIcon
	cell._weaponType = weaponType
	cell._name = name
	cell._fightingNum = _fightingNum
	cell._inviteBtn = inviteBtn

end
function GrabMineInviteListPop:updateCell(cell, index)
	local playerData = self._playerList[index] or {}


    local newParmas = {
        data = {
            mainType = zc.mainTypeSoldier,
            type = 1,
            id = 101,
            level = zc.getLevelTipShow()..(playerData.level or "1"),
        },
        showLevel = true,
        mainRoleIcon = playerData.iconId or 1,
        listener = function ()
        end
    }
    zc.updateIconByData(cell._headIcon,newParmas)


    cell._fightingNum:setString(playerData.fighting)
    cell._name:setString(playerData.userName)


    cell._inviteBtn:setTouchEndedCall(function()

        -- _type(1：邀请占领、2：邀请挑战)
        local _type = tonumber(self._extraData._type) or 1
        local _params = {type=_type, targetUserIds=playerData.userId}
        if _type == 2 then
            _params = {type=_type, targetUserIds=playerData.userId, teamId=self._extraData.teamId}
        end
        
        zc.sendHttp({
            apiName = "CountryMine_inviteMember",
            params = _params,
            successCallback = function (net_data)
                zc.tipInfo(zc.lang("invite_success").. "！")
                playerData._hasInvited = true
                self._myTable:reloadDataAndScrollToCurrentCell()
            end
        })
    end)

    if playerData._hasInvited then
        cell._inviteBtn:setEnable(false)
    else
        cell._inviteBtn:setEnable(true)
    end
end

function GrabMineInviteListPop:onCleanup()
    if self._callback and type(self._callback) == "function" then
        self._callback()
    end
end

return GrabMineInviteListPop