--[[
	校场训练结束界面
	唐实聪
	2016.5.30
]]
local DrillFieldTrainingOverPop = class("DrillFieldTrainingOverPop", function()
	return ZCPopLayer:create()
end)

function DrillFieldTrainingOverPop:create( params )
	return DrillFieldTrainingOverPop.new( params )
end

function DrillFieldTrainingOverPop:ctor( params )
	self:initData( params )
	self:initUI()
    self:show()
end

function DrillFieldTrainingOverPop:initData( params )
    self._data = params.heroData
	self._size = self:getContentSize()
end

function DrillFieldTrainingOverPop:initUI()
	local bg = cc.Sprite:create( "res/Main/common/popBg/popBg_tip_blue.png" )
	bg:setPosition( self._size.width/2, self._size.height/2 )
	self:addContent( bg )
	local bgSize = bg:getContentSize()

	local title = zc.getTipPopTitle( "xunlianjieshu" )
    title:setPosition( bgSize.width/2, bgSize.height-30 )
    bg:addChild( title )
    -- tableview
    local tableview = zc.ZCTableView:create( cc.size( 603, 288 ) )
    tableview:setBounceable( true )
    tableview:setInertia( true )
    tableview:setDirection( cc.SCROLLVIEW_DIRECTION_VERTICAL )
    tableview:setPosition( cc.p( 13, 13 ) )
    tableview:setDelegate()
    tableview:setVerticalFillOrder( cc.TABLEVIEW_FILL_TOPDOWN )
    local cellWidth = 603
    local cellHeight = 83
    -- 屏幕上显示的cell数量
    local function cellSizeForTable(table, idx) 
        return cellHeight, cellWidth
    end
    local function tableCellAtIndex(table, cellIndex)
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell( cell, cellIndex, cellWidth, cellHeight )
        end
        -- 更新界面
        self:updateCell( cell, cellIndex )
        return cell
    end
    local function numberOfCellsInTableView()
    	return #self._data
    end
    tableview:registerScriptHandler( cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX )
    tableview:registerScriptHandler( tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX )
    tableview:registerScriptHandler( numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW )
    bg:addChild(tableview)
    tableview:reloadData()

    local close = zc.createBackButton({
        pos = cc.p(bgSize.width-10, bgSize.height-10),
        listener = function () 
            self:hide({music=true})
        end,
    })
    bg:addChild(close, 1)
end

function DrillFieldTrainingOverPop:buildCell( cell, cellIndex, cellWidth, cellHeight )
	-- cellBg
	local cellBg = cc.Sprite:create( "res/Main/drillField/over_cellbg.png" )
	cellBg:setPosition( cellWidth/2, cellHeight/2 )
	cell:addChild( cellBg )
	-- 头像
	local icon = zc.createIconByData({
        data = {
            mainType = zc.mainTypeSoldier,
            type = 1, 
            id = 1,
        },
        pos = cc.p( 43, cellBg:getContentSize().height/2 ), 
    })
    icon:setScale( 0.6 )
	cellBg:addChild( icon )
	cell._icon = icon
    -- 名字背景
    local nameBg = ccui.Scale9Sprite:create( cc.rect( 18, 18, 4, 4 ), "res/Main/common/common_inner22.png" )
    nameBg:setContentSize( 175, 30 )
	nameBg:setAnchorPoint( 0, 0.5 )
	nameBg:setPosition( 110, 55 )
	cellBg:addChild( nameBg )
    -- 名字
    local name = zc.createLabel({
        fontSize = 20,
        pos = cc.p( nameBg:getContentSize().width/2, nameBg:getContentSize().height/2 ),
        outLine = true,
    })
    nameBg:addChild( name )
    cell._name = name
	-- 兵器
	local weaponSp = cc.Sprite:create()
	weaponSp:setPosition( 0, nameBg:getContentSize().height/2 )
	nameBg:addChild( weaponSp )
	cell._weaponSp = weaponSp
	-- 进度条
	local progressBg = cc.Sprite:create( "res/Main/drillField/over_gray.png" )
	progressBg:setAnchorPoint( 0, 0.5 )
	progressBg:setPosition( 90, 21 )
    cellBg:addChild( progressBg )
    cell._progressBg = progressBg
	local oriExp = cc.Sprite:create( "res/Main/drillField/over_yellow.png" )
	oriExp:setAnchorPoint( 0, 0.5 )
    oriExp:setPosition( progressBg:getPosition() )
	cell._oriExp = oriExp
	local dstExp = cc.Sprite:create( "res/Main/drillField/over_green.png" )
	dstExp:setAnchorPoint( 0, 0.5 )
    dstExp:setPosition( progressBg:getPosition() )
	cell._dstExp = dstExp
	-- 模板
	local stencil = cc.Node:create()
	stencil:setAnchorPoint( 0, 0 )
	stencil:setPosition( 0, 0 )
    local stencilSp = cc.Sprite:create( "res/Main/drillField/over_gray.png" )
    stencilSp:setAnchorPoint( 0, 0.5 )
    stencilSp:setPosition( progressBg:getPosition() )
	stencil:addChild( stencilSp )
	-- clippingNode
	local clippingNode = cc.ClippingNode:create()
	clippingNode:addChild( oriExp )
	clippingNode:addChild( dstExp )
	clippingNode:setStencil( stencil )
	clippingNode:setInverted( false )
	clippingNode:setAlphaThreshold( 0 )
	cellBg:addChild( clippingNode )
	-- 增加经验值
	local addExp = zc.createLabel({
        fontSize = 20,
        color = zc.COLOR_GREEN,
        ap = cc.p( 0, 0.5 ),
        pos = cc.p( 454, progressBg:getPositionY() ),
        outLine = true,
	})
	cellBg:addChild( addExp )
	cell._addExp = addExp
end

function DrillFieldTrainingOverPop:updateCell( cell, cellIndex )
    local data = self._data[cellIndex + 1]
	zc.updateIconByData( cell._icon, {
        data = {
            mainType = zc.mainTypeSoldier,
            type = data.data.heroId, 
            id = data.data.heroId,
            level = zc.getLevelTipShow()..data.data.level,
            reincarnate = data.data.reincarnate,
        },
        showLevel = true,
    })
    local _nameText = data.data.name
    local _newAdvance = tonumber(data.data.newAdvance) or 0
    if _newAdvance > 0 then
        _nameText = _nameText .. "+" .. _newAdvance
    end
    cell._name:setText( _nameText )
    cell._weaponSp:setTexture( zc.getHeroTypeImg( data.data.weaponType or 1 ) )
    local oriLevel = tonumber( data.data.level )
    local oriExp = tonumber( data.data.exp ) + tonumber( data.addExp )
    local _exp = tonumber(gameData.getDataFromCacheWithPrimaryKey("hero_level", oriLevel).exp)
    while oriExp > _exp do
        oriLevel = oriLevel + 1
        _exp = tonumber(gameData.getDataFromCacheWithPrimaryKey("hero_level", oriLevel).exp)
        oriExp = oriExp - _exp
    end
    local oriPct = tonumber( data.data.exp )/tonumber( data.data.expLimit )
    -- print("oriPct====",oriPct,oriExp,oriLevel,_exp)
    cell._oriExp:setPositionX( cell._progressBg:getPositionX() + cell._progressBg:getContentSize().width*( oriPct - 1 ) )
    local dstPct = oriExp/tonumber( _exp )
    -- print("dstPct====",dstPct)
    cell._dstExp:setPositionX( cell._progressBg:getPositionX() + cell._progressBg:getContentSize().width*( dstPct - 1 ) )
    cell._addExp:setText( "EXP+"..data.addExp )
    if oriLevel < tonumber( data.data.level ) then
        cell._oriExp:setLocalZOrder( 1 )
        cell._dstExp:setLocalZOrder( 2 )
    else
        cell._oriExp:setLocalZOrder( 2 )
        cell._dstExp:setLocalZOrder( 1 )
    end
end

return DrillFieldTrainingOverPop