--[[
	英雄试炼副本选择关卡
]]

local HeroCopyDetailPop = class("HeroCopyDetailPop", function()
	return ZCPopLayer:create({opacityValue = 200, hideCallback = nil})
end)

function HeroCopyDetailPop:create( params )
	return HeroCopyDetailPop.new( params )
end

function HeroCopyDetailPop:onEnter( ... )
	-- performWithDelay(self, function()
	-- 	print("performWithDelay:HeroCopyDetailPop")
	-- 	if LayerManager.getTopInfoLayer() then
	-- 		print("performWithDelay:HeroCopyDetailPop" .. 1)
	-- 		LayerManager.getTopInfoLayer():setVisible(false)
	-- 	end
 --    end, 1)
	if self._init then
		-- if LayerManager.getTopInfoLayer() then
		-- 	print("getTopInfoLayer")
		-- 	LayerManager.getTopInfoLayer():setVisible(false)
		-- end

		return
	end
	self._init = true
	zc.addEventListener({
    	name = CUSTOM_EVENT.EVENT_HEROCOPY_CHANGE,
    	callback = function(data)
	    	-- dump(data.data,"---test----")
			self:initData(data.data)
			self:updateUI()
    end})
    LayerManager.getTopInfoLayer():setVisible(false)
    print("------------**********************---------------")
    PlayerData.HeroCopyDetailPop = true
end

function HeroCopyDetailPop:guideFunc()
    local currentGID = getGuideManager():getCurrentGID()
    -- print("currentGID" .. currentGID)

    if currentGID == GuideKey.KEY_15006 then
    	getGuideManager():setCurrentGID(GuideKey.KEY_15007)
        getGuideManager():setObjTarget(self.guideBtn)
        getGuideManager():startGuide()
    elseif currentGID == GuideKey.KEY_15008 then
    	getGuideManager():setCurrentGID(GuideKey.KEY_15009)
    	getGuideManager():setObjTarget(self.rewardBg:getChildByName("firstReward"))
        getGuideManager():startGuide()
    end
end

function HeroCopyDetailPop:ctor( params )
	self:initData( params )
	self:initUI()

	self:getContainerLayer():setTouchEndedCallback(function()

	end)

	self:show(false) -- 显示阴影
	self:updateUI()
end

function HeroCopyDetailPop:initData(params)

	-- print("self.guankaIdx" .. self.guankaIdx)
	-- dump(params)

	-- if params.isDrop then
	-- 	self.isDrop = params.isDrop
	-- end

	self.copyInfo = params.data
	if params.chapterId then
		self.chapterId = params.chapterId --大章节id
	end
	if params.houseIdx then
		self.houseIdx = params.houseIdx --小房子索引
	end

	if params.callbackCount then
		self.callback = params.callbackCount --刷新上级界面的次数
	end

	if params.callbakcShowAnimation then
		self.animationCallBack = params.callbakcShowAnimation --这个是用来播新出现的小房子动作的
	end

	if params.guankaIdx then
		self.guankaIdx = params.guankaIdx
	end

	if self.guankaIdx then
		self.guankaIdx = self.guankaIdx--选择的关卡索引
	else
		self.guankaIdx = self:getFirstEntryGuankaIdx()
	end
	self.guankaStaticInfo = gameData.getAllDataWithNoClone("heroTrainTollgate")
	
	
end


--有没有星级奖励可以领取
function HeroCopyDetailPop:isStartReward()
	local staticData = gameData.getAllDataWithNoClone("heroTrainStarAwards")

    local starRewardCount = 0
    local chapter = (self.chapterId-1)*9 + self.houseIdx

    --星星个数
    local starNum = 0
    if self.copyInfo[tostring(chapter)] then
        for k,v in pairs(self.copyInfo[tostring(chapter)].chapterInfo) do
            starNum = tonumber(v.s) + starNum
        end
    end

    --算出总共能领的奖励个数
    for k,v in pairs(staticData) do
        if tonumber(v.chapterId) == chapter then
            if starNum >= tonumber(v.starNumber) then
            	starRewardCount = starRewardCount + 1
            end
        end
    end

   	if self.copyInfo[tostring(chapter)] then
   		return table.nums(self.copyInfo[tostring(chapter)].received) < starRewardCount
   	else
   		return false
   	end
end

--第一次进来让他选中当前能打得最新关卡
function HeroCopyDetailPop:getFirstEntryGuankaIdx()
	local idx = 1
	if self.copyInfo[tostring((self.chapterId-1)*9 + self.houseIdx)] then
		idx = table.nums(self.copyInfo[tostring((self.chapterId-1)*9 + self.houseIdx)].chapterInfo) + 1
		return math.min(idx, 5)
	end

	return 1
end

--获得关卡名字
function HeroCopyDetailPop:getTitleDes()
	local copyStatic = gameData.getAllDataWithNoClone("heroTrainChapter")

	return copyStatic[tostring((self.chapterId-1)*9 + self.houseIdx)].name
end

--获取每关的星星数
function HeroCopyDetailPop:getCopyStar(idx)
	local starNum = 0
    if self.copyInfo[tostring((self.chapterId-1)*9 + self.houseIdx)] then
        for k,v in pairs(self.copyInfo[tostring((self.chapterId-1)*9 + self.houseIdx)].chapterInfo) do
            local tollgateId = self:getTollgateId(idx)
            if tollgateId == tonumber(k) then
                starNum = starNum + tonumber(v.s)
            end
        end
    end
    return starNum
end

--有没有首杀奖励
function HeroCopyDetailPop:isFirstReward()
	if self.copyInfo[tostring((self.chapterId-1)*9 + self.houseIdx)] then
        for k,v in pairs(self.copyInfo[tostring((self.chapterId-1)*9 + self.houseIdx)].chapterInfo) do
            local tollgateId = self:getTollgateId(self.guankaIdx)
            if tollgateId == tonumber(k) then
                if tonumber(v.r) == 2 then
                	return true
                else
                	return false
                end
            end
        end
    end
    return false
end

function HeroCopyDetailPop:setFirstReward()
	for k,v in pairs(self.copyInfo[tostring((self.chapterId-1)*9 + self.houseIdx)].chapterInfo) do
        local tollgateId = self:getTollgateId(self.guankaIdx)
        if tollgateId == tonumber(k) then
            v.r = 0
        end
    end
end

--是不是可以扫荡
function HeroCopyDetailPop:getIsPass()
	if self.copyInfo[tostring((self.chapterId-1)*9 + self.houseIdx)] then
        for k,v in pairs(self.copyInfo[tostring((self.chapterId-1)*9 + self.houseIdx)].chapterInfo) do
            local tollgateId = self:getTollgateId(self.guankaIdx)
            if tollgateId == tonumber(k) then
                return tonumber(v.s)
            end
        end
    end
    return false
end

--获取关卡id
function HeroCopyDetailPop:getTollgateId(guankaIdx)
	local idx = self.guankaIdx
	if guankaIdx then
		idx = guankaIdx
	end
	local str = "10" .. string.format("%02d", (self.chapterId-1)*9 + self.houseIdx) .. string.format("%03d", idx ) 
	return tonumber(str)
end

--奖励信息
function HeroCopyDetailPop:getReward(idx)
	local staticData = self.guankaStaticInfo[tostring(self:getTollgateId())]

	local list = {}

	local str = ""
	if idx == 1 then   --首杀
		str = staticData.firstDrop
	elseif idx == 2 then  --普通
		str = staticData.commonDrop
	end

	if string.find(str, ",") then
		list = string.split(str, ",")
	else
		list = str
	end

	local rewardList = {}

	for i=1,#list do
		local tb = string.split(list[i], "|")
		local reward = {}
		reward.type = tonumber(tb[1])
		reward.id = tonumber(tb[2])
		reward.num = tonumber(tb[3])
		table.insert(rewardList, reward)
	end
	return rewardList
end

--获得禁止出战的信息
function HeroCopyDetailPop:getCannotInfo()
	local staticData = self.guankaStaticInfo[tostring(self:getTollgateId())]

	local limit1 = {}  --禁止出战的国家
	local limit2 = {}	--禁止出战的类型

	if string.find(staticData.fightLimit1, ",") then
		limit1 = string.split(staticData.fightLimit1, ",")
	elseif tonumber(staticData.fightLimit1) ~= "" then
		table.insert(limit1, tonumber(staticData.fightLimit1))
	end

	if string.find(staticData.fightLimit2, ",") then
		limit2 = string.split(staticData.fightLimit2, ",")
	elseif tonumber(staticData.fightLimit2) ~= "" then
		table.insert(limit2, tonumber(staticData.fightLimit2))
	end

	local limitStr = ""
	limitStr_config = { zc.lang("herocopy_country1"), zc.lang("herocopy_country2"), zc.lang("herocopy_country3"), zc.lang("herocopy_country4")}

	if table.nums(limit1) ~= 0 then
		for i=1,#limit1 do
			limitStr = limitStr .. limitStr_config[tonumber(limit1[i])] .. " "
		end
	end
	return limitStr, limit2
end

function HeroCopyDetailPop:initUI()

	local _backBtn = zc.createTopBackButton({
            pos = cc.p(zc.width - 60, zc.height - 40), 
            listener = function()
            	LayerManager.getTopInfoLayer():setVisible(true)
                self:hide()
            end,
        })
	self:addChild(_backBtn,5)

	local titleBg = cc.Sprite:create( "res/Main/copy/heroCopy/title.png" )
	titleBg:setAnchorPoint(ccp(0.5, 0))
	titleBg:setPosition(ccp(zc.width/2, zc.height - titleBg:getContentSize().height))
	self:addContent(titleBg)

	local title = zc.createLabel({ap = ccp(0.5, 0.5), text = "第12章 黄巾之乱", fontSize = 20, pos = ccp(titleBg:getContentSize().width/2 - 7, titleBg:getContentSize().height/2 + 4)})
	titleBg:addChild(title)
	self.title = title

	self.person = cc.Sprite:create( "res/Main/hero/body/22.png" )
	self.person:setAnchorPoint(ccp(0.5, 0))
	self.person:setScale(0.75)
	self.person:setPosition(ccp(zc.width/2 - 100, zc.height/2-160))
	self:addContent(self.person,-1)

	self.redBg = cc.Sprite:create( "res/Main/copy/heroCopy/red_bg.png" )
	self.redBg:setAnchorPoint(ccp(0.5, 0.5))
	self.redBg:setPosition(ccp(zc.width/2+170, zc.height/2))
	self:addContent(self.redBg,2)

	for i=1,5 do
		local copyBg = ZCSprite:create( "res/Main/copy/heroCopy/open_1.png" )
		copyBg:setTag(i)
		copyBg:setName("copyBg" .. i)
		copyBg:setTouchEndedCallback(function ()
			if i > self:getFirstEntryGuankaIdx() then
				zc.tipInfo(zc.lang("herocopy_unlock"))
				return 
			end

			self.guankaIdx = i
			self:updateUI()
			self:initRewardTableViwe()

			local currentGID = getGuideManager():getCurrentGID()
    		if currentGID == GuideKey.KEY_15007 then
    			getGuideManager():getCurrentGID(GuideKey.KEY_15008)
    			getGuideManager():setObjTarget(self.fightBtn)
    			getGuideManager():startGuide()
    		end
		end)

		--功能引导用
		if i == 1 then
			self.guideBtn = copyBg
		end

		local img = cc.Sprite:create( "res/Main/copy/heroCopy/copy_" .. i .. ".png" )
		img:setPosition(ccp(img:getContentSize().width/2, copyBg:getContentSize().height/2))
		copyBg:addChild(img)

		local starBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
		starBg:setPosition(ccp(100, copyBg:getContentSize().height/2))
        starBg:setName("starBg")
        starBg:setAnchorPoint(ccp(0, 0.5))
        starBg:setContentSize(100,30)

        copyBg:addChild(starBg)

        for j=1,3 do
        	local starImg = zc.createSprite("res/Main/common/common_hero_star_1.png")
	        starImg:setScale(0.8)
	        starImg:setAnchorPoint(ccp(0, 0.5))
	        starImg:setPosition(ccp(7 + (j-1)*30, starBg:getContentSize().height/2))
	        starImg:setName("starImg" .. j)
	        starBg:addChild(starImg)
        end

		copyBg:setPosition(ccp(self.redBg:getContentSize().width/2 + 67 - (i-1)*40, self.redBg:getContentSize().height - 220 - (i-1)*110))
		self.redBg:addChild(copyBg)
	end

	local line = ZCSprite:create("res/Main/copy/heroCopy/line.png")
	line:setSwallowTouches(false)
	line:setScaleY(2)
	line:setPosition(ccp(zc.width/2 + 400, zc.height/2 + 30))
	line:setAnchorPoint(ccp(0.5, 0))
	self:addChild(line,3)
	self.line = line

	local boxImg = ZCSprite:create("res/Main/copy/heroCopy/box.png")
	-- boxImg:setSwallowTouches(true)
	boxImg:setScaleY(0.5)
	boxImg:setTouchEndedCallback(function ()

		local currentGID = getGuideManager():getCurrentGID()
		if currentGID == GuideKey.KEY_15010 or currentGID == GuideKey.KEY_15011 then
			getGuideManager():setFuncGuideOver()
		end
		getGuideManager():addMaskLayer()
		self.line:runAction(cc.Sequence:create(
            cc.MoveBy:create(0.2, ccp(0, -50)),
            cc.MoveBy:create(0.2, ccp(0, 50)),
            cc.CallFunc:create(function()
				local chapter = (self.chapterId - 1)*9 + self.houseIdx
				getGuideManager():removeMaskLayer()
				local callBack = function()
					self:updateUI()
				end
            	zc.createSourcePop( "HeroCopyStarRewardPop", "src/layer/heroCopy/HeroCopyStarRewardPop.lua", {chapter = chapter, copyInfo = self.copyInfo, callback = callBack} )
			end))
        )
	end)
	boxImg:setPosition(ccp(line:getContentSize().width/2, 0))
	line:addChild(boxImg)
	self.boxImg = boxImg

	local keyLight = zc.createSpine({scale = 1, fileName = "yaoshiguang", path = "res/animation/huodongbaoxiang/"})
	keyLight:setPosition(ccp(self.boxImg:getContentSize().width/2, self.boxImg:getContentSize().height/2 - 10))    
    keyLight:playAction("idle", true)
    keyLight:setName("keyLight")
    self.boxImg:addChild(keyLight)

	local nameBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
	nameBg:setContentSize(90,35)
	nameBg:setPosition(ccp(46, -15))
	boxImg:addChild(nameBg)

	nameBg:addChild(zc.createLabel({text = zc.lang("herocopy_get"), fontSize = 20, color = ccc3(255, 216, 161), pos = ccp(18, 17)}))
	nameBg:addChild(zc.createImageView({src = "res/Main/common/common_hero_star_1.png", scale = 0.8, pos = ccp(45, 17)}))
	nameBg:addChild(zc.createLabel({text = zc.lang("herocopy_reward"), color = ccc3(255, 216, 161), fontSize = 20,pos = ccp(77, 17)}))

	self.rewardBg = ZCSprite:create("res/Main/copy/heroCopy/rewardBg.png")
	self.rewardBg:setAnchorPoint(ccp(0.5, 0))
	self.rewardBg:setPosition(ccp(zc.width/2 - 185, 0))
	self:addContent(self.rewardBg,3)

	local dropImg = ZCSprite:create("res/Main/copy/heroCopy/drop.png")
	dropImg:setPosition(ccp(self.rewardBg:getContentSize().width/2 + 10, self.rewardBg:getContentSize().height-10))
	self.rewardBg:addChild(dropImg)

	local normal_ = zc.createSprite("res/Main/copy/heroCopy/firstBg.png")
	local selected_ = zc.createSprite("res/Main/copy/heroCopy/firstBg.png")
    local firstReward = zc.createPushButton({
        normalNode = normal_,
        selectedNode = selected_,
        text = zc.lang("herocopy_firstReward"),
        fontColor = ccc3(255, 216, 161),
        pos = ccp(40,self.rewardBg:getContentSize().height+ 30),
        scale = 1,
        fontSize = 22,
        text_pos = ccp(55, 10),
        outLine = true,
        endCallback = function ( )

    		local award = self:getReward(1)
        	local id = self:getTollgateId()
        	local canGet = self:isFirstReward()
        	local callback = function()
        		self:setFirstReward()
        		self:updateUI()

        		local currentGID = getGuideManager():getCurrentGID()

        		if currentGID == GuideKey.KEY_15010 then
        			local function _callBack()
		        	performWithDelay(self, function()
				            getGuideManager():setObjTarget(self.boxImg)
				            getGuideManager():startGuide()
					    end, 0.3)
			        end
			        getGuideManager():setHeroFuncCallBack(_callBack)
			        getGuideManager():startGuide()
        		end

        	end

        	zc.createSourcePop( "HeroCopyRewardPop", "src/layer/heroCopy/HeroCopyRewardPop.lua", {reward = award, tollgateId = id, canGet = canGet, callback = callback} )
        end
    })
    self.rewardBg:addChild(firstReward)
    firstReward:setName("firstReward")
    -- firstReward:setVisible(false)
    local _spine = zc.createSpine({scale = 1, fileName = "zhaocaimao", path = "res/animation/shilian/"})
	_spine:setPosition(ccp(65, 50))    
    _spine:playAction("animation", true)
    firstReward:addChild( _spine, -1 )
    _spine:setName("_spine")

    local firstTextBg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    firstTextBg:setPosition(ccp(55, 10))
    firstTextBg:setContentSize(100,35)
    firstReward:addChild(firstTextBg)

    for i=1,2 do
    	local cannotBg = cc.Sprite:create("res/Main/copy/leftTimesBg.png")
    	cannotBg:setName("cannotBg" .. i)
	    cannotBg:setAnchorPoint(0, 0)
	    cannotBg:setPosition(zc.width-350, 60-(i-1)*35)
	    cannotBg:setContentSize(145,48)
	    self:addChild(cannotBg)
	    cannotBg:addChild(zc.createLabel({name = "cannotText",text = zc.lang("herocopy_cannot"), fontSize = 20, pos = ccp(27, 0), ap = ccp(0, 0),color = ccc3(255, 216, 161)}))
    	
    	for j=1,5 do
    		if i == 1 then
    			local weaponIcon = zc.createSprite("res/Main/role/common/weapon_icon_1.png" )
    			weaponIcon:setPosition(ccp(233+(j-1)*41, 12))
    			weaponIcon:setScale(0.5)
    			weaponIcon:setName("weaponIcon" .. j)
    			cannotBg:addChild(weaponIcon)
    		elseif j == 1 then
    			local weaponIcon = zc.createLabel({ap = ccp(0, 0), pos = ccp(215, 0), fontSize = 20, text = "111", color = display.COLOR_RED})
    			weaponIcon:setName("weaponIcon" .. j)
    			cannotBg:addChild(weaponIcon)
    		end
    	end
    end

    local normal_ = zc.createSprite("res/Main/copy/heroCopy/fight.png")
	local selected_ = zc.createSprite("res/Main/copy/heroCopy/fight.png")
    local fightBtn = zc.createPushButton({
        normalNode = normal_,
        selectedNode = selected_,
        pos = ccp(zc.width - 100, zc.height/2 - 170),
        scale = 1,
        fontSize = 22,
        outLine = true,
        endCallback = function ( )
        	if self:getIsPass() == 1 or self:getIsPass() == 2 then
		        if self.copyInfo.totalTimes <= 0 then
		    		if self:canBuyTime() then
		    			self:buyTimes()
		    		else
		    			zc.tipInfo(zc.lang("herocopy_noTimes"))
		    		end
		    		return
		    	end
		    end
        	zc.sendHttp({
                apiName = "Hero_CopyInfo",
                params = {tollgateId = self:getTollgateId()},
                successCallback = function(data)
                	local _enemyGroup = gameData.getDataFromCache("heroTrainNpcGroup", {tollgateId = self:getTollgateId()})
		            local _enemysData = {
			            tollgateId = self:getTollgateId(),
		            	enemys = {}
		            }
		            for i = 1, 9 do
		                local _npcId = tonumber(_enemyGroup["location" .. i]) or 0
		                if _npcId ~= 0 then
		                    _enemysData.enemys[i] = gameData.getDataFromCacheWithPrimaryKey("heroTrainNpc", _npcId)
		                else
		                	_enemysData.enemys[i] = {}
		                end
		            end

		            local _isFirst = 1

		            local _params = {
		                battleType = BattleType.HeroCopy, 
		                enemys = _enemysData, 
		                tollgateId = self:getTollgateId(),
		                fightScene = 1,
		                isFirstFight = _isFirst,
		                callback = function()
							performWithDelay(self, function()
								if LayerManager.getTopInfoLayer() then
									print("performWithDelay:HeroCopyDetailPop" .. 1)
									LayerManager.getTopInfoLayer():setVisible(false)
								end
						    end, 0.6)
		            	end
		            }
    				zc.createMatrixBattle( _params )
    				PlayerData.HeroCopyDetailPop = true
                end,
            })
        end
    })
    self:addChild(fightBtn)
    self.fightBtn = fightBtn
    fightBtn:setVisible(true)

    local normal_ = zc.createSprite("res/Main/copy/heroCopy/fight_more.png")
	local selected_ = zc.createSprite("res/Main/copy/heroCopy/fight_more.png")
    local fightMoreBtn = zc.createPushButton({
        normalNode = normal_,
        selectedNode = selected_,
        pos = ccp(zc.width - 100, zc.height/2 - 170),
        scale = 1,
        fontSize = 22,
        outLine = true,
        endCallback = function ( )
        	-- self:sweepCopy()
        	if self.copyInfo.totalTimes <= 0 then
        		if self:canBuyTime() then
	    			self:buyTimes()
	    		else
	    			zc.tipInfo(zc.lang("herocopy_noTimes"))
	    		end
        		return
        	else
        		self.copyInfo.totalTimes = self.copyInfo.totalTimes  - 1
        	end

        	if self.callback then
        		self.callback()
        	end

        	local tollDb = {}
        	tollDb.id = self:getTollgateId()
        	local _params = {
                dropInfo = self:getReward(2),
                tollDb = tollDb,
                nationId = 4,
            }
            zc.createSourcePop("Copysweep", "src/layer/chapter/CopysweepPop.lua", _params)
        end
    })
    self:addChild(fightMoreBtn)
    self.fightMoreBtn = fightMoreBtn
    self.fightMoreBtn:setVisible(false)
	self:initRewardTableViwe()

	--阻挡穿透，不用看，也不要删。暂无用
	-- local stopBtn = zc.createPushButton({
	-- 		touchSize = cc.size(80,60),
	--         endCallback = function()
	--         	return
	--         end
	-- 	})
	-- stopBtn:setPosition(zc.width - 100, zc.height/2 - 85)
	-- self:addChild(stopBtn)
end

function HeroCopyDetailPop:updateUI()

	print("HeroCopyDetailPop:updateUI")

	self.fightMoreBtn:setVisible(self:getIsPass() == 3)
	self.fightBtn:setVisible(not (self:getIsPass() == 3))
	self.title:setText(self:getTitleDes())


	local keyLight = self.boxImg:getChildByName("keyLight")
	keyLight:setVisible(self:isStartReward())

	local bodyId = self.guankaStaticInfo[tostring(self:getTollgateId())].card

	self.person:setTexture("res/Main/hero/body/" .. bodyId ..".png")

	local firstReward = self.rewardBg:getChildByName("firstReward")
	firstReward:setVisible(true)
	local _spine = firstReward:getChildByName("_spine")
	_spine:setVisible(self:isFirstReward())
	if self:isFirstReward() then
		firstReward:setText(LANGUAGE_TOLLGATEHERO.can_fetch)
		firstReward:getLabel():setPosition(ccp(55, 10))
	else
		if self:getIsPass() then
			firstReward:setVisible(false)
		else
			firstReward:setText(zc.lang("herocopy_firstReward"))
			firstReward:getLabel():setPosition(ccp(55, 10))	
		end
	end

	for i=1,5 do
		local copyBg = self.redBg:getChildByName("copyBg" .. i)
		local starBg = copyBg:getChildByName("starBg")

		local starVisible = true

		if i == self.guankaIdx then
			copyBg:setTexture("res/Main/copy/heroCopy/open_select.png")
		elseif i <= self:getFirstEntryGuankaIdx() then
			copyBg:setTexture("res/Main/copy/heroCopy/open_1.png")
		else
			starVisible = false
			copyBg:setTexture("res/Main/copy/heroCopy/open_2.png")
		end

		starBg:setVisible(starVisible)

		for j=1,3 do
			local starImg = starBg:getChildByName("starImg" .. j)
			if j <= self:getCopyStar(i) then
				starImg:setTexture("res/Main/common/common_hero_star_1.png")
			else
				starImg:setTexture("res/Main/common/common_hero_star_2.png")
			end
		end
	end

	--禁战相关
	local limitInfo1, limitInfo2 = self:getCannotInfo()
	for i=1,2 do
    	local cannotBg = self:getChildByName("cannotBg" .. i)
    	for j=1,5 do
    		if i == 1 then --噤战武将类型
    			local weaponIcon = cannotBg:getChildByName("weaponIcon" .. j)
    			if table.nums(limitInfo2) ~= 0 then
	    			if j <= table.nums(limitInfo2) then
	    				weaponIcon:setVisible(true)
	    				weaponIcon:setTexture("res/Main/role/common/weapon_icon_" .. limitInfo2[j] .. ".png")
	    			else
	    				weaponIcon:setVisible(false)
	    			end
	    		else
	    			cannotBg:setVisible(false)
	    		end
    			
    		elseif j == 1 then --噤战武将国家
    			local weaponIcon = cannotBg:getChildByName("weaponIcon" .. j)
    			if limitInfo1 ~= "" then
    				cannotBg:setVisible(true)
    				weaponIcon:setText(limitInfo1)
    			else
    				cannotBg:setVisible(false)
    			end
    		end
    	end
    end

    self:guideFunc()
end

function HeroCopyDetailPop:initRewardTableViwe()

	if self.rewardTableView then
		self.rewardTableView:removeFromParentAndCleanup(true)
	end

	self.commonReward = self:getReward(2)

	local tableView = zc.ZCTableView:create(cc.size(270 ,90))
    tableView:setDirection( cc.SCROLLVIEW_DIRECTION_HORIZONTAL )
    tableView:setPosition(40,self.rewardBg:getContentSize().height-110)
    tableView:setDelegate()
    tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    local _cellWidth = 90
    local _cellHeight = 90
    local function cellSizeForTable(table, cellIndex) 
        return _cellHeight, _cellWidth
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = table:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            self:buildCell(cell, cellIndex + 1)
        end
        -- 更新界面
        self:updateCell(cell, cellIndex + 1,table)
        return cell
    end
    local function numberOfCellsInTableView()
        return table.nums(self.commonReward)
    end
    tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
   
    self.rewardBg:addChild( tableView )
    tableView:reloadData()
    self.rewardTableView = tableView
end

function HeroCopyDetailPop:buildCell(cell)
    local item, info = zc.createIconByData({
        data = {
            mainType = 1,
            type = 1, 
            id = 1,
            num = 2,
        }, 
        showDetailPop = true,
        pos = cc.p(45, 45), 
    })
    item:setScale(0.6)
    cell:addChild(item)
    cell.item = item
end

function HeroCopyDetailPop:updateCell(cell, idx)

	local nowData = self.commonReward[idx]
    zc.updateIconByData(cell.item,{
    		data = {
            mainType = nowData.type,
            type = nowData.id,
            id = nowData.id,
            num = nowData.num,
        }, 
    	})
    cell.item:setTouchEndedShowTip()
end

--还有没有购买次数
function HeroCopyDetailPop:canBuyTime()
	local vipLv = tonumber( PlayerData:getBaseInfoByTag( "vip" ) ) or 0
    -- print("vipLv:" .. vipLv)

    local info = gameData.getDataFromCacheWithPrimaryKey("vip", 27)    
    -- dump(info)
    local maxNum = tonumber(info["vip" .. vipLv])
    if tonumber(self.copyInfo.buyTimes) >= maxNum then
        -- zc.tipInfo(zc.lang("herocopy_countLimit"))
        return false
    end

    return true
end


--购买次数
function HeroCopyDetailPop:buyTimes()

    local _consumeData = gameData.getDataFromCache("consume_price", {type=62, subtype=( tonumber( self.copyInfo.buyTimes ) + 1 )})

    self._comsumePrice = _consumeData.price
    local vipLv = tonumber( PlayerData:getBaseInfoByTag( "vip" ) ) or 0

    local info = gameData.getDataFromCacheWithPrimaryKey("vip", 27)    
    local maxNum = tonumber(info["vip" .. vipLv])


    local length = string.len(tostring(self._comsumePrice)) + 2

    -- 购买弹窗
    local params = {
        tip = LANGUAGE_ARENA_BUY( self._comsumePrice ),
        special = {
            {
                begin = 5,
                length = length,
                color = display.COLOR_YELLOW,
            }
        },
        bottomDes = {
            maxNum = maxNum,
            haveBuyNum = tonumber(self.copyInfo.buyTimes)
        },
        consume = {
            [1] = {
                type = 1,
                num = self._comsumePrice,
            }
        },
        clickHide = false,
        _type = 1,
        buyTimes = self.copyInfo.buyTimes,
        callback = function( data )
                zc.sendHttp({
                    apiName = "Hero_BuyTimes",
                    params = {times = 1},
                    successCallback = function(data)
                        dump(data)
                        self.copyInfo.totalTimes = self.copyInfo.totalTimes + 1
                        self.copyInfo.buyTimes = tonumber(self.copyInfo.buyTimes) + 1
                        print("self.copyInfo.buyTimes: .. " .. self.copyInfo.buyTimes)
                        PlayerData:updataData( data )
                        if self.callback then
                        	self.callback()
                        end
                        zc.tipInfo( zc.lang("tips_buy_success") )
                        self:updateUI()
                    end
                })
            -- end
        end
    }

    zc.createSourcePop( "MakeBuyTimesPop", "src/layer/makeUp/MakeBuyTimesPop.lua", params )
end


function HeroCopyDetailPop:onExit()
	if self.animationCallBack then
		self.animationCallBack()
	end
	PlayerData.HeroCopyDetailPop = false
end

function HeroCopyDetailPop:onCleanup() 
	zc.removeEventListener( CUSTOM_EVENT.EVENT_HEROCOPY_CHANGE )
end

return HeroCopyDetailPop