--[[
    FileName: UpcomingOpenPop.lua
    Author: andong
    Date: 2016-03-17
    Purpose: xx弹窗
]]
local UpcomingOpenPop = class( "UpcomingOpenPop", function ()
    return ZCPopLayer:create({opacityValue=180})
end)
function UpcomingOpenPop:create(params)
    return self.new(params)
end
function UpcomingOpenPop:ctor(params)
    self:initData(params)
    self:initUI()
    self:show(false)
end
function UpcomingOpenPop:initData(params)
    self._params = params.nextInfo
end
function UpcomingOpenPop:initUI()
    local _spine = zc.getSpine( "xingongnengyindao" )
    _spine:setPosition( cc.p(zc.width/2,zc.height/2) )
    _spine:playAction( "hit", false )
    self:addChild(_spine,2)
    _spine:registerSpineEventHandler( function ( event )
        if event.animation == "hit" then
            _spine:playAction( "idle", true)
        end
    end, sp.EventType.ANIMATION_COMPLETE)
    self._spine = _spine
    local bgSp = zc.createSprite()
    bgSp:setContentSize(cc.size(zc.width,zc.height))
    bgSp:setPosition(zc.width/2,zc.height/2)
    self:addChild(bgSp,10)
    bgSp:setCascadeOpacityEnabled(true)
    local _normal = zc.createSprite("res/Main/common/common_icon_"..self._params.icon..".png")
    _normal:setPosition(cc.p(zc.width/2,zc.height/2+60))
    bgSp:addChild(_normal)
    local content = zc.createLabel({
        text = self._params.content,
        outLine = true,
        fontSize = 26,
        fontName = zc.getFont(1),
        ap = cc.p(0, 0.5),
        pos = cc.p(zc.width/2-276, zc.height/2+106),
        color = display.COLOR_WHITE,
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.5,
    })
    bgSp:addChild(content)
    local descStr = self._params.desc 
    if descStr == "" then
        descStr = zc.lang("coming_soon") .. self._params.content.. zc.lang("func") .. "!"
    end
    local descLab = zc.createLabel({
        text = descStr,
        stroke = true,
        fontSize = 20,
        fontName = zc.getFont(1),
        ap = cc.p(0, 1),
        pos = cc.p(zc.width/2-276, zc.height/2+80),
        color = cc.c3b(223,216,197),
        color2 = display.COLOR_BLACK,
        align = kCCTextAlignmentCenter,
        pixel = 1.5,
        width = 150,
    })
    bgSp:addChild(descLab)
    --文字描述 cc.c3b( 255, 54, 68 )
    local _msg = ""
    if tonumber(self._params.userLevel) == 1 then
        local tollgateId = tonumber(self._params.tollgateId) or 0
        local tollgateInfo = gameData.getDataFromCacheWithPrimaryKey("tollgate", tollgateId) or {}
        local guanqia = tollgateId % 100
        _msg = "[size=22][color=ffe2cb5a]" .. zc.lang("finish_tollgate") .. " [/size][/color][size=24][color=ffff3644]" .. zc.lang("num_di") ..tostring(tollgateInfo.chapterId).. zc.lang("num_zhang") ..guanqia.. zc.lang("num_guan") .. "[/size][/color][size=22][color=ffe2cb5a] " .. LANGUAGE_ROLE.unlock .. "[/size][/color]"
    else
        _msg = "[size=22][color=ffe2cb5a]" .. zc.lang("leading_actor") .. " [/size][/color][size=24][color=ffff3644]"..self._params.userLevel.. zc.lang("level_1") .. "[/size][/color][size=22][color=ffe2cb5a] " .. LANGUAGE_ROLE.unlock .. "[/size][/color]"
    end
    local openLevel = zc.createRichLabel({
        text = _msg,
        ttf = zc.getFontName(2),
        pos = cc.p(zc.width/2+110, zc.height/2),
        anchor = cc.p(0,1),
    })
    openLevel:enableStroke(display.COLOR_BLACK, 0.2)
    bgSp:addChild(openLevel)
    self._containerLayer:setTouchEndedCallback(function()
        self._containerLayer:setVisible(false)
        self._spine:playAction( "over", false)
        bgSp:runAction(cc.Sequence:create(cc.FadeOut:create(0.5)))
        self._spine:registerSpineEventHandler( function ( event )
                if event.animation == "over" then
                    performWithDelay(self._spine, function()
                        LayerManager.removeLayout(true)
                    end,0.1)
                end
        end, sp.EventType.ANIMATION_COMPLETE)
    end)
end

function UpcomingOpenPop:onCleanup()
    cc.Director:getInstance():getTextureCache():removeTextureForKey("res/animation/xingongnengyindao/xingongnengyindao.png")
end

return UpcomingOpenPop