--[[
FileName        RoleFettersRegionalMapPop.lua
ProjectName     HJ2
Created by wangming on 16-10-31 地域羁绊地图弹窗
]]
local RoleFettersRegionalMapPop = class("RoleFettersRegionalMapPop", function()
    return zc.createNormalDialog({
    	showFlower = false,
    })
end)

function RoleFettersRegionalMapPop:create( params )
    return RoleFettersRegionalMapPop.new(params)
end

function RoleFettersRegionalMapPop:onCleanup()
	zc.dispatchEvent({name = CUSTOM_EVENT.EVENT_REDORBUBBLE_CHANGE, data = {tag = "house", id = 1}})
end

function RoleFettersRegionalMapPop:ctor( params )
	local _params = params or {}
	self._region = tonumber(_params.region) or 0
	self._region = self._region < 0 and 0 or self._region
	self._region = self._region > 4 and 0 or self._region

	local _di = zc.createSprite("res/Main/role/fetter/regionalMap/bg.png")
	_di:setPosition(zc.width*0.5, zc.height*0.5)
	self:addChild(_di)


	local _mapInfos = {
		{
			mapPos = cc.p(535, 445),
			flagPos = cc.p(630, 465),
			parts = {
				cc.rect(0, 188, 237, 105),
				cc.rect(127, 64, 180, 150),
				cc.rect(313, 136, 520, 184),
				cc.rect(456, 0, 240, 120),
				cc.rect(460, 85, 190, 190),
				cc.rect(130, 105, 177, 115),
				cc.rect(265, 138, 170, 75),
			}
		},
		{
			mapPos = cc.p(315, 268),
			flagPos = cc.p(270, 255),
			parts = {
				cc.rect(5, 0, 240, 300),
				cc.rect(44, 300, 109, 85),
				cc.rect(240, 63, 137, 116),
			}
		},
		{
			mapPos = cc.p(563, 212),
			flagPos = cc.p(660, 220),
			parts = {
				cc.rect(5, 0, 90, 106),
				cc.rect(90, 30, 100, 68),
				cc.rect(172, 69, 190, 90),
				cc.rect(362, 90, 100, 65),
				cc.rect(135, 164, 350, 50),
				cc.rect(275, 202, 220, 42),
				cc.rect(390, 248, 105, 36),
				cc.rect(311, 127, 155, 122),
				cc.rect(180, 72, 220, 130),
			}
		},
		{
			mapPos = cc.p(490, 330),
			flagPos = cc.p(490, 330),
			parts = {
				cc.rect(10, 10, 225, 73),
				cc.rect(238, 36, 30, 120),
				cc.rect(5, 92, 220, 60),
				cc.rect(50, 158, 200, 53),
				cc.rect(50, 33, 190, 134),
			}
		},
	}

	local _mSprites = {}
	for i=1, 4 do
		local _sp = zc.createSprite("res/Main/role/fetter/regionalMap/map" .. i .. ".png")
		_sp:setPosition(_mapInfos[i].mapPos)
		_di:addChild(_sp)
		_mSprites[i] = _sp

		local _flagSp = zc.createSprite("res/Main/role/fetter/regionalMap/flag" .. i .. ".png")
		_flagSp:setPosition(_mapInfos[i].flagPos)
		_di:addChild(_flagSp, 1)

		local _tipSp = zc.createSprite("res/Main/activity/rechargeFirst/detailBtn.png")
		_tipSp:setPosition(_flagSp:getContentSize().width + 20, _flagSp:getContentSize().height + 20)
		_flagSp:addChild(_tipSp)
		_sp._tipSp = _tipSp

	    local _label = zc.createLabel({
	    	text = zc.lang("fetters_achieve"),
	    	fontSize = 22,
	    	width = 50,
	    	color = cc.c3b(75, 53, 29),
	    	pos = cc.p(_tipSp:getContentSize().width*0.5 + 5, _tipSp:getContentSize().height*0.5),
	    })			    
	    _tipSp:addChild(_label)

		if self._region ~= i then
			_sp:setVisible(false)
		end
	end

	local _cloudUp = zc.getSpine("jiban_yun")
	_cloudUp:setPosition(zc.width*0.5, zc.height - 80)
	_cloudUp:playAction("animation2", true)
	self:addChild(_cloudUp)

	local _cloudDown = zc.getSpine("jiban_yun")
	_cloudDown:setPosition(zc.width*0.5 + 20, 80)
	_cloudDown:playAction("animation", true)
	self:addChild(_cloudDown)

	local function _freshTips( index )
		local _target = _mSprites[index]
		if not _target then
			return
		end
		_target = _target._tipSp
		if not _target then
			return
		end
		local _flag = PlayerData:getRegionalFlag(index)
		_target:setVisible(_flag)
	end

	local function _checkTouchedOne( index, pos )
		local _parts = _mapInfos[index].parts
		local _target = _mSprites[index]
		if not _target or not _parts then
			return false
		end
		local _pos = _target:convertToNodeSpace(pos)
		for i=1, #_parts do
			if cc.rectContainsPoint(_parts[i], _pos) then
				return true
			end
		end
		return false
	end

	local function _checkTouched( pos )
		for i=4, 1, -1 do
			if _checkTouchedOne(i, pos) then
				return i
			end
		end
		return 0
	end

	local _layer = cc.Layer:create()
	self:addChild(_layer)
	local _touchedIdx = self._region
	local _beganPos = cc.p(0, 0)
	local _flag = true
	_layer:onTouch(function( event )
		local _idx = _checkTouched(event)
		if _touchedIdx ~= 0 then
			_mSprites[_touchedIdx]:setVisible(false)
		end
		_touchedIdx = _idx
		if _touchedIdx ~= 0 then
			_mSprites[_touchedIdx]:setVisible(true)
		end
		if event.name == "began" then
			_beganPos.x = event.x
			_beganPos.y = event.y
			_flag = true
		elseif event.name == "moved" then
			if cc.pGetDistance(_beganPos, event) > 10 then
				_flag = false
			end
		elseif event.name == "ended" and _flag then
			_touchedIdx = _checkTouched(event)
			if _touchedIdx ~= 0 then
				zc.createSourcePop("RoleFettersRegional", "src/layer/role/RoleFettersRegionalPop.lua", {
					region = _touchedIdx,
					callback = function()
						_freshTips(_touchedIdx)
					end
				})
			else
				LayerManager.removeLayout()
			end
		end
		return true
	end, false, true)

	for i=1,4 do
		_freshTips(i)
	end
end



return RoleFettersRegionalMapPop