--[[
-- 任务指引界面
-- @author lph
-- Creation  2016-1-13
]]
-- local MainTaskType = 1 --主线任务
-- local AchievementTaskType = 2 --成就任务
-- local DailyTaskType = 3 --日常任务
-- local STATUS_INCOMPLETE = 1 --未完成
-- local STATUS_COMPLETED = 2 --完成未领取
-- local STATUS_FINISH = 3 --完成已领取
local TaskListPop = class("TaskListPop",function ()
	return zc.createNormalDialog({
        closeCallBack = function()
            LayerManager.removeLayout(nil, nil, false)
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_12819 then
                zc.setGuideFuncNextStep(_currentGID)
                local _mainCity = zc.getScene("mainCity")
                if _mainCity then
                    _mainCity:guideFunc()
                end
            end
        end
    })
end)

function TaskListPop:create(data)
    local _pop = TaskListPop.new(data)
    -- _pop:show(false)
    return _pop
end

function TaskListPop:ctor(data)
    self.btn_tag = 1
    self._heroPicList = {}
    self._achieveReds = {}
    if data then 
        self.btn_tag = tonumber(data.tag) or 1
        self._targetTaskId = data.taskId
    end
    self.curTaskList = {}
    self.taskActivityTemplateData = gameData.getAllDataWithNoClone("task_activity")
    self.activityValueMax = 0
    for k,v in pairs(self.taskActivityTemplateData) do
        local _activity = tonumber(v.activity) or 0
        if _activity > self.activityValueMax then
            self.activityValueMax = _activity
        end
    end
    
    self:initUI()
    local _currentGID = getGuideManager():getCurrentGID()
    if _currentGID == GuideKey.KEY_12815 then
        zc.setGuideFuncNextStep(_currentGID, false)
        LayerManager.addShieldLayout(nil, 0.3)
    end
end

function TaskListPop:onEnter()
    self:updateTableView(self.btn_tag, true)
    getGuideManager():addMaskLayer()
    performWithDelay(self, function()
        getGuideManager():removeMaskLayer()
        self:addGuide()
    end, 0.1)
end

function TaskListPop:onCleanup()
    local textureCache = cc.Director:getInstance():getTextureCache()
    textureCache:removeTextureForKey("res/Main/task/task_bg.png")
    textureCache:removeTextureForKey("res/Main/task/task_item_bg.png")
    textureCache:removeTextureForKey("res/Main/task/task_title.png")
    textureCache:removeTextureForKey("res/Main/task/task_treasureBox_bg.png")
    textureCache:removeTextureForKey("res/Main/task/mainTaskBian.png")
    textureCache:removeTextureForKey("res/Main/task/mainTaskBg.png")
    if table.nums(self._heroPicList) > 0 then
        for k,v in pairs(self._heroPicList) do
            textureCache:removeTextureForKey(k)
        end
    end
end

function TaskListPop:initUI()
	local _bg = zc.createNormalPop({
        tag = 3,
        bianZOrder = 1,
        height = 557, 
        width = 762,
        src = "res/Main/shop/shopBg.jpg",
    })
    _bg:setPosition(zc.width*0.5 ,zc.height*0.5)
    self._bg = _bg
	self:addChild(_bg)

    self:createMainTaskView()

	--标题
	local _task_title = zc.getSprite({
        src = "res/Main/task/task_title.png",
        pos = cc.p(-25, _bg:getBoundingBox().height - 15),
        ap = cc.p(0, 0.5)
    })
	_bg:addChild(_task_title, 1)

    --日常宝箱bg
    self._task_treasureBox_bg = zc.createImageView({
        src = "res/Main/role/trinket/sellDi.png",
        pos = cc.p(156, 8),
        ap = cc.p(0,0),
    })
    self._task_treasureBox_bg:setScaleX(1.02)
    self._task_treasureBox_bg:setScaleY(0.96)

    _bg:addChild(self._task_treasureBox_bg, 1)
    --每日活跃度
    local du_Bg = ccui.Scale9Sprite:create(cc.rect(12, 11, 14, 10), "res/Main/role/common/name_bg.png")
    du_Bg:setContentSize(95,28)
    du_Bg:setAnchorPoint(0, 0.5)
    du_Bg:setPosition(5, self._task_treasureBox_bg:getContentSize().height*0.5)
    self._task_treasureBox_bg:addChild(du_Bg)

    local _task_activity_label = zc.createLabel({
        text = zc.lang("active_degree"),
        fontSize = 22,
        ap = cc.p(0, 0.5),
        color = cc.c3b(250,250,206),
        pos = cc.p(10,du_Bg:getContentSize().height/2),
        stroke = true,
        pixel = 2,
    })
    du_Bg:addChild(_task_activity_label)

    local _task_activity_num = zc.createLabel({
        text = PlayerData:getTaskActivityValue(),
        fontSize = 22,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(120,-20),
        stroke = true,
        color = display.COLOR_GOLD,
    })
   _task_activity_label:addChild(_task_activity_num)
   self._task_treasureBox_bg._task_activity_num = _task_activity_num

    --活跃度进度
    local expImgBg = zc.createSprite("res/Main/drillField/drillField_heroExp_bg.png")
    expImgBg:setAnchorPoint(cc.p(0, 0.5))
    expImgBg:setScaleX(1.05)
    expImgBg:setScaleY(0.8)

    local expGressImg = zc.createSprite("res/Main/drillField/drillField_heroExp.png")
    expGressImg:setAnchorPoint(cc.p(0, 0.5))
    local expPrgress = cc.ProgressTimer:create(expGressImg)
    expPrgress:setScaleX(1.05)
    expPrgress:setScaleY(0.8)

    expPrgress:setAnchorPoint(cc.p(0, 0.5))
    expPrgress:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    expPrgress:setBarChangeRate(cc.p(1, 0))
    expPrgress:setMidpoint(cc.p(0, 0))
    expPrgress:setPosition(cc.p(110,45))
    expImgBg:setPosition(cc.p(110,45))
    self._task_treasureBox_bg:addChild(expImgBg)
    self._task_treasureBox_bg:addChild(expPrgress)
    self.slider = expPrgress

    self:updateExBar()

    --宝箱
    self._task_treasureBox = {}
    for i=1,4 do
        local _node = cc.Node:create()
        _node:setContentSize(80, 80)
        local _box = zc.createPushButton({
            normalNode = _node,
            pos = cc.p(110+105*i, 50),
            needEnableWhenMoving = false,
            scale = 0.8,
            endCallback = function () 
                self:receiveTreasureBox(i)
            end,
        })
        self._task_treasureBox_bg:addChild(_box)
        local armature = zc.getSpine("missionbox")
        armature:playAction("box"..i.."_lock", true)
        armature:setPosition(40, 20)
        _box:addChild(armature)
        self._task_treasureBox[i] = armature 
        local _activityData = gameData.getDataFromCacheWithPrimaryKey("task_activity", 100000+i) 
        if PlayerData:getTaskActivityValue() >= (tonumber(_activityData.activity) or 155) then
            local _flag = false
            if table.nums(PlayerData:getTaskActivityDrawIds()) > 0  then
                for k,v in pairs(PlayerData:getTaskActivityDrawIds()) do
                    if tonumber(v) == tonumber(_activityData.id) then
                        _flag = true
                    end
                end
            end
            if _flag then
                armature:playAction("box"..i.."_open", true) 
            else
                armature:playAction("box"..i.."_closer", true) 
            end
        end
        --活跃度
        local _task_activity_label = zc.createLabel({
            text = _activityData.activity or "155",
            fontSize = 22,
            ap = cc.p(0.5, 0),
            pos = cc.p(110+105*i,-2),
            outLine = true,
        })
        self._task_treasureBox_bg:addChild(_task_activity_label)  
    end

    --创建任务列表
    self._viewSize = cc.size(610, 435)
    local myTableView = cc.TableView:create(self._viewSize)--580
    myTableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    myTableView:setPosition(cc.p(157, -30))--160
    myTableView:setDelegate()
    myTableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)

    local function cellSizeForTable(table, idx) 
        return 603, 135--122, 580
    end
    local function tableCellAtIndex(table, cellIndex) 
        cellIndex = cellIndex + 1
        local cell = myTableView:dequeueCell()
        -- 创建模板
        if cell == nil then
            cell = cc.TableViewCell:new()
            self:buildCell(cell, cellIndex)
        end
        -- 更新界面
        self:updateCell(cell, cellIndex)
        return cell
    end
    local function numberOfCellsInTableView()
        return #self.curTaskList
    end
    myTableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    myTableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    myTableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _bg:addChild(myTableView)
    self._myTableView = myTableView

    self:createAchievementTaskView()

      --页签BG
    local _tag_bg = zc.createTabButtonBg({tag = 3})
    _tag_bg:setAnchorPoint( 0, 0 )
    _tag_bg:setPosition(4, 7)
    _bg:addChild(_tag_bg)
    local splitY = zc.createSprite( "res/Main/common/tab_split_y.png" )
    splitY:setPosition( _tag_bg:getContentSize().width + 3, _tag_bg:getContentSize().height/2 )
    splitY:setScaleY( 468/493 )
    _tag_bg:addChild( splitY, 2 )
    -- 分隔线
    local split1 = zc.createSprite("res/Main/common/tab_split_x_new.png")
    split1:setPosition(_tag_bg:getContentSize().width/2, 332 + 62 )
    _tag_bg:addChild(split1)
    --页签
    self._tagButtons = {}
    local _tabConfig = LANGUAGE_task_tabs()

    local btn = zc.createPushButton({
        normalNode = zc.createSprite("res/Main/activity/shengwangicon.png"),
        selectedNode = zc.createSprite("res/Main/activity/shengwangicon.png"),
        endCallback = function() 
            print("---test-----")
            LayerManager.backToMainCity(false)
            zc.sendHttp({
                apiName = "ShengWang_goods",
                successCallback = function (data)
                    zc.createSourceScene("PrestigeShopLayer", "src/layer/shop/ShopLayer.lua", {data = data, index = 4} )
                end,
            })
        end,
        pos = cc.p(_tag_bg:getContentSize().width/2 + 10,310 - 4*62),
    })
    _bg:addChild(btn)
    btn:setVisible(false)
    self.shengwangbtn = btn

    for i, v in ipairs(_tabConfig) do
        local pos = cc.p( _tag_bg:getContentSize().width/2, 440 - i*62 )
        local tab_btn = zc.createComTabButton({
            tag = 4,
            btnText = v,
            touchSize = cc.size( 153, 62),
            needSwallow = false,
            needEnableWhenOut = true,
            needEnableWhenMoving = true,
            endCallback = function()
                if i ~= self.btn_tag then
                    local _currentGID = getGuideManager():getCurrentGID()
                    if _currentGID == GuideKey.KEY_12816 then
                        zc.setGuideFuncNextStep(_currentGID, false)
                    end
                    self._tagButtons[i]:setSelected( true )
                    self._tagButtons[self.btn_tag]:setSelected( false )
                    self:updateTableView(i)

                    _currentGID = getGuideManager():getCurrentGID()
                    if _currentGID == GuideKey.KEY_12817 then
                        self:addGuide()
                    end
                end
                if self.btn_tag == 2 then
                    self.shengwangbtn:setVisible(true)
                else
                    self.shengwangbtn:setVisible(false)
                end
            end
        })
        tab_btn:setPosition(pos)
        _tag_bg:addChild(tab_btn, 1)

        self._tagButtons[i] = tab_btn
        local _redPoint = zc.createSprite("res/Main/common/common_red_point.png")
        _redPoint:setVisible(false)
        tab_btn:addChild(_redPoint)
        tab_btn._redPoint = _redPoint
        _redPoint:setAnchorPoint(1, 1)
        _redPoint:setPosition(tab_btn:getContentSize().width - 10, tab_btn:getContentSize().height)
        if i == 3 then
            self._guideTagBtn = tab_btn
        end
        -- 分隔线
        local split = zc.createSprite("res/Main/common/tab_split_x_new.png")
        split:setPosition(tab_btn:getPositionX(), tab_btn:getPositionY() - tab_btn:getContentSize().height*0.5 - 9 )
        _tag_bg:addChild(split)
    end
    self._tagButtons[self.btn_tag]:setSelected(true)
    
    --更新列表
    self:updateTableView(0)
end

function TaskListPop:updateExBar()
    print("PlayerData:getTaskActivityValue() .",PlayerData:getTaskActivityValue(),"self.activityValueMax:",self.activityValueMax)
    local _value = PlayerData:getTaskActivityValue()/self.activityValueMax*100
    _value = _value > 100 and 100 or _value
    self.slider:setPercentage(_value)
end

function TaskListPop:buildCell( cell, cellIndex )
	cell._item_bg = zc.getSprite({
        src = "res/Main/task/task_item_bg.png",
        pos = cc.p(0,0),
        ap = cc.p(0,0),
    })
    cell:addChild(cell._item_bg)

    cell._item = zc.createIconByData({
        data = {
            mainType = zc.mainTypeOthers,
            type = 1,
            id = 0,
            quality = 1,
        }, 
        pos = cc.p(60, cell._item_bg:getContentSize().height/2 + 2), 
    })
    cell._item:setScale(0.65)
    cell._item_bg:addChild(cell._item)
    cell._item_icon = zc.createImageView({
        src = "res/Main/common/common_icon_wujiang.png",
        pos = cc.p(cell._item:getContentSize().width/2, cell._item:getContentSize().height/2),
        ap = cc.p(0.5,0.5),
    })
    cell._item_icon:setScale(2/3)
    cell._item:addChild(cell._item_icon)

    local _nameDi1 = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(290, 30))
    _nameDi1:setAnchorPoint(0, 0.5)
    _nameDi1:setPosition(115, 84)
    cell._item_bg:addChild(_nameDi1)

    local _nameDi2 = zc.getScaleNode("res/Main/role/common/name_bg.png", cc.size(230, 30))
    _nameDi2:setAnchorPoint(0, 0.5)
    _nameDi2:setPosition(175, 48)
    cell._item_bg:addChild(_nameDi2)
    --任务名称
    cell._task_name_label = zc.createLabel({
        text = zc.lang("task_name"),
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(120, 85),
    })
    cell._item_bg:addChild(cell._task_name_label)
    cell._task_name_label:setVisible(false)
    --任务描述
    cell._task_desc_label = zc.createLabel({
        text = zc.lang("task_description"),
        fontSize = 22,
        ap = cc.p(0, 0.5),
        pos = cc.p(120, 85),
    })
    cell._item_bg:addChild(cell._task_desc_label)
    --奖励
    cell._reward_label = zc.createLabel({
        text = zc.lang("reward") .. ":",
        fontSize = 20,
        ap = cc.p(0, 0.5),
        pos = cc.p(120, 48),
        color = cc.c3b(76, 18, 18),
    })
    cell._item_bg:addChild(cell._reward_label)
    --资源图1
    cell._reward_icon_1 = zc.createImageView({
        src = "res/Main/common/common_icon_gold.png",
        pos = cc.p(180, 46),
        ap = cc.p(0,0.5),
    })
    cell._item_bg:addChild(cell._reward_icon_1)
    --数量1
    cell._reward_num_1 = zc.createLabel({
        fontSize = 20,
        ap = cc.p(0, 0),
        pos = cc.p(47, 10),
    })
    cell._reward_icon_1:addChild(cell._reward_num_1)
    --资源图2
    cell._reward_icon_2 = zc.createImageView({
        src = "res/Main/common/common_icon_gold.png",
        pos = cc.p(290, 46),
        ap = cc.p(0,0.5),
    })
    cell._item_bg:addChild(cell._reward_icon_2)
    --数量2
    cell._reward_num_2 = zc.createLabel({
        fontSize = 20,
        ap = cc.p(0, 0),
        pos = cc.p(47, 10),
    })
    cell._reward_icon_2:addChild(cell._reward_num_2)

    --活跃度t
    cell.active_degree_text = zc.createLabel({
        text = zc.lang("active_degree"),
        fontSize = 20,
        ap = cc.p(0, 0),
        pos = cc.p(290, 36),
    })
    cell._item_bg:addChild(cell.active_degree_text)
    --活跃度
    cell.active_degree = zc.createLabel({
        fontSize = 20,
        ap = cc.p(0, 0),
        pos = cc.p(350, 36),
        color = display.COLOR_GREEN,
    })
    cell._item_bg:addChild(cell.active_degree)

    --完成度数据
    cell._completionDegree_label = zc.createLabel({
        fontSize = 20,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(510, 90),
        outLine = true,
        pixel = 1.3,
        color = display.COLOR_GREEN,
        color2 = cc.c3b( 87, 0, 0 ),
    })
    cell._item_bg:addChild(cell._completionDegree_label)
end

function TaskListPop:updateCell(cell, cellIndex)
	local _taskInfo = self.curTaskList[cellIndex]
    local _taskTemplate = nil
    local _active_degree = ""
    if tonumber(_taskInfo.type) == 3 then
        _taskTemplate = gameData.getDataFromCacheWithPrimaryKey("task_daily", _taskInfo.taskId)
        _active_degree = _taskTemplate.activity
        cell.active_degree:setVisible(true)
        cell.active_degree_text:setVisible(true)
    else
        _taskTemplate = _taskInfo._template or gameData.getDataFromCacheWithPrimaryKey("task", _taskInfo.taskId)
        cell.active_degree:setVisible(false)
        cell.active_degree_text:setVisible(false)
    end                      
	local _task_name = _taskTemplate.name
	if not _taskInfo then 
        return
    end

	cell._task_desc_label:setText(_taskTemplate.desc)
    local _src = "res/Main/common/common_icon_wujiang.png"
    if _taskTemplate.icon then
	   _src = string.format("res/Main/common/common_icon_%s.png",tostring(_taskTemplate.icon))
       cell._item_icon:loadTexture(_src)
    end
	
	local _data = self:getTaskRewards(_taskTemplate.awards) 
    if _data then
        local _bool1 = tonumber(_data[1]) == 1 or tonumber(_data[2]) == zc.cardExtractPopId
        local _str1 = tostring(_data[3])
		if _bool1 then
            cell._reward_icon_1:setOpacity(255)
            if tonumber(_data[2]) == zc.cardExtractPopId then
                local _itemDb = gameData.getDataFromCacheWithPrimaryKey("item", _data[2])
                cell._reward_icon_1:loadTexture(zc.cardExtractPopSmallImg)
            else
                cell._reward_icon_1:loadTexture(zc.getImgByType(_data[2]))
            end
            cell._reward_num_1:setPositionX(50)
            cell._reward_num_1:removeAllChildren()
        else
            cell._reward_icon_1:setOpacity(0)
            local info = zc._getIconInfo({
                data = {
                    mainType= _data[1],
                    id = _data[2]
                }
            })
            local _color = zc.getColorType(info.star)
            _str1 = " x " .. tostring(_data[3])
            local _label = zc.createLabel({
                fontSize = 20,
                text = info.name,
                color = _color,
                ap = cc.p(1, 0),
                shadow = true,
                pos = cc.p(0, 0)
            })
            cell._reward_num_1:setPositionX(55)
            cell._reward_num_1:addChild(_label)
        end
        cell._reward_num_1:setText(_str1)
        if #_data > 3 then
            cell._reward_icon_2:setVisible(true)
            local _bool2 = tonumber(_data[4]) == 1 or tonumber(_data[5]) == zc.cardExtractPopId
            local _str2 = tostring(_data[6])
            if _bool2 then
                cell._reward_icon_2:setOpacity(255)
                if tonumber(_data[5]) == zc.cardExtractPopId then
                    cell._reward_icon_2:loadTexture(zc.cardExtractPopSmallImg)
                else
                    cell._reward_icon_2:loadTexture(zc.getImgByType(_data[5]))
                end
                cell._reward_num_2:setPositionX(50)
                cell._reward_num_2:removeAllChildren()
            else
                cell._reward_icon_2:setOpacity(0)
                local info = zc._getIconInfo({
                    data = {
                        mainType= _data[4],
                        id = _data[5]
                    }
                })
                local _color = zc.getColorType(info.star)
                _str2 = "x" .. tostring(_data[6])
                local _label = zc.createLabel({
                    fontSize = 20,
                    text = info.name,
                    color = _color,
                    ap = cc.p(1, 0),
                    shadow = true,
                    pos = cc.p(0, 0)
                })
                cell._reward_num_2:setPositionX(55)
                cell._reward_num_2:addChild(_label)
            end
			cell._reward_num_2:setText(_str2)
        else
            cell.active_degree:setText("+".._active_degree)
            cell._reward_icon_2:setVisible(false)
		end
    end
    if cell._task_goto then
        cell._task_goto:removeSelf()
        cell._task_goto = nil 
    end
    if cell._over_get then
        cell._over_get:removeSelf()
        cell._over_get = nil 
    end

    local _status = tonumber(_taskInfo.status) or 1

    if _status == 3 then
        cell._completionDegree_label:setVisible(false)
        cell._over_get = zc.createSprite("res/Main/activity/monthSign/fetched.png")
        cell._over_get:setPosition(510, 60)
        cell:addChild(cell._over_get)
        return
    elseif _status ~= 1 and _status ~= 2 then
        return
    end
    if _taskTemplate.progress ~= 0 then
        cell._completionDegree_label:setVisible(true)
    else
        cell._completionDegree_label:setVisible(false)
    end
    local _color = display.COLOR_RED
    local _text = tonumber(_taskInfo.arg) or 0
    local _tag = 2
    local _btnText = zc.lang("goto_rightnow")
    if _status == 2 then
        _tag = 1
        _color = display.COLOR_GREEN
        _btnText = zc.lang("fetch_2")
    else
        local _datas = string.split(_taskTemplate.conditions or "",",")
        local __data = string.split(_datas[1] or "","|")
        if tonumber(__data[1]) == 52 or tonumber(__data[1]) == 59 then
            _btnText = zc.lang("un_finish")
        end
        if _taskTemplate.functionId and tonumber(_taskTemplate.functionId) > 0 then
            local _flag = zc.getFunctionStatus(_taskTemplate.functionId, false) 
            if not _flag then
                _btnText = zc.lang("func") .. LANGUAGE_TOLLGATEHERO.not_open
            end
        end
    end

    local _max = tonumber(_taskInfo.conditions) or 1
    if type(_max) ~= "number" then
        _max = 1
    end
    _text = _text > _max and _max or _text
    _text = _text .. "/".. _max
    cell._completionDegree_label:setColor(_color)
    cell._completionDegree_label:setText(_text)
    -- 前往
    cell._task_goto = zc.createCommomBtn({
        tag = _tag,
        ap = cc.p(0.5,0.5),
        pos = cc.p(510, 50),
        text = _btnText,
        endCallback = function()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_12817 then
                self._myTableView:setTouchEnabled(true)
            end
            if _btnText == zc.lang("un_finish") or 
              _btnText == (zc.lang("func") .. LANGUAGE_TOLLGATEHERO.not_open) then
                return
            end
            if _status == 1 then
                LayerManager.backToMainCity(false)
                zc.toReceiveRewardsView(_taskTemplate.conditions)
            elseif _status == 2 then
                self:receiveTaskRewards(_taskInfo.id)
                if tolua.isnull(cell._task_goto) then
                    return
                end
                cell._task_goto:setEnable(false)
            end
        end
    })
    cell:addChild(cell._task_goto)

    if _taskInfo.taskId == GuideTaskKey and _status == 2 then
        self._guideTaskGoto = cell._task_goto
    end
end

function TaskListPop:createMainTaskView()
    local _bg = zc.createSprite("res/Main/task/mainTaskBg.png")
    _bg:setAnchorPoint(0, 0)
    _bg:setPosition(150, 6)
    self._bg:addChild(_bg)
    self._mainTaskView = _bg

    local _pos = cc.p(470, 265)

    local _bianSp = zc.createSprite("res/Main/task/mainTaskBian.png")
    _bianSp:setPosition(_pos)
    local _size = _bianSp:getContentSize()

    local _view = zc.createScrollview({
        size = _size,
        innerSize = _size,
        touchEnable = false,
        pos = cc.p(_pos.x - _size.width*0.5, _pos.y - _size.height*0.5),
    }) 
    _bg:addChild(_view)

    local _diSp = zc.createSprite()
    _diSp:setScale(0.6)
    _diSp:setAnchorPoint( 0.5, 1 )
    _diSp:setPosition(_size.width/2, _size.height)
    _view:addChild(_diSp)
    _bg._hero = _diSp

    _bg:addChild(_bianSp)


    local _size = _bg:getContentSize()

    local _task_name_label = zc.createLabel({
        text = "",
        pos = cc.p(_size.width*0.5, _size.height - 25),
        fontSize = 24,
        color = display.COLOR_BLACK,
    })
    _bg:addChild(_task_name_label)
    _bg._task_name_label = _task_name_label


    local _completionDegree_label = zc.createLabel({
        text = "",
        pos = cc.p(330, _size.height - 83),
        fontSize = 22,
        ap = cc.p(1, 0.5),
        outLine = true,
        color2 = cc.c3b( 87, 0, 0 ),
    })
    _bg:addChild(_completionDegree_label)
    _bg._completionDegree_label = _completionDegree_label


    local _task_desc_label = zc.createRichLabel({
        text = "",
        anchor = cc.p(0, 0.5),
        color = display.COLOR_BLACK,
        fontSize = 22,
        pos = cc.p(75, _size.height - 83),
    })
    _task_desc_label:setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
    _task_desc_label:setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER)
    _bg:addChild(_task_desc_label)
    _bg._task_desc_label = _task_desc_label

    local _task_detail_desc_label = zc.createRichLabel({
        text = "",
        anchor = cc.p(0, 1),
        fontSize = 20,
        color = cc.c3b(60, 0, 0),
        pos = cc.p(49, _size.height - 115),
    })
    _task_detail_desc_label:setDimensions(cc.size(280, 130))
    _bg:addChild(_task_detail_desc_label)
    _bg._task_detail_desc_label = _task_detail_desc_label

    local _tbSize = cc.size(300, 80)
    local _tableView = zc.ZCTableView:create(_tbSize)
    _tableView:setDirection(zctech.SCROLLVIEW_DIRECTION_HORIZONTAL)
    _tableView:setPosition(cc.p(85, 130))
    _tableView:setDelegate()
    _tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    _bg:addChild(_tableView)
    _bg._taskAwardTab = _tableView
    
    local _cellSize = cc.size(80, 80)
    local function cellSizeForTable(table, idx) 
        return _cellSize.height, _cellSize.width
    end
    local function numberOfCellsInTableView()
        local _size = _bg._awardData and #_bg._awardData or 0
        return _size
    end
    local function tableCellAtIndex(table, cellIndex) 
        local cell = _tableView:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(_cellSize)
        else
            cell:removeAllChildren()
        end
        if not _bg._awardData then
            return cell
        end
        local _data = tostring(_bg._awardData[cellIndex + 1]) or ""
        local _info = string.split(_data, "|")
        local item = zc.createIconByData({
            data = {
                mainType = _info[1],
                type = _info[2], 
                id = _info[2],
                num = _info[3],
            }, 
            pos = cc.p(_cellSize.width*0.5, _cellSize.height*0.5), 
        })
        item:setScale(0.6)
        cell:addChild(item)
        item:setTouchEndedShowTip()
        
        return cell
    end
    _tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
end

--成就标签页按钮文字
function TaskListPop:getAchieveTaskBtnsText()
    local _tb = {
        "1－9",
        "10－19",
        "20－29",
        "30－39",
        "40－49",
        "50－59",
        "60－69",
        "70－79",
        "80－89",
        "90－99",
    }
    return _tb
end

function TaskListPop:createAchievementTaskView()
    local _sp = zc.createSprite("res/Main/task/achieve_di.png")
    _sp:setAnchorPoint(0, 1)
    _sp:setPosition(150, 478)
    self._bg:addChild(_sp)
    self._achieveDi = _sp
    self._achieveTag = 0
    self._nowAchieveBtn = nil
    self._btnTexts = self.getAchieveTaskBtnsText() 
    local _tbSize = cc.size(600, 50)
    local _tableView = zc.ZCTableView:create(_tbSize)
    _tableView:setDirection(zctech.SCROLLVIEW_DIRECTION_HORIZONTAL)
    _tableView:setPosition(155, 420)
    _tableView:setDelegate()
    _tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    self._bg:addChild(_tableView)
    self._achieveTab = _tableView
    
    local _cellSize = cc.size(130, 50)
    local function cellSizeForTable(table, idx) 
        return _cellSize.height, _cellSize.width
    end
    local function numberOfCellsInTableView()
        return #self._btnTexts
    end
    
    local function _setBtnSelected( btn, doUpdate )
        if not tolua.isnull(self._nowAchieveBtn) then
            if self._nowAchieveBtn.idx == self._achieveTag then
                self._nowAchieveBtn:setSelected(false)
            end
        end
        self._nowAchieveBtn = btn
        self._achieveTag = btn.idx
        btn:setSelected(true)  
        if doUpdate then
            self:updateAchieveTask(2)
        end
    end
    local _num = zc.getAchieveTaskLevel()

    local function tableCellAtIndex(table, cellIndex) 
        local cell = _tableView:dequeueCell()
        if cell == nil then
            cell = zc.ZCTableViewCell:new()
            cell:setContentSize(_cellSize)
        else
            cell:removeAllChildren()
        end
        local _idx = cellIndex + 1
        local _btn = zc.createPushButton({
            normalNode = zc.createSprite("res/Main/task/achieve_normal.png"),
            selectedNode = zc.createSprite("res/Main/task/achieve_selected.png"),
            fontSize = 22,
            text = self._btnTexts[_idx] .. zc.lang("level_1"),
            fontColor = cc.c3b(75, 0, 0),
            needEnableWhenMoving = true,
            needSwallow = false,
            endCallback = function() end,
            pos = cc.pMul(cc.pFromSize(_cellSize), 0.5)
        })
        if self._achieveReds[_idx] then
            local _redPoint = zc.createSprite("res/Main/common/common_red_point.png")
            _btn:addChild(_redPoint)
            _redPoint:setAnchorPoint(1, 1)
            _redPoint:setPosition(_btn:getContentSize().width, _btn:getContentSize().height)
        end
        _btn:setTouchEndedCall(function()
            if _idx > _num then
                zc.tipInfo(zc.lang("tips_level_unenough_to_look"))
                return
            end
            _setBtnSelected(_btn, true)
        end)
        _btn.idx = _idx
        cell:addChild(_btn)
        if _idx == self._achieveTag then
            _setBtnSelected(_btn)
        end
        return cell
    end
    _tableView:registerScriptHandler(cellSizeForTable, cc.TABLECELL_SIZE_FOR_INDEX)
    _tableView:registerScriptHandler(tableCellAtIndex, cc.TABLECELL_SIZE_AT_INDEX)
    _tableView:registerScriptHandler(numberOfCellsInTableView, cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    _tableView:reloadData()
end

function TaskListPop:freshRedpoint()
    for i=1,#self._tagButtons do
        local _tag = i
        if _tag == 2 then
            _tag = 3
        elseif _tag == 3 then
            _tag = 2
        end
        local _num = zc.getAchieveTaskLevel()
        local _redPoint = self._tagButtons[i]._redPoint
        local _show = false
        local _list = PlayerData:getTaskData()[_tag] or {}
        if table.nums(_list) > 0 then
            for k,v in pairs(_list) do
                if tonumber(v.status) == 2 then
                    if _tag == 2 then
                        local _taskTemplate = gameData.getDataFromCacheWithPrimaryKey("task", v.taskId)
                        if _taskTemplate.level <= _num then
                            _show = true
                            break
                        end
                    else
                        _show = true
                        break
                    end
                end
            end
        end
        _redPoint:setVisible(_show)
    end
end

--更新表内容
function TaskListPop:updateTableView(tag,isForceUpdate)
    local _tag = tonumber(tag) or 1
    if _tag == 0 then
        self._myTableView:setVisible(false)
        self._task_treasureBox_bg:setVisible(false)
        self:updateMainTask(_tag)
        self:updateAchieveTask(_tag)
        return
    end 
    if self.btn_tag == _tag and not isForceUpdate then
        return
    end
    self.btn_tag = _tag
    self:freshRedpoint()
    if _tag == 2 then
        _tag = 3
    elseif _tag == 3 then
        _tag = 2
    end

    self.curTaskList = PlayerData:getTaskData()[_tag] or {}
    if _tag == 3 then
        self._myTableView:setVisible(true)
        self._task_treasureBox_bg:setVisible(true)
        self:updateMainTask(_tag)
        self:updateAchieveTask(_tag)
        self._viewSize.height = 381
        self._myTableView:setViewSize(self._viewSize)
        self._myTableView:setPositionY(85)
        self._myTableView:reloadData()
        self:checkEmpty()
    elseif _tag == 1 then
        self._myTableView:setVisible(false)
        self._task_treasureBox_bg:setVisible(false)
        self:updateMainTask(_tag)
        self:updateAchieveTask(_tag)
        self:checkEmpty()
    else
        self._myTableView:setVisible(true)
        self._task_treasureBox_bg:setVisible(false)
        self:updateMainTask(_tag)
        self._viewSize.height = 404
        self._myTableView:setViewSize(self._viewSize)
        self._myTableView:setPositionY(7)
        if self._achieveTag == 0 then
            local _num = zc.getAchieveTaskLevel()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_12817 then
                self._targetTaskId = GuideTaskKey
            end
            if self._targetTaskId then
                local _taskTemplate = gameData.getDataFromCacheWithPrimaryKey("task", self._targetTaskId)
                if _taskTemplate.level <= _num then
                    _num = _taskTemplate.level
                end
            end
            self._achieveTag = _num
        end
        self._nowAchieveBtn = nil
        self:updateAchieveRed(_tag)
        self._achieveTab:reloadData()
        local _width = self._achieveTab:getViewSize().width
        for i=self._achieveTag, 1, - 1 do
            local _cell = self._achieveTab:cellAtIndex(i - 1)
            if not _cell then
                self._achieveTab:getContainer():setPositionX(_width - 130*i)
                self._achieveTab:scrollViewDidScroll(self._achieveTab)
                break
            else
                local _offSet = self._achieveTab:getContentOffset()
                local _x = _cell:getPositionX() + _cell:getContentSize().width
                if _x + _offSet.x >= _width then
                    self._achieveTab:getContainer():setPositionX(_width - _x)
                    self._achieveTab:scrollViewDidScroll(self._achieveTab)
                    break
                end
            end
        end
        self:updateAchieveTask(_tag)
    end
end

function TaskListPop:updateAchieveRed(_tag)
    local _list = PlayerData:getAchieveTask()
    local _achieveTag = zc.getAchieveTaskLevel()
    self._achieveReds = {}
    for k,v in pairs(_list) do
        if tonumber(k) <= _achieveTag then
            for key, value in pairs(v) do
                if value.status == 2 then
                    local _taskTemplate = value._template or {}
                    local _level = tonumber(_taskTemplate.level) or 0 
                    self._achieveReds[_level] = true
                    break
                end
            end
        end
    end
end

function TaskListPop:checkEmpty()
    if #self.curTaskList == 0 then
        if not self._emptySp then
            self._emptySp = zc.createSprite("res/Main/common/empty.png")
            self._emptySp:setPosition(420, 280)
            self._bg:addChild(self._emptySp)
        end
    else
        if self._emptySp then
            self._emptySp:removeFromParent()
            self._emptySp = nil
        end
    end
end

function TaskListPop:updateMainTask( tag )
    if tag ~= 1 then
        self._mainTaskView:setVisible(false)
        self._guideTaskGoto = nil
        return
    end
    local _taskInfo = self.curTaskList[1]
    if not _taskInfo then 
        self._mainTaskView:setVisible(false)
        self._guideTaskGoto = nil
        return
    end
    self._mainTaskView:setVisible(true)
    local cell = self._mainTaskView

    local _taskTemplate = gameData.getDataFromCacheWithPrimaryKey("task", _taskInfo.taskId)

    cell._task_name_label:setString(_taskTemplate.name)
    cell._task_desc_label:setString(_taskTemplate.desc)
    cell._task_detail_desc_label:setString("\t" .. _taskTemplate.detailDesc)
    local _texture = "res/Main/hero/body/" .. _taskTemplate.card .. ".png"
    if not self._heroPicList[_texture] then
        self._heroPicList[_texture] = true
    end
    cell._hero:setTexture(_texture)

    cell._awardData = string.split(_taskTemplate.awards, ",")
    if cell._taskAwardTab then
        cell._taskAwardTab:reloadData()
    end

    if cell._task_goto then
        cell._task_goto:removeSelf()
        cell._task_goto = nil 
    end
    local _status = tonumber(_taskInfo.status) or 1
    if _status ~= 1 and _status ~= 2 then
        cell._completionDegree_label:setString("")
        return
    end

    if _taskTemplate.progress ~= 0 then
        cell._completionDegree_label:setVisible(true)
    else
        cell._completionDegree_label:setVisible(false)
    end
    local _color = display.COLOR_RED
    local _text = tonumber(_taskInfo.arg) or 0
    local _tag = 2
    local _btnText = zc.lang("qianwang_2")
    if _status == 2 then
        _tag = 1
        _color = display.COLOR_GREEN
        _btnText = zc.lang("fetch_2")
    end
    local _max = tonumber(_taskInfo.conditions) or 1
    if type(_max) ~= "number" then
        _max = 1
    end
    _text = _text > _max and _max or _text
    _text = _text .. "/".._max
    cell._completionDegree_label:setColor(_color)
    cell._completionDegree_label:setText(_text)
    
    -- 前往
    cell._task_goto = zc.createCommomBtn({
        tag = _tag,
        ap = cc.p(0.5, 0.5),
        pos = cc.p(cell:getContentSize().width*0.5, 50),
        text = _btnText,
        endCallback = function()
            if _status == 1 then
                LayerManager.backToMainCity(false)
                zc.toReceiveRewardsView(_taskTemplate.conditions)
            elseif _status == 2 then
                cell._task_goto:setEnable(false)
                self:receiveTaskRewards(_taskInfo.id, _taskTemplate)
                performWithDelay(cell._task_goto, function ()
                    cell._task_goto:setEnable(true)
                end,0.01)
            end
        end
    })
    cell:addChild(cell._task_goto)
    self._guideTaskGoto = cell._task_goto
end

function TaskListPop:updateAchieveTask( tag )
    if tag ~= 2 then
        self._achieveDi:setVisible(false)
        self._achieveTab:setVisible(false)
        return
    end
    self._achieveDi:setVisible(true)
    self._achieveTab:setVisible(true)
    local _achieveTag = self._achieveTag

    self.curTaskList = PlayerData:getAchieveTask()[_achieveTag] or {}

    if self._targetTaskId then
        for k,v in pairs(self.curTaskList) do
            if v.taskId == self._targetTaskId then
                local _data = table.remove(self.curTaskList, k)
                table.insert(self.curTaskList, 1, _data)
                break
            end
        end
        self._targetTaskId = nil
    end
    self._myTableView:reloadData()
    self:checkEmpty()
end

--领取宝箱奖励
function TaskListPop:receiveTreasureBox(tag)
    local _flag = false
    local _activityData = gameData.getDataFromCacheWithPrimaryKey("task_activity", 100000+tag)
    if next(_activityData) ~= nil then
        if PlayerData:getTaskActivityValue() >=  tonumber(_activityData.activity or 200) then
            if table.nums(PlayerData:getTaskActivityDrawIds()) > 0  then
                for k,v in pairs(PlayerData:getTaskActivityDrawIds()) do
                    if tonumber(v) == tonumber(_activityData.id) then
                        _flag = true
                    end
                end
            end
            if not _flag then
                zc.sendHttp({
                    apiName = "Task_deliveryActivity",
                    params = {id = _activityData.id},
                    successCallback = function (data) 
                        PlayerData:setTaskActivityDrawIds(data.activityDrawIds)
                        zc.createShowReward(data)
                        data.noAnimation = true
                        PlayerData:updataData(data)
                        self:initTreasureBox()
                    end,
                })
            end
        else
            zc.createSourcePop("rewardPreview", "src/layer/task/RewardPreviewPop.lua",{award = _activityData.awards})
        end
    end
end

--创建宝箱
function TaskListPop:initTreasureBox()
    local _label = self._task_treasureBox_bg._task_activity_num
    if _label then
        _label:setText(PlayerData:getTaskActivityValue())
    end
    self:updateExBar()

    for i=1,4 do
        local _activityData = gameData.getDataFromCacheWithPrimaryKey("task_activity", 100000+i) 
        if PlayerData:getTaskActivityValue() >= (tonumber(_activityData.activity) or 155) then
            local _flag = false
            if table.nums(PlayerData:getTaskActivityDrawIds()) > 0  then
                for k,v in pairs(PlayerData:getTaskActivityDrawIds()) do
                    if tonumber(v) == tonumber(_activityData.id) then
                        _flag = true
                    end
                end
            end
            if _flag then
                self._task_treasureBox[i]:playAction("box"..i.."_open", true) 
            else
                self._task_treasureBox[i]:playAction("box"..i.."_closer", true) 
            end
        end
        
    end
end

--奖励
function TaskListPop:getTaskRewards(rewards)
	local _str = rewards
    local _data = {}
    if _str and tonumber(_str) ~= 0 then 
    	_data = string.split(string.gsub(_str,",","|"),"|")
    else
        _data = nil
    end
    return _data
end

--领取奖励
function TaskListPop:receiveTaskRewards(taskId, taskDb)
    local _taskId = tonumber(taskId) or 0
	zc.sendHttp({
        apiName = "Task_delivery",
        params = {id = taskId},
        successCallback = function (data)
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_6022 then
                zc.setGuideFuncNextStep(_currentGID)
                self:addGuide()
            end
            for k,v in pairs(PlayerData._downTaskDatas) do
                if tonumber(v.id) == _taskId then
                    v.status = 3
                    break
                end
            end
            local _taskData = data.newTasks or {}
            if table.nums(_taskData) > 0 then
                for k,v in pairs(_taskData) do
                    table.insert(PlayerData._downTaskDatas, v)
                end
            end
        	PlayerData:freshMyTaskDatas()
        	PlayerData:updataData(data)
            self:updateTableView(self.btn_tag, true)
            PlayerData:setTaskActivityValue(data.activity)
            self:updateExBar()

            self:initTreasureBox()

            local mainCity = zc.getScene("mainCity")
            mainCity:updateTaskLeadTips(false)
            if taskDb and taskDb.id == GuideTask33Key then
                mainCity:checkShowFuben()
            end 
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_12817 then
                zc.setGuideFuncNextStep(_currentGID)
                self:addGuide()
            end
        end,
    })
end

-- 返回更新
function TaskListPop:updateTaskView()
    zc.sendHttp({
        apiName = "Task_taskList", 
        successCallback = function (data)
            PlayerData:setTaskData(data)
            --同步主城任务tips
            local mainCity = zc.getScene("mainCity")
            if mainCity then
                mainCity:updateTaskLeadTips(false)
            end
            self:updateTableView(self.btn_tag, true)
        end,
    })
end

function TaskListPop:addGuide()
    local _currentGID = getGuideManager():getCurrentGID()
    if inArray(_currentGID, GuideGroup.DUI_HUA) then
        local function _callBack()
            local _currentGID = getGuideManager():getCurrentGID()
            if _currentGID == GuideKey.KEY_OVER then
                local _guideHand = zc.createSpine({
                    fileName = "shou",
                    actName = "shou",
                    scale = 0.6
                })
                _guideHand:setGlobalZOrder(1)
                _guideHand:setPosition(cc.pMul(cc.pFromSize(self._guideTaskGoto:getContentSize()), 0.5))
                self._guideTaskGoto:addChild(_guideHand)
                return
            elseif _currentGID == GuideKey.KEY_12819 then
                getGuideManager():setObjTarget(self._closeBtn)
            else
                getGuideManager():setObjTarget(self._guideTaskGoto)
            end
            getGuideManager():startGuide()
        end
        getGuideManager():setHeroFuncCallBack(_callBack)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_12816 then
        getGuideManager():setObjTarget(self._guideTagBtn, 0.8)
        getGuideManager():startGuide()
    elseif _currentGID == GuideKey.KEY_12817 then
        if self._guideTaskGoto then
            getGuideManager():addMaskLayer()
            performWithDelay(self, function()
                self._myTableView:setTouchEnabled(false)
                getGuideManager():removeMaskLayer()
                getGuideManager():setObjTarget(self._guideTaskGoto, 0.8)
                getGuideManager():startGuide()
            end, 0.3)
        else
            getGuideManager():setCurrentGID(GuideKey.KEY_12818)
            self:addGuide()
        end
    elseif _currentGID == GuideKey.KEY_6021 then
        zc.setGuideFuncNextStep(_currentGID, false)

        local _taskInfo = self.curTaskList[1]
        if not _taskInfo or _taskInfo.status ~= 2 then
            local _currentGID = getGuideManager():getCurrentGID()
            zc.setGuideFuncNextStep(_currentGID, false)
            self:addGuide()
            return
        end
        getGuideManager():setObjTarget(self._guideTaskGoto, 0.8)
        getGuideManager():startGuide()
    end
end

return TaskListPop